import dataclasses
import typing
from _typeshed import Incomplete
from torch.library import get_ctx as get_ctx

__all__ = ['custom_op', 'CustomOp', 'get_ctx']

def custom_op(qualname: str, manual_schema: str | None = None) -> typing.Callable: ...

class CustomOp:
    def __init__(self, lib, cpp_ns, schema, operator_name, ophandle, *, _private_access: bool = False) -> None: ...
    def __call__(self, *args, **kwargs): ...
    def impl(self, device_types: str | typing.Iterable[str], _stacklevel: int = 2) -> typing.Callable: ...
    def impl_factory(self) -> typing.Callable: ...
    def impl_abstract(self, _stacklevel: int = 2) -> typing.Callable: ...
    def impl_save_for_backward(self, _stacklevel: int = 2): ...
    def impl_backward(self, output_differentiability: Incomplete | None = None, _stacklevel: int = 2): ...

@dataclasses.dataclass
class FuncAndLocation:
    func: typing.Callable
    location: str
