from _typeshed import Incomplete
from dataclasses import dataclass, field
from typing import Any, Callable, Generator

@dataclass
class CompilationCallbackHandler:
    start_callbacks: list[Callable[[], None]] = field(default_factory=list)
    end_callbacks: list[Callable[[], None]] = field(default_factory=list)
    def register_start_callback(self, callback: Callable[[], None]) -> Callable[[], None]: ...
    def register_end_callback(self, callback: Callable[[], None]) -> Callable[[], None]: ...
    def remove_start_callback(self, callback: Callable[[], None]) -> None: ...
    def remove_end_callback(self, callback: Callable[[], None]) -> None: ...
    def run_start_callbacks(self) -> None: ...
    def run_end_callbacks(self) -> None: ...
    def install_callbacks(self) -> Generator[None, Any, Any]: ...
    def clear(self) -> None: ...

callback_handler: Incomplete

def on_compile_start(callback: Callable[[], None]) -> Callable[[], None]: ...
def on_compile_end(callback: Callable[[], None]) -> Callable[[], None]: ...
