import torch
from _typeshed import Incomplete
from torch._dynamo.external_utils import FakeCompiledAutogradEngine as FakeCompiledAutogradEngine, call_backward as call_backward, call_hook as call_hook
from torch._dynamo.source import GetItemSource as GetItemSource, LocalSource as LocalSource
from torch._dynamo.utils import counters as counters, lazy_format_graph_code as lazy_format_graph_code, set_locals_to_steal as set_locals_to_steal
from torch._logging import getArtifactLogger as getArtifactLogger, trace_structured as trace_structured
from torch._prims_common import clone_preserve_strides as clone_preserve_strides
from torch._subclasses import FakeTensorMode as FakeTensorMode
from torch.fx import GraphModule as GraphModule
from torch.fx.experimental._backward_state import BackwardState as BackwardState
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, PythonKeyTracer as PythonKeyTracer, decompose as decompose, disable_autocast_cache as disable_autocast_cache, disable_proxy_modes_tracing as disable_proxy_modes_tracing, fetch_object_proxy as fetch_object_proxy, track_tensor_tree as track_tensor_tree
from torch.fx.experimental.symbolic_shapes import DimDynamic as DimDynamic, ShapeEnv as ShapeEnv
from torch.fx.proxy import Proxy as Proxy
from torch.fx.traceback import preserve_node_meta as preserve_node_meta, set_stack_trace as set_stack_trace
from torch.utils._ordered_set import OrderedSet as OrderedSet
from torch.utils._traceback import CapturedTraceback as CapturedTraceback
from typing import Any

compiled_autograd_log: Incomplete
verbose_log: Incomplete

def snapshot_verbose_logging_enabled(): ...
def snapshot_cudagraph_enabled(): ...
def maybe_clone(x): ...

class AutogradCompilerInstance:
    compiler_fn: Incomplete
    stack: Incomplete
    close: Incomplete
    shape_env: Incomplete
    fake_tensor_mode: Incomplete
    fx_tracer: Incomplete
    proxy_mode: Incomplete
    hooks_proxy: Proxy | None
    def __init__(self, compiler_fn) -> None: ...
    def wrap_fake(self, x, source): ...
    @staticmethod
    def source(name, idx) -> GetItemSource: ...
    aot_graph_cls_name: str | None
    aot_graph_infos: dict[int, dict[str, Any]]
    def begin_capture(self, inputs: list[torch.Tensor], sizes: list[int], scalars: list[int | float], origins: list[list[tuple[int, str]]]): ...
    def proxy_call_backward(self, inputs, output_metadatas, saved_tensors, backward_idx: int): ...
    def proxy_call_hook(self, hook, *args, **kwargs): ...
    def tensor_pre_hook(self, inputs, hook_id, i: int): ...
    def pre_hook(self, inputs, hook_id): ...
    def post_hook(self, outputs, inputs, hook_id): ...
    def post_acc_grad_hook(self, input, hook_id): ...
    def move_graph_nodes_to_cuda(self, graph) -> list[int]: ...
    def is_sym_node(self, node): ...
    def dce(self): ...
    def end_capture(self, outputs): ...
    def rename_aot_dispatcher_nodes(self): ...
    @staticmethod
    def get_all_nodes(args): ...
    @staticmethod
    def is_placeholder(node): ...
    def reorder_accumulate_grad_nodes(self) -> None: ...
    def reorder_tensor_pre_hook_nodes(self) -> None: ...
    def reorder_pre_hook_nodes_to_schedule_asap(self) -> None: ...
    def reorder_pre_hook_nodes_to_mimic_eager(self) -> None: ...
    def reorder_post_acc_grad_hook_nodes(self) -> None: ...
    def reorder_post_hook_nodes(self) -> None: ...
    def to_proxy(self, t): ...
    def bind_tensors_to_proxies(self, tensors, proxies, origins: list[tuple[int, str]] | None = None): ...
    def bind_backward_state(self, index: int): ...
    def set_node_origin(self, node_name: str, nodecall_index: int, pyobj: torch.autograd.Function | None): ...

compiled_autograd_enabled: bool
compiled_autograd_enabled_force_eager: bool
in_compiled_autograd_region: bool

def reset() -> None: ...
