import torch
from .exc import unimplemented as unimplemented
from .variables import CellVariable as CellVariable
from .variables.constant import ConstantVariable as ConstantVariable
from .variables.tensor import SymNodeVariable as SymNodeVariable
from _typeshed import Incomplete
from torch.fx.experimental.symbolic_shapes import free_symbols as free_symbols

class ComptimeVar:
    def __init__(self, v) -> None: ...
    def as_proxy(self): ...
    def is_proxy(self): ...
    def as_fake(self): ...
    def size(self, dim: int | None = None) -> int | torch.SymInt: ...
    def python_type(self): ...
    def as_python_constant(self): ...
    def is_python_constant(self): ...
    def is_dynamic(self): ...
    def force_static(self) -> None: ...

class ComptimeContext:
    def __init__(self, tx) -> None: ...
    def get_local(self, name: str, *, stacklevel: int = 0) -> ComptimeVar: ...
    def graph_break(self, msg: str = 'ComptimeContext.graph_break') -> None: ...
    def graph(self): ...
    def assert_static(self, val) -> None: ...
    def print_graph(self, *, verbose: bool = True, file: Incomplete | None = None) -> None: ...
    def parent(self): ...
    def print(self, val, *, file: Incomplete | None = None) -> None: ...
    def print_disas(self, *, file: Incomplete | None = None, stacklevel: int = 0) -> None: ...
    def print_value_stack(self, *, file: Incomplete | None = None, stacklevel: int = 0) -> None: ...
    def print_locals(self, *, file: Incomplete | None = None, stacklevel: int = 0) -> None: ...
    def print_bt(self, *, file: Incomplete | None = None, stacklevel: int = 0) -> None: ...
    def print_guards(self, *, file: Incomplete | None = None) -> None: ...
    def sleep(self, sec) -> None: ...

class _Comptime:
    @staticmethod
    def __call__(fn, fallback_fn=...) -> None: ...
    @staticmethod
    def graph_break(): ...
    @staticmethod
    def print(e): ...
    @staticmethod
    def print_graph(): ...
    @staticmethod
    def print_disas(*, stacklevel: int = 0): ...
    @staticmethod
    def print_value_stack(*, stacklevel: int = 0): ...
    @staticmethod
    def print_value_stack_and_return(e, *, stacklevel: int = 0): ...
    @staticmethod
    def print_locals(*, stacklevel: int = 0): ...
    @staticmethod
    def print_bt(*, stacklevel: int = 0): ...
    @staticmethod
    def print_guards(): ...
    @staticmethod
    def assert_static(val): ...
    @staticmethod
    def force_static(val): ...
    @staticmethod
    def breakpoint() -> None: ...
    @staticmethod
    def sleep(sec): ...

comptime: Incomplete
