from . import config as config
from .utils import clone_inputs as clone_inputs, get_debug_dir as get_debug_dir
from _typeshed import Incomplete
from torch import Tensor as Tensor
from torch._dynamo.testing import rand_strided as rand_strided
from torch._prims_common import is_float_dtype as is_float_dtype
from torch.multiprocessing.reductions import StorageWeakRef as StorageWeakRef
from torch.utils._content_store import ContentStoreReader as ContentStoreReader, ContentStoreWriter as ContentStoreWriter
from typing import Any, Callable, TypeVar

log: Incomplete
T = TypeVar('T')
inductor_config: Incomplete
use_buck: Incomplete
extra_deps: Incomplete
extra_imports: str
cur_target: Incomplete
BUCK_CMD_PREFIX: Incomplete

class BuckTargetWriter:
    target: Incomplete
    path: Incomplete
    cmd_line_path: Incomplete
    def __init__(self, filename) -> None: ...
    def build(self): ...
    def write(self, print_msg: bool = True): ...

def minifier_dir(): ...

MAX_CONSTANT_NUMEL_INLINE: int

class NNModuleToString:
    safe_reprs: Incomplete
    @staticmethod
    def can_convert_to_string(gm): ...
    @staticmethod
    def convert(gm): ...

def generate_config_string(*, stable_output: bool = False): ...
def get_minifier_repro_path(): ...
def helper_for_dump_minify(contents) -> None: ...

class AccuracyError(Exception): ...

def clone_inputs_retaining_gradness(example_inputs): ...
def run_fwd_maybe_bwd(gm, args, only_fwd: bool = False, disable_clone: bool = False): ...
def same_two_models(gm, opt_gm, example_inputs, only_fwd: bool = False, *, require_fp64: bool = False, ignore_non_fp: bool = False): ...
def cast_dtype_args_to_fp64(model): ...
def cast_to(dtype, model, inputs): ...
def cast_to_fp64(model, inputs): ...
def backend_accuracy_fails(gm, example_inputs, compiler_fn, only_fwd: bool = False, *, require_fp64: bool = False, ignore_non_fp: bool = False): ...

class NopInputReader:
    total: int
    def __init__(self) -> None: ...
    def storage(self, storage_hash, nbytes, *, device: Incomplete | None = None, dtype_hint: Incomplete | None = None) -> None: ...
    def tensor(self, *args, **kwargs) -> None: ...
    def symint(self, *args, **kwargs) -> None: ...

class InputReader:
    store: Incomplete
    args: Incomplete
    pbar: Incomplete
    def __init__(self, save_dir: Incomplete | None = None, *, pbar: Incomplete | None = None) -> None: ...
    def storage(self, storage_hash, nbytes, *, device: Incomplete | None = None, dtype_hint: Incomplete | None = None): ...
    def tensor(self, storage, shape, stride: Incomplete | None = None, *, storage_offset: Incomplete | None = None, dtype: Incomplete | None = None, requires_grad: Incomplete | None = None, is_leaf: Incomplete | None = None, **metadata): ...
    def symint(self, val): ...

class InputWriter:
    storage_counter: Incomplete
    save_dir: Incomplete
    store: Incomplete
    seen_storages: Incomplete
    def __init__(self, save_dir, *, stable_hash: bool = False) -> None: ...
    def lines(self): ...
    def storage(self, untyped_storage, *, dtype_hint: Incomplete | None = None, device_hint: Incomplete | None = None) -> str: ...
    def tensor(self, name, t) -> None: ...
    def unsupported(self, name, arg) -> None: ...
    def const(self, name) -> None: ...
    def symint(self, name, val) -> None: ...

def aot_graph_input_parser(func: Callable[[list[Tensor]], list[Tensor]], device: str = 'cuda', sym_shapes: dict[str, int] | None = None, default_sym_shape: int | None = None) -> dict[str, Any]: ...
def profile_to_file(filename: str) -> Callable[[T], T]: ...
