from . import trace_rules as trace_rules, variables as variables
from .comptime import comptime as comptime
from .eval_frame import DisableContext as DisableContext, DynamoStance as DynamoStance, RunOnlyContext as RunOnlyContext, innermost_fn as innermost_fn
from .exc import IncorrectUsage as IncorrectUsage
from .external_utils import is_compiling as is_compiling
from .utils import is_function as is_function
from .variables import VariableTracker as VariableTracker
from _typeshed import Incomplete
from dataclasses import dataclass
from torch._C._dynamo.eval_frame import reset_code as reset_code, set_eval_frame as set_eval_frame, set_guard_error_hook as set_guard_error_hook, skip_code as skip_code, unsupported as unsupported
from torch.utils._contextlib import _DecoratorContextManager
from torch.utils._python_dispatch import is_traceable_wrapper_subclass as is_traceable_wrapper_subclass
from typing import Callable

def run(fn: Incomplete | None = None): ...
def disable(fn: Incomplete | None = None, recursive: bool = True): ...
def skip(fn: Incomplete | None = None): ...

class set_stance(_DecoratorContextManager):
    stance: Incomplete
    prev: Incomplete
    def __init__(self, stance: str = 'default', *, skip_guard_eval_unsafe: bool = False, force_backend: Incomplete | None = None) -> None: ...
    def __call__(self, fn): ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_val: BaseException | None, exc_tb: types.TracebackType | None) -> None: ...
    def clone(self): ...

def assume_constant_result(fn): ...
def allow_in_graph(fn): ...
def disallow_in_graph(fn): ...
def graph_break() -> None: ...
def forbid_in_graph(fn): ...
def substitute_in_graph(original_fn: _F, *, can_constant_fold_through: bool = False, skip_signature_check: bool = False, is_embedded_type: bool = False) -> Callable[[_F], _F]: ...

@dataclass(frozen=True)
class _DimRange:
    dim: int
    min: int
    max: int

def mark_unbacked(t, index) -> None: ...
def mark_dynamic(t, index, *, min: Incomplete | None = None, max: Incomplete | None = None) -> None: ...
def maybe_mark_dynamic(t, index) -> None: ...
def mark_static(t, index: Incomplete | None = None): ...
def mark_static_address(t, guard: bool = True) -> None: ...
