from . import config as config
from .utils import counters as counters
from _typeshed import Incomplete
from enum import Enum
from torch._guards import CompileId as CompileId
from traceback import StackSummary
from typing import Any, NoReturn

def exportdb_error_message(case_name): ...

log: Incomplete
graph_breaks_log: Incomplete

class TorchDynamoException(RuntimeError): ...
class InternalTorchDynamoError(TorchDynamoException): ...

class RestartAnalysis(TorchDynamoException):
    restart_reason: str
    def __init__(self, *args, restart_reason: Incomplete | None = None) -> None: ...

class SpeculationRestartAnalysis(RestartAnalysis): ...
class UnspecializeRestartAnalysis(RestartAnalysis): ...
class CompileCollectiveRestartAnalysis(RestartAnalysis): ...
class TensorifyScalarRestartAnalysis(RestartAnalysis): ...
class SkipFrame(TorchDynamoException): ...
class TorchRuntimeError(TorchDynamoException): ...

class InvalidBackend(TorchDynamoException):
    def __init__(self, name) -> None: ...

class ResetRequired(TorchDynamoException):
    def __init__(self) -> None: ...

class BackendCompilerFailed(TorchDynamoException):
    backend_name: Incomplete
    inner_exception: Incomplete
    def __init__(self, backend_fn, inner_exception) -> None: ...

class Unsupported(TorchDynamoException):
    real_stack: Incomplete
    msg: Incomplete
    category: str | None
    case_name: str | None
    def __init__(self, msg, *, case_name: Incomplete | None = None) -> None: ...
    def remove_from_stats(self) -> None: ...
    def add_to_stats(self, category: str = 'unimplemented') -> None: ...

class RecompileError(TorchDynamoException): ...

class ArgsMismatchError(Unsupported):
    def __init__(self, msg) -> None: ...

class AttributeMutationError(Unsupported):
    def __init__(self, msg) -> None: ...

class CondOpArgsMismatchError(ArgsMismatchError):
    def __init__(self, msg) -> None: ...

class UserErrorType(Enum):
    DYNAMIC_CONTROL_FLOW = ...
    ANTI_PATTERN = ...
    STANDARD_LIBRARY = ...
    CONSTRAINT_VIOLATION = ...
    DYNAMIC_DIM = ...
    INVALID_INPUT = ...
    INVALID_OUTPUT = ...
    UNSUPPORTED_ALIASED_MUTATED_DYNAMIC_INPUTS = ...

class UserError(Unsupported):
    error_type: Incomplete
    message: Incomplete
    def __init__(self, error_type: UserErrorType, msg, case_name: Incomplete | None = None) -> None: ...

class SkipCodeRecursiveException(TorchDynamoException): ...
class RecompileLimitExceeded(Unsupported): ...
class UnsafeScriptObjectError(TorchDynamoException): ...
class UncapturedHigherOrderOpError(TorchDynamoException): ...
class IncorrectUsage(Exception): ...
class FailOnRecompileLimitHit(Exception): ...
class ObservedException(TorchDynamoException): ...

class ObservedUserStopIteration(ObservedException):
    value: Any | None
    def __init__(self, *args, **kwargs) -> None: ...

class ObservedKeyError(ObservedException): ...
class ObservedAttributeError(ObservedException): ...

observed_exception_map: Incomplete

def raise_observed_exception(e, tx) -> None: ...
def handle_observed_exception(tx) -> None: ...

exceptions_allowed_to_be_fallback: Incomplete

def unimplemented_with_warning(e: Exception, code, msg: str) -> NoReturn: ...
def unimplemented(msg: str, *, from_exc: Any = ..., case_name: str | None = None) -> NoReturn: ...
def warning(msg: str) -> None: ...

class KeyErrorMsg:
    value: Incomplete
    def __init__(self, value) -> None: ...

def augment_exc_message(exc: Exception, msg: str = '\n', export: bool = False) -> None: ...
def get_exc_message(e: Exception, compile_id: CompileId) -> tuple[str | None, int | None]: ...
def get_real_stack(exc: Exception, frame: Incomplete | None = None) -> StackSummary | None: ...
def filter_stack(stack): ...
def format_error_msg_verbose(exc: Exception, code, record_filename: Incomplete | None = None, frame: Incomplete | None = None) -> str: ...
def format_error_msg(exc: Exception, code, record_filename: Incomplete | None = None, frame: Incomplete | None = None) -> str: ...
