import pickle
import torch.fx
from .symbolic_convert import InstructionTranslatorBase as InstructionTranslatorBase
from _typeshed import Incomplete
from torch._subclasses.fake_tensor import FakeTensor as FakeTensor
from torch.utils._pytree import tree_flatten as tree_flatten
from typing import Any, Callable, TypeVar

T = TypeVar('T')
Node = torch.fx.Node
Region = list[Node]
IdenticalNodes = list[Node]
GlobalStateKey: Incomplete
log: Incomplete
graph_expansion_log: Incomplete

def debug_log(msg: str, *args) -> None: ...

class NodeHashException(Exception): ...

class InputPickler(pickle.Pickler):
    dispatch_table: Incomplete
    fast: bool
    def __init__(self) -> None: ...
    def dumps(self, obj: Any) -> bytes: ...

def get_global_state_key() -> GlobalStateKey: ...

class BackwardBfsArgIter:
    def __init__(self, origin: Node) -> None: ...
    @staticmethod
    def create(origin: Node) -> BackwardBfsArgIter: ...
    def next(self) -> Node | None: ...
    def peek(self) -> Node | None: ...
    def add_children(self, node: Node) -> None: ...

class GraphRegionTracker:
    hash_to_duplicates: dict[str, IdenticalNodes]
    node_to_duplicates: dict[Node, IdenticalNodes]
    input_pickler: Incomplete
    def __init__(self) -> None: ...
    def track_node(self, tx: InstructionTranslatorBase, node: Node) -> None: ...
    def get_identical_regions(self, graph: torch.fx.Graph) -> list[list[Region]]: ...

def fully_expand_region_group(regions: list[Region], seen_nodes: set[Node], is_identical_fn: Callable[[Node, Node], bool]) -> None: ...
