import ast
import dataclasses
import enum
import types
from . import config as config, convert_frame as convert_frame, exc as exc, mutation_guard as mutation_guard
from .eval_frame import set_guard_error_hook as set_guard_error_hook
from .source import AttrProxySource as AttrProxySource, AttrSource as AttrSource, CallFunctionNoArgsSource as CallFunctionNoArgsSource, ChainedSource as ChainedSource, ConstDictKeySource as ConstDictKeySource, DefaultsSource as DefaultsSource, FSDPNNModuleSource as FSDPNNModuleSource, FlattenScriptObjectSource as FlattenScriptObjectSource, GetItemSource as GetItemSource, GlobalSource as GlobalSource, GlobalStateSource as GlobalStateSource, GlobalWeakRefSource as GlobalWeakRefSource, GradSource as GradSource, LocalSource as LocalSource, NNModuleSource as NNModuleSource, NumpyTensorSource as NumpyTensorSource, ODictGetItemSource as ODictGetItemSource, OptimizerSource as OptimizerSource, ScriptObjectQualifiedNameSource as ScriptObjectQualifiedNameSource, ShapeEnvSource as ShapeEnvSource, SubclassAttrListSource as SubclassAttrListSource, TorchFunctionModeStackSource as TorchFunctionModeStackSource, TupleIteratorGetItemSource as TupleIteratorGetItemSource, TypeSource as TypeSource, UnspecializedBuiltinNNModuleSource as UnspecializedBuiltinNNModuleSource, UnspecializedNNModuleSource as UnspecializedNNModuleSource, UnspecializedParamBufferSource as UnspecializedParamBufferSource, WeakRefCallSource as WeakRefCallSource
from .types import CacheEntry as CacheEntry, DynamoFrameType as DynamoFrameType, ExtraState as ExtraState, GuardFail as GuardFail, GuardFn as GuardFn, GuardedCode as GuardedCode
from .utils import common_constant_types as common_constant_types, dict_keys_repr as dict_keys_repr, get_custom_getattr as get_custom_getattr, get_torch_function_mode_stack as get_torch_function_mode_stack, get_torch_function_mode_stack_at as get_torch_function_mode_stack_at, guard_failures as guard_failures, istype as istype, key_is_id as key_is_id, key_to_id as key_to_id, normalize_range_iter as normalize_range_iter, orig_code_map as orig_code_map, tensor_always_has_static_shape as tensor_always_has_static_shape, tuple_iterator_getitem as tuple_iterator_getitem, tuple_iterator_len as tuple_iterator_len, unpatched_nn_module_getattr as unpatched_nn_module_getattr, verify_guard_fn_signature as verify_guard_fn_signature
from _typeshed import Incomplete
from collections.abc import Generator
from sympy import Symbol as Symbol
from torch._C._dynamo.guards import DictGuardManager as DictGuardManager, RootGuardManager as RootGuardManager, check_obj_id as check_obj_id, check_type_id as check_type_id, dict_version as dict_version, install_no_tensor_aliasing_guard as install_no_tensor_aliasing_guard, install_object_aliasing_guard as install_object_aliasing_guard, install_storage_overlapping_guard as install_storage_overlapping_guard, profile_guard_manager as profile_guard_manager
from torch._dynamo.source import TensorProperty as TensorProperty, TensorPropertySource as TensorPropertySource, is_from_flatten_script_object_source as is_from_flatten_script_object_source, is_from_local_source as is_from_local_source, is_from_optimizer_source as is_from_optimizer_source
from torch._guards import CompileContext as CompileContext, CompileId as CompileId, DuplicateInputs as DuplicateInputs, Guard as Guard, GuardBuilderBase as GuardBuilderBase, GuardEnvExpr as GuardEnvExpr, GuardSource as GuardSource, Source as Source, StorageOverlap as StorageOverlap
from torch._logging import structured as structured
from torch._utils_internal import justknobs_check as justknobs_check
from torch.fx.experimental.symbolic_shapes import EqualityConstraint as EqualityConstraint, SYMPY_INTERP as SYMPY_INTERP, is_symbolic as is_symbolic
from torch.utils._ordered_set import OrderedSet as OrderedSet
from torch.utils._traceback import format_frame as format_frame, report_compile_source_on_error as report_compile_source_on_error
from torch.utils.weak import TensorWeakRef as TensorWeakRef
from typing import Any, Callable
from weakref import ReferenceType

guard_manager_testing_hook_fn: Callable[[Any, Any], Any] | None
log: Incomplete
guards_log: Incomplete
recompiles_log: Incomplete
recompiles_verbose_log: Incomplete
verbose_guards_log: Incomplete

class GuardManagerWrapper:
    root: Incomplete
    diff_guard_root: Incomplete
    closure_vars: Incomplete
    args: Incomplete
    code_parts: Incomplete
    verbose_code_parts: Incomplete
    global_scope: Incomplete
    guard_fail_fn: Incomplete
    cache_entry: Incomplete
    extra_state: Incomplete
    id_matched_objs: Incomplete
    no_tensor_aliasing_sources: Incomplete
    print_no_tensor_aliasing_guard: bool
    diff_guard_sources: OrderedSet[str]
    def __init__(self, root: Incomplete | None = None) -> None: ...
    def collect_diff_guard_sources(self): ...
    def finalize(self) -> None: ...
    def populate_diff_guard_manager(self) -> None: ...
    def clone_with_chosen_sources(self, chosen_sources): ...
    def get_guard_lines(self, guard): ...
    def get_manager_line(self, guard_manager, accessor_str: Incomplete | None = None): ...
    def construct_dict_manager_string(self, mgr, body) -> None: ...
    def construct_manager_string(self, mgr, body) -> None: ...
    def check(self, x): ...
    def check_verbose(self, x): ...
    def populate_code_parts_for_debugging(self): ...

def from_numpy(a): ...
def uninteresting_files(): ...
def strip_function_call(name): ...
def strip_getattr_getitem(name): ...
def get_verbose_code_part(code_part: str, guard: Guard) -> str: ...
def get_verbose_code_parts(code_parts: str | list[str], guard: Guard) -> list[str]: ...
def convert_to_concrete_values(size_or_stride): ...
def get_tensor_guard_code_part(value, name, sizes, strides): ...
def get_key_index(dct, key): ...
def get_key_index_source(source, index): ...

@dataclasses.dataclass(frozen=True)
class NNModuleAttrAccessorInfo:
    present_in_generic_dict: bool = ...
    l1_key: str | None = ...
    l2_key: str | None = ...

def getitem_on_dict_manager(source, base_guard_manager, base_example_value, example_value, guard_manager_enum): ...
def match_on_id_for_tensor(guard): ...

@dataclasses.dataclass
class GuardCodeList:
    code_list: list[str]
    guard: Guard

class GuardManagerType(enum.Enum):
    GUARD_MANAGER = 1
    DICT_GUARD_MANAGER = 2
    DICT_SUBCLASS_GUARD_MANAGER = 3

class GuardBuilder(GuardBuilderBase):
    id_ref: Incomplete
    source_ref: Incomplete
    lookup_weakrefs: Incomplete
    scope: dict[str, dict[str, object]]
    guard_manager: Incomplete
    argnames: list[str]
    code: list[GuardCodeList]
    shape_env_code: list[GuardCodeList]
    no_tensor_aliasing_names: list[str]
    no_tensor_aliasing_guard_managers: list[GuardManagerWrapper]
    check_fn_manager: CheckFunctionManager
    key_order_guarded_dict_ids: Incomplete
    id_matched_objs: dict[str, ReferenceType[object]]
    def __init__(self, id_ref: Callable[[Any, str], str], source_ref: Callable[[Source], str], lookup_weakrefs: Callable[[object], ReferenceType[object]], local_scope: dict[str, object], global_scope: dict[str, object], guard_manager: GuardManagerWrapper, check_fn_manager: CheckFunctionManager) -> None: ...
    def guard_on_dict_keys_and_ignore_order(self, example_value, guard) -> None: ...
    def guard_on_dict_keys_and_order(self, value, guard) -> None: ...
    def getattr_on_nn_module(self, source, base_guard_manager, base_example_value, example_value, base_source_name, source_name, guard_manager_enum): ...
    def requires_key_order_guarding(self, source): ...
    def get_guard_manager_type(self, source, example_value): ...
    def manager_guards_on_keys(self, mgr_enum): ...
    def get_global_guard_manager(self): ...
    def get_guard_manager_from_source(self, source): ...
    def get_guard_manager(self, guard: Guard): ...
    def add_python_lambda_leaf_guard_to_root(self, code_parts, verbose_code_parts, closure_vars: Incomplete | None = None, is_epilogue: bool = True) -> None: ...
    def get(self, name: str) -> Any: ...
    def arg_ref(self, guard: str | Guard) -> str: ...
    def HASATTR(self, guard: Guard): ...
    def NOT_PRESENT_IN_GENERIC_DICT(self, guard: Guard, attr: Incomplete | None = None) -> None: ...
    def TYPE_MATCH(self, guard: Guard) -> None: ...
    def DICT_VERSION(self, guard: Guard): ...
    def DICT_CONTAINS(self, guard: Guard, key: str, invert: bool): ...
    def ID_MATCH(self, guard: Guard): ...
    def NOT_NONE_MATCH(self, guard: Guard, value: Incomplete | None = None): ...
    def NAME_MATCH(self, guard: Guard): ...
    def DATA_PTR_MATCH(self, guard: Guard): ...
    def DUAL_LEVEL(self, guard: Guard): ...
    def FUNCTORCH_STACK_MATCH(self, guard: Guard): ...
    def TENSOR_SUBCLASS_METADATA_MATCH(self, guard: Guard): ...
    def EQUALS_MATCH(self, guard: Guard): ...
    def CONSTANT_MATCH(self, guard: Guard): ...
    def NN_MODULE(self, guard: Guard): ...
    def FUNCTION_MATCH(self, guard: Guard): ...
    def CLOSURE_MATCH(self, guard: Guard): ...
    def BUILTIN_MATCH(self, guard: Guard): ...
    def PYMODULE_MATCH(self, guard: Guard): ...
    def SEQUENCE_LENGTH(self, guard) -> None: ...
    def TUPLE_ITERATOR_LEN(self, guard) -> None: ...
    def RANGE_ITERATOR_MATCH(self, guard) -> None: ...
    def DUPLICATE_INPUT(self, guard, source_b) -> None: ...
    def DICT_KEYS(self, guard) -> None: ...
    def WEAKREF_ALIVE(self, guard) -> None: ...
    def DICT_CONST_KEYS(self, guard) -> None: ...
    def EMPTY_NN_MODULE_HOOKS_DICT(self, guard) -> None: ...
    def OBJECT_MUTATION(self, guard: Guard): ...
    def GRAD_MODE(self, guard: Guard): ...
    def DETERMINISTIC_ALGORITHMS(self, guard: Guard): ...
    def TORCH_FUNCTION_STATE(self, guard: Guard): ...
    def FSDP_TRAINING_STATE(self, guard: Guard): ...
    def DEFAULT_DEVICE(self, guard: Guard): ...
    def SHAPE_ENV(self, guard: Guard): ...
    def TENSOR_MATCH(self, guard: Guard, value: Incomplete | None = None): ...

class PyExprCSEPass:
    USE_THRESHOLD: int
    ALLOWED_NODE_TYPES: Incomplete
    @dataclasses.dataclass
    class Config:
        expr_count: dict[str, int]
        expr_to_name: dict[str, str]
    class ExprCounter(ast.NodeVisitor):
        def __init__(self, config: PyExprCSEPass.Config) -> None: ...
        def visit(self, node: ast.AST) -> Any: ...
    class Replacer(ast.NodeTransformer):
        preface: list[str]
        def __init__(self, config: PyExprCSEPass.Config, gen_name: Callable[[], str]) -> None: ...
        def visit(self, node: ast.AST) -> Any: ...
    def __init__(self) -> None: ...
    def count(self, exprs: list[str]) -> None: ...
    def replace(self, expr: str) -> tuple[list[str], str]: ...

def must_add_nn_module_guards(guard): ...

class DeletedGuardManagerWrapper(GuardManagerWrapper):
    invalidation_reason: Incomplete
    def __init__(self, reason) -> None: ...
    diff_guard_root: Incomplete
    def populate_diff_guard_manager(self) -> None: ...

class CheckFunctionManager:
    guard_manager: Incomplete
    output_graph: Incomplete
    torch_function_mode_stack: Incomplete
    def __init__(self, output_graph: Incomplete | None = None, cache_entry: Incomplete | None = None, guard_fail_fn: Callable[[GuardFail], None] | None = None) -> None: ...
    def compile_check_fn(self, builder, guards_out, guard_fail_fn): ...
    def invalidate(self, obj_str) -> None: ...
    def id_ref(self, obj, obj_str): ...
    def lookup_weakrefs(self, obj): ...

def build_guard_function(code_parts, closure_args) -> tuple[str, str]: ...
def is_recompiles_enabled(): ...
def is_recompiles_verbose_enabled(): ...
def make_torch_function_mode_stack_guard(intial_stack): ...
def recompilation_reason_for_no_tensor_aliasing_guard(guard_manager, scope): ...
def get_guard_fail_reason_helper(guard_manager: GuardFn, f_locals: dict[str, object], compile_id: CompileId) -> str: ...
def get_guard_fail_reason(guard_manager: GuardFn, code: types.CodeType, f_locals: dict[str, object], compile_id: CompileId) -> str: ...
def get_and_maybe_log_recompilation_reason(cache_entry, frame: DynamoFrameType) -> list[str]: ...
def update_diff_guard_managers_for_existing_cache_entries(cache_entry): ...
def guard_error_hook(guard_manager: GuardFn, code: types.CodeType, f_locals: dict[str, object], index: int, last: bool): ...
def unique(seq) -> Generator[Incomplete]: ...
def make_dupe_guard(obj_source, dupe_source): ...
def install_guard(*guards, skip: int = 0) -> None: ...
