from typing import Any
from typing_extensions import TypeAlias

OnExitType: TypeAlias

class MetricsContext:
    def __init__(self, on_exit: OnExitType) -> None: ...
    def __enter__(self) -> MetricsContext: ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_value: BaseException | None, _traceback: Any) -> None: ...
    def in_progress(self) -> bool: ...
    def increment(self, metric: str, value: int) -> None: ...
    def set(self, metric: str, value: Any) -> None: ...
    def set_key_value(self, metric: str, key: str, value: Any) -> None: ...
    def update(self, values: dict[str, Any]) -> None: ...
    def update_outer(self, values: dict[str, Any]) -> None: ...
    def add_to_set(self, metric: str, value: Any) -> None: ...
