import dataclasses
import enum
import types
from _typeshed import Incomplete
from torch._dynamo.symbolic_convert import InstructionTranslator as InstructionTranslator
from torch._dynamo.utils import dynamo_timed as dynamo_timed, get_chromium_event_logger as get_chromium_event_logger, warn_once as warn_once
from torch._environment import is_fbcode as is_fbcode
from torch._inductor.remote_cache import JsonDataTy as JsonDataTy, RemoteCache as RemoteCache
from torch._logging._internal import trace_structured_artifact as trace_structured_artifact
from typing import DefaultDict
from typing_extensions import Self

class ReservedWorkflowIdUserError(ValueError): ...

log: Incomplete
LOCK_TIMEOUT: int

@dataclasses.dataclass(frozen=True)
class CodeId:
    filename: str
    firstlineno: int
    name: str
    @staticmethod
    def make(code: types.CodeType) -> CodeId: ...

@dataclasses.dataclass
class CodeState:
    automatic_dynamic: DefaultDict[str, FrameStateSizeEntry] = dataclasses.field(default_factory=Incomplete)

@dataclasses.dataclass(frozen=True)
class InferStride:
    dim: int

class AutoUnset(enum.Enum):
    token = 0

auto_unset: Incomplete

class AutoDynamic(enum.Enum):
    token = 0

auto_dynamic: Incomplete

@dataclasses.dataclass
class FrameStateSizeEntry:
    scalar: int | AutoDynamic | AutoUnset = dataclasses.field(default=auto_unset)
    size: AutoDynamic | AutoUnset | tuple[int | AutoDynamic, ...] = dataclasses.field(default=auto_unset)
    stride: AutoDynamic | AutoUnset | tuple[int | AutoDynamic | InferStride, ...] = dataclasses.field(default=auto_unset)
    def render(self) -> str: ...
    def __post_init__(self) -> None: ...
    def is_size_dynamic(self, dim: int) -> bool: ...
    def is_stride_dynamic(self, dim: int) -> bool: ...
    @classmethod
    def make_scalar(cls, x: int) -> FrameStateSizeEntry: ...
    @classmethod
    def make_tensor(cls, size: tuple[int, ...], stride: tuple[int, ...]) -> FrameStateSizeEntry: ...
    @classmethod
    def make_size(cls, size: tuple[int, ...]) -> FrameStateSizeEntry: ...
    def __ior__(self, other: Self) -> Self: ...

def update_automatic_dynamic(tx: InstructionTranslator, name: str, entry: FrameStateSizeEntry, *, is_unspecialized_nn_module: bool = False) -> FrameStateSizeEntry: ...
def process_automatic_dynamic(tx: InstructionTranslator, name: str, entry: FrameStateSizeEntry, *, is_unspecialized_nn_module: bool = False) -> FrameStateSizeEntry: ...
def get_cache_key() -> str | None: ...
def code_state_path(cache_key: str) -> str | None: ...
def should_use_remote_dynamo_pgo_cache() -> bool: ...
def get_remote_cache() -> RemoteCache[JsonDataTy] | None: ...
def render_code_state(cs: DefaultDict[CodeId, CodeState]) -> str: ...
def get_code_state() -> DefaultDict[CodeId, CodeState]: ...
def put_code_state() -> None: ...
def put_local_code_state(cache_key: str) -> None: ...
def put_remote_code_state(cache_key: str) -> None: ...
def reset_code_state() -> None: ...
