import dataclasses
import types
from .bytecode_transformation import Instruction as Instruction, bytecode_from_template as bytecode_from_template, create_call_function as create_call_function, create_instruction as create_instruction, create_jump_absolute as create_jump_absolute, create_load_const as create_load_const, overwrite_instruction as overwrite_instruction, transform_code_object as transform_code_object, unique_id as unique_id
from .utils import ExactWeakKeyDictionary as ExactWeakKeyDictionary
from _typeshed import Incomplete
from typing import Any

CO_OPTIMIZED: int
CO_NEWLOCALS: int
CO_VARARGS: int
CO_VARKEYWORDS: int
CO_NESTED: int
CO_GENERATOR: int
CO_NOFREE: int
CO_COROUTINE: int
CO_ITERABLE_COROUTINE: int
CO_ASYNC_GENERATOR: int
TORCH_DYNAMO_RESUME_IN_PREFIX: str

@dataclasses.dataclass(frozen=True)
class ReenterWith:
    stack_index: int
    target_values: tuple[Any, ...] | None = ...
    def try_except_torch_function_mode(self, code_options, cleanup: list[Instruction]): ...
    def try_finally(self, code_options, cleanup: list[Instruction]): ...
    def __call__(self, code_options, cleanup): ...

@dataclasses.dataclass
class ResumeFunctionMetadata:
    code: types.CodeType
    instructions: list[Instruction] = dataclasses.field(default_factory=list)
    prefix_block_target_offset_remap: list[int] = dataclasses.field(default_factory=list)
    block_target_offset_remap: dict[int, int] | None = ...

class ContinueExecutionCache:
    cache: Incomplete
    generated_code_metadata: Incomplete
    @classmethod
    def lookup(cls, code, lineno, *key): ...
    @classmethod
    def generate(cls, code, lineno, offset: int, setup_fn_target_offsets: tuple[int, ...], nstack: int, argnames: tuple[str, ...], argnames_null: tuple[str, ...], setup_fns: tuple[ReenterWith, ...], stack_ctx_vars: tuple[tuple[int, tuple[Any]], ...], argnames_ctx_vars: tuple[tuple[str, tuple[Any]], ...], null_idxes: tuple[int, ...]) -> types.CodeType: ...
    @staticmethod
    def unreachable_codes(code_options) -> list[Instruction]: ...
    @classmethod
    def generate_based_on_original_code_object(cls, code, lineno, offset: int, setup_fn_target_offsets: tuple[int, ...], *args): ...
