import dataclasses
import types
from .resume_execution import TORCH_DYNAMO_RESUME_IN_PREFIX as TORCH_DYNAMO_RESUME_IN_PREFIX
from .utils import NP_SUPPORTED_MODULES as NP_SUPPORTED_MODULES, getfile as getfile, hashable as hashable, unwrap_if_wrapper as unwrap_if_wrapper
from .variables import BuiltinVariable as BuiltinVariable, FunctionalCallVariable as FunctionalCallVariable, FunctorchHigherOrderVariable as FunctorchHigherOrderVariable, NestedUserFunctionVariable as NestedUserFunctionVariable, PolyfilledFunctionVariable as PolyfilledFunctionVariable, SkipFunctionVariable as SkipFunctionVariable, TorchInGraphFunctionVariable as TorchInGraphFunctionVariable, UserFunctionVariable as UserFunctionVariable, UserMethodVariable as UserMethodVariable
from .variables.base import VariableTracker as VariableTracker
from _typeshed import Incomplete
from typing import Any, Callable

np: types.ModuleType | None
manual_torch_name_rule_map: Incomplete
torch_c_binding_in_graph_functions: Incomplete
torch_non_c_binding_in_graph_functions: Incomplete
torch_name_rule_map: Incomplete

def get_torch_obj_rule_map() -> dict[Any, type['VariableTracker']]: ...
def load_object(name): ...
def get_tensor_method(): ...
def is_aten_op_or_tensor_method(obj): ...

class FunctionIdSet:
    function_ids: set[int] | None
    function_names: dict[int, str] | None
    lazy_initializer: Incomplete
    def __init__(self, lazy_initializer: Callable[[], dict[int, str] | set[int]]) -> None: ...
    def __call__(self) -> set[int]: ...
    def get_name(self, idx: int, default: str): ...
    def add(self, idx: int): ...
    def remove(self, idx: int): ...
    def __contains__(self, idx: int) -> bool: ...

def add_module_init_func(name: str, init_func: Callable[[], None]) -> None: ...
def is_callable_allowed(obj) -> bool: ...
def is_callable_disallowed(obj) -> bool: ...
def is_forbidden(obj) -> bool: ...
def is_builtin_callable(obj) -> bool: ...
def is_builtin_constant(obj) -> bool: ...
def is_polyfilled_callable(obj) -> bool: ...
def is_numpy(obj) -> bool: ...
def is_numpy_dtype(obj) -> bool: ...
def is_numpy_type_info(obj) -> bool: ...

BUILTIN_SKIPLIST: Incomplete
THIRDPARTY_SKIPLIST: Incomplete
LEGACY_MOD_INLINELIST: Incomplete
MOD_INLINELIST: Incomplete

def get_legacy_mod_inlinelist(): ...
def get_mod_inlinelist(): ...

SKIP_DIRS: Incomplete
SKIP_DIRS_RE: Incomplete
is_fbcode: Incomplete
FBCODE_SKIP_DIRS: set[str]
FBCODE_SKIP_DIRS_RE: Incomplete
FBCODE_SKIP_TORCHREC_DIRS: Incomplete
FBCODE_SKIP_TORCHREC_DIRS_RE: Incomplete
FBCODE_INLINE_FILES_IN_SKIPPED_DIRS: Incomplete
FBCODE_INLINE_FILES_IN_SKIPPED_DIRS_RE: Incomplete
FORCE_SKIP_FILES: Incomplete

def add(import_name: str): ...

@dataclasses.dataclass
class SkipResult:
    skipped: bool
    reason: str | None

def check_file(filename, is_inlined_call: bool = False): ...

@dataclasses.dataclass
class FunctionInfo:
    py_obj: object | None
    name: str | None
    filename: str
    code: types.CodeType | None

def check_verbose(obj, is_inlined_call: bool = False): ...
def check(obj, is_inlined_call: bool = False): ...
def is_torch_inline_allowed(filename): ...
def dynamo_dir(): ...
def is_torch(filename): ...
def lookup_callable(obj): ...
def lookup(obj): ...
def lookup_inner(obj, name: Incomplete | None = None, filename: Incomplete | None = None, is_direct_call: bool = True, reasons: None | set[str] = None): ...
def clear_lru_cache() -> None: ...
