import torch
import torch.nn as nn
from _typeshed import Incomplete
from torch import Tensor as Tensor
from torch.nn.utils._named_member_accessor import NamedMemberAccessor as NamedMemberAccessor
from typing import Any, Iterable, NoReturn, Sequence

def raise_parameter_tying_error() -> NoReturn: ...
def create_names_map(named_params: dict[str, Tensor] | Iterable[tuple[str, Tensor]], tied_named_params: dict[str, Tensor] | Iterable[tuple[str, Tensor]]) -> dict[str, list[str]]: ...
def extract_weights(mod: nn.Module) -> tuple[tuple[Tensor, ...], tuple[str, ...], dict[str, list[str]]]: ...
def extract_buffers(mod: nn.Module) -> tuple[tuple[Tensor, ...], tuple[str, ...], dict[str, list[str]]]: ...
def load_weights(mod: nn.Module, names: Sequence[str], params: Sequence[Tensor], as_params: bool = False) -> None: ...
def load_buffers(mod: nn.Module, names: Sequence[str], buffers: Sequence[Tensor], as_params: bool = False) -> None: ...
def load_state(model: nn.Module, weights: Sequence[Tensor], weight_names: Sequence[str], buffers: Sequence[Tensor] = (), buffer_names: Sequence[str] = ()) -> nn.Module: ...
def make_functional_deprecated_v1(model: nn.Module): ...
def make_functional_with_buffers_deprecated_v1(model: nn.Module): ...

class FunctionalModuleWithBuffers(nn.Module):
    stateless_model: Incomplete
    param_names: Incomplete
    buffer_names: Incomplete
    all_names_map: Incomplete
    def __init__(self, stateless_model: nn.Module, param_names: tuple[str, ...], buffer_names: tuple[str, ...], param_names_map: dict[str, list[str]], buffer_names_map: dict[str, list[str]]) -> None: ...
    def forward(self, params: Iterable[Tensor], buffers: Iterable[Tensor], *args, **kwargs) -> Any: ...

class FunctionalModule(nn.Module):
    stateless_model: Incomplete
    param_names: Incomplete
    names_map: Incomplete
    def __init__(self, stateless_model: nn.Module, param_names: tuple[str, ...], names_map: dict[str, list[str]]) -> None: ...
    def forward(self, params: Iterable[Tensor], *args, **kwargs) -> Any: ...

def make_functional(model: nn.Module, disable_autograd_tracking: bool = False) -> tuple[FunctionalModule, tuple[Tensor, ...]]: ...
def make_functional_with_buffers(model: nn.Module, disable_autograd_tracking: bool = False) -> tuple[FunctionalModuleWithBuffers, tuple[Tensor, ...], tuple[Tensor, ...]]: ...
def transpose_stack(tuple_of_tuple_of_tensors: tuple[tuple[Tensor, ...], ...]) -> tuple[Tensor, ...]: ...
def combine_state_for_ensemble(models: Sequence[nn.Module]) -> tuple[FunctionalModuleWithBuffers, tuple[Tensor, ...], tuple[Tensor, ...]]: ...
def functional_init(model_class: type[nn.Module], ensemble_shape: tuple[()] | tuple[int] = (), device: torch.types.Device = 'cpu'): ...
def functional_init_with_buffers(model_class: type[nn.Module], ensemble_shape: tuple[()] | tuple[int] = (), device: torch.types.Device = 'cpu'): ...
