import torch
from _typeshed import Incomplete
from enum import Enum
from torch._C import DispatchKey as DispatchKey
from torch._higher_order_ops.torchbind import call_torchbind as call_torchbind
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses.fake_tensor import FakeTensorMode as FakeTensorMode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, disable_proxy_modes_tracing as disable_proxy_modes_tracing, track_tensor_tree as track_tensor_tree
from typing import Any
from weakref import WeakKeyDictionary

class _EffectType(Enum):
    ORDERED = 'Ordered'

OpType: Incomplete
SIDE_EFFECTS: WeakKeyDictionary[OpType, _EffectType]

class WithEffects(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, token, op: OpType, *args: tuple[Any, ...], **kwargs: dict[str, Any]) -> tuple[Any, ...]: ...

with_effects: Incomplete

def has_aliasing(op: OpType): ...
def has_effects(op, args, kwargs) -> bool: ...
def get_effect_key(op, args, kwargs) -> _EffectType | None: ...
def new_token_tensor() -> torch.Tensor: ...
def with_effects_dense(token: torch.Tensor, op: torch._ops.OpOverload, *args: tuple[Any, ...], **kwargs: dict[str, Any]) -> tuple[torch.Tensor, ...]: ...
def with_effects_fake(mode, token: torch.Tensor, op: torch._ops.OpOverload, *args: tuple[Any, ...], **kwargs: dict[str, Any]) -> tuple[torch.Tensor, ...]: ...
def with_effects_proxy(mode, token: torch.Tensor, op: torch._ops.OpOverload, *args: tuple[Any, ...], **kwargs: dict[str, Any]) -> tuple[torch.Tensor, ...]: ...
def handle_effects(allow_token_discovery: bool, tokens: dict[_EffectType, torch.Tensor], op: OpType, args: tuple[Any, ...], kwargs: dict[str, Any]) -> Any: ...
