import torch
from dataclasses import dataclass
from torch._ops import OperatorBase as OperatorBase
from torch.fx.experimental.proxy_tensor import make_fx as make_fx
from torch.fx.passes.shape_prop import TensorMetadata as TensorMetadata
from torch.multiprocessing.reductions import StorageWeakRef as StorageWeakRef
from typing import Any, Callable

@dataclass
class UnsupportedAliasMutationException(RuntimeError):
    reason: str

def autograd_not_implemented_inner(operator: OperatorBase, delayed_error: bool, *args: Any, **kwargs: Any) -> Any: ...
def autograd_not_implemented(op: OperatorBase, deferred_error: bool) -> Callable: ...
def reenter_make_fx(fn): ...
def has_potential_input_alias_or_mutation(gm, inputs, pre_dispatch: bool = False): ...
def unique_graph_id(proxy_mode, prefix): ...
def clone_outputs_aliasing_inputs(args): ...
def prepare_fw_with_masks(fn): ...
def create_fw_bw_graph(fn, use_output_and_grad_bw, fw_inputs, fw_outputs): ...
def save_tensors_and_symints_for_backward(ctx, args) -> None: ...
def saved_tensors_and_symints(ctx): ...
def get_dummy_aot_autograd_config(): ...
def first_slice_copy(t: torch.Tensor, dim: int = 0) -> torch.Tensor: ...
def diff_tensor_meta(meta1: TensorMetadata, meta2: TensorMetadata, check_grad: bool = True) -> list[str]: ...
def validate_subgraph_args_types(lifted_args: tuple[Any, ...] | list[Any]): ...
