from . import ir as ir
from .utils import get_dtype_size as get_dtype_size, sympy_product as sympy_product
from .virtualized import V as V
from _typeshed import Incomplete
from enum import IntEnum

class NCCL_COLL(IntEnum):
    ALL_REDUCE = 0
    ALL_GATHER = 1
    REDUCE_SCATTER = 2

class NVIDIA_GPU_TYPE(IntEnum):
    VOLTA = 0
    AMPERE = 1
    HOPPER = 2

def get_gpu_type() -> NVIDIA_GPU_TYPE: ...
def get_collective_type(node: ir.IRNode) -> NCCL_COLL: ...
def get_collective_input_size_bytes(node: ir.IRNode) -> int: ...
def get_collective_group_size(node: ir.IRNode) -> int: ...

class NCCL_HW(IntEnum):
    NVLINK = 0
    PCI = 1
    NET = 2

class NCCL_ALGO(IntEnum):
    TREE = 0
    RING = 1

class NCCL_PROTO(IntEnum):
    LL = 0

baseLat: Incomplete
hwLat: Incomplete
llMaxBws: Incomplete

def estimate_nccl_collective_runtime(node: ir.IRNode) -> float: ...
