from _typeshed import Incomplete
from torch._dynamo.utils import dynamo_timed as dynamo_timed
from torch._inductor import config as config, exc as exc
from torch._inductor.cpu_vec_isa import VecISA as VecISA, invalid_vec_isa as invalid_vec_isa
from torch._inductor.fb.utils import log_global_cache_errors as log_global_cache_errors, log_global_cache_stats as log_global_cache_stats, log_global_cache_vals as log_global_cache_vals, use_global_cache as use_global_cache
from torch._inductor.runtime.runtime_utils import cache_dir as cache_dir
from torch.torch_version import TorchVersion as TorchVersion
from typing import Sequence

SUBPROCESS_DECODE_ARGS: Incomplete
log: Incomplete

def cpp_compiler_search(search: str) -> str: ...
def install_gcc_via_conda() -> str: ...
def check_compiler_exist_windows(compiler: str) -> None: ...
def get_cpp_compiler() -> str: ...
def is_gcc() -> bool: ...
def is_clang() -> bool: ...
def is_intel_compiler() -> bool: ...
def is_apple_clang() -> bool: ...
def is_msvc_cl() -> bool: ...
def get_compiler_version_info(compiler: str) -> str: ...
def run_compile_cmd(cmd_line: str, cwd: str) -> bytes: ...
def normalize_path_separator(orig_path: str) -> str: ...

class BuildOptionsBase:
    def __init__(self, compiler: str = '', definitions: list[str] | None = None, include_dirs: list[str] | None = None, cflags: list[str] | None = None, ldflags: list[str] | None = None, libraries_dirs: list[str] | None = None, libraries: list[str] | None = None, passthrough_args: list[str] | None = None, aot_mode: bool = False, use_absolute_path: bool = False, compile_only: bool = False) -> None: ...
    def get_compiler(self) -> str: ...
    def get_definations(self) -> list[str]: ...
    def get_include_dirs(self) -> list[str]: ...
    def get_cflags(self) -> list[str]: ...
    def get_ldflags(self) -> list[str]: ...
    def get_libraries_dirs(self) -> list[str]: ...
    def get_libraries(self) -> list[str]: ...
    def get_passthough_args(self) -> list[str]: ...
    def get_aot_mode(self) -> bool: ...
    def get_use_absolute_path(self) -> bool: ...
    def get_compile_only(self) -> bool: ...
    def save_flags_to_file(self, file: str) -> None: ...

def get_cpp_options(cpp_compiler: str, compile_only: bool, warning_all: bool = True, extra_flags: Sequence[str] = ()) -> tuple[list[str], list[str], list[str], list[str], list[str], list[str], list[str]]: ...

class CppOptions(BuildOptionsBase):
    def __init__(self, compile_only: bool = False, warning_all: bool = True, extra_flags: Sequence[str] = (), use_absolute_path: bool = False, compiler: str = '') -> None: ...

def is_conda_llvm_openmp_installed() -> bool: ...
def homebrew_libomp() -> tuple[bool, str]: ...
def perload_clang_libomp_win(cpp_compiler: str, omp_name: str) -> None: ...
def perload_icx_libomp_win(cpp_compiler: str) -> None: ...
def get_mmap_self_macro(use_mmap_weights: bool) -> list[str]: ...
def get_cpp_torch_options(cpp_compiler: str, vec_isa: VecISA, include_pytorch: bool, aot_mode: bool, compile_only: bool, use_absolute_path: bool, use_mmap_weights: bool) -> tuple[list[str], list[str], list[str], list[str], list[str], list[str], list[str]]: ...

class CppTorchOptions(CppOptions):
    def __init__(self, vec_isa: VecISA = ..., include_pytorch: bool = False, warning_all: bool = True, aot_mode: bool = False, compile_only: bool = False, use_absolute_path: bool = False, use_mmap_weights: bool = False, shared: bool = True, extra_flags: Sequence[str] = (), compiler: str = '') -> None: ...

def get_cpp_torch_device_options(device_type: str, aot_mode: bool = False, compile_only: bool = False) -> tuple[list[str], list[str], list[str], list[str], list[str], list[str], list[str]]: ...

class CppTorchDeviceOptions(CppTorchOptions):
    def __init__(self, vec_isa: VecISA = ..., include_pytorch: bool = False, device_type: str = 'cuda', aot_mode: bool = False, compile_only: bool = False, use_absolute_path: bool = False, use_mmap_weights: bool = False, shared: bool = True, extra_flags: Sequence[str] = ()) -> None: ...

def get_name_and_dir_from_output_file_path(file_path: str) -> tuple[str, str]: ...

class CppBuilder:
    def __init__(self, name: str, sources: str | list[str], BuildOption: BuildOptionsBase, output_dir: str = '') -> None: ...
    def get_command_line(self) -> str: ...
    def get_target_file_path(self) -> str: ...
    def build(self) -> tuple[bytes, str]: ...
