import dataclasses
import torch
from _typeshed import Incomplete
from torch._inductor import config as config
from typing import Any, Callable

class VecISA:
    def bit_width(self) -> int: ...
    def nelements(self, dtype: torch.dtype = ...) -> int: ...
    def build_macro(self) -> list[str]: ...
    def build_arch_flags(self) -> str: ...
    def __hash__(self) -> int: ...
    def check_build(self, code: str) -> bool: ...
    def __bool__(self) -> bool: ...

@dataclasses.dataclass
class VecNEON(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

@dataclasses.dataclass
class VecSVE(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

@dataclasses.dataclass
class VecAVX512(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

@dataclasses.dataclass
class VecAMX(VecAVX512):
    __hash__: Callable[[VecISA], Any] = ...
    def __bool__(self) -> bool: ...

@dataclasses.dataclass
class VecAVX2(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

@dataclasses.dataclass
class VecZVECTOR(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

@dataclasses.dataclass
class VecVSX(VecISA):
    __hash__: Callable[[VecISA], Any] = ...

class InvalidVecISA(VecISA):
    def __bool__(self) -> bool: ...
    __hash__: Callable[[VecISA], Any]

def x86_isa_checker() -> list[str]: ...

invalid_vec_isa: Incomplete
supported_vec_isa_list: Incomplete

def get_isa_from_cpu_capability(capability: str | None, vec_isa_list: list[VecISA], invalid_vec_isa: InvalidVecISA): ...
def valid_vec_isa_list() -> list[VecISA]: ...
def pick_vec_isa() -> VecISA: ...
