import dataclasses
import torch
from . import config as config
from _typeshed import Incomplete
from enum import Enum
from torch import Tensor as Tensor
from torch._C import _cuda_CUDAAllocator_AllocatorState as AllocatorState
from torch._dynamo.mutation_guard import GenerationTracker as GenerationTracker
from torch._dynamo.utils import counters as counters, dynamo_timed as dynamo_timed, preserve_rng_state as preserve_rng_state
from torch._inductor.compile_fx import align_inputs_from_check_idxs as align_inputs_from_check_idxs, copy_misaligned_inputs as copy_misaligned_inputs, get_expanded_dims as get_expanded_dims, get_input_idxs_to_check as get_input_idxs_to_check, index_expanded_dims as index_expanded_dims, remove_unaligned_input_idxs as remove_unaligned_input_idxs, static_input as static_input
from torch._inductor.cudagraph_utils import CheckInvariantStatus as CheckInvariantStatus, FunctionID as FunctionID, ModelType as ModelType, OutputType as OutputType, PlaceholderInfo as PlaceholderInfo, WrappedFunction as WrappedFunction, check_for_mutation as check_for_mutation, log_cudagraph_skip_and_bump_counter as log_cudagraph_skip_and_bump_counter, log_data_ptr_mismatch as log_data_ptr_mismatch, maybe_warning_due_to_dynamic_shape as maybe_warning_due_to_dynamic_shape
from torch._inductor.utils import InputType as InputType
from torch.multiprocessing.reductions import StorageWeakRef as StorageWeakRef
from torch.storage import UntypedStorage as UntypedStorage
from torch.utils.weak import TensorWeakRef as TensorWeakRef
from typing import Any, Callable, ContextManager, Generator, Iterator, Sequence, TypeVar

StorageWeakRefPointer = int
StorageDataPtr = int
NBytes = int
S = TypeVar('S', bound='StorageWeakRefWrapper')

class AllocatorState: ...

log: Incomplete

@dataclasses.dataclass(frozen=True)
class GraphID:
    id: int

def clear_cublass_cache() -> None: ...
def clear_cublas_manager() -> Generator[None, None, None]: ...
def disable_conv_cache_emptying() -> Generator[None, None, None]: ...
def enable_history_recording() -> Generator[None, None, None]: ...
def get_history_recording() -> ContextManager[None]: ...

class TreeManagerContainer:
    tree_manager: CUDAGraphTreeManager | None
    live_cudagraphify_fns: int
    device_index: Incomplete
    live_storages_count: int
    graph: torch.cuda.CUDAGraph | None
    lock: Incomplete
    def __init__(self, device_index: int) -> None: ...
    def finalize_cudagraphify_fn(self) -> None: ...
    def add_strong_reference(self, fn: Callable[..., Any]) -> None: ...
    def get_tree_manager(self) -> CUDAGraphTreeManager: ...

local: Incomplete

class MarkStepBox:
    mark_step_counter: int

def mark_step_begin() -> None: ...
def reset_cudagraph_trees() -> None: ...
def get_obj(local: Any, attr_name: str) -> Any: ...
def get_container(device_index: int) -> TreeManagerContainer: ...
def get_manager(device_index: int, create_if_none_exists: bool = True) -> CUDAGraphTreeManager | None: ...
def cudagraphify_impl(model: ModelType, inputs: list[InputType], static_input_idxs: Sequence[int], *args: Any, **kwargs: Any) -> ModelType: ...
def cudagraphify(model: ModelType, inputs: list[InputType], static_input_idxs: Sequence[int] = (), *, device_index: int, is_backward: bool, is_inference: bool, stack_traces: StackTraces | None = None, constants: tuple[torch.Tensor, ...] = (), placeholders: tuple[PlaceholderInfo, ...] = (), mutated_input_idxs: tuple[int, ...] = ()) -> tuple[ModelType, OutputType]: ...

class StorageWeakRefWrapper:
    storage_ref: StorageWeakRef | None
    ref: Incomplete
    extra_ref_check: Incomplete
    def __init__(self, inp: Tensor | UntypedStorage, extra_ref_check: Callable[[], bool] | None = None) -> None: ...
    @classmethod
    def from_weakref_and_data_ptr(cls, cdata: Any, data_ptr: int, extra_ref_check: Callable[[], bool] | None = None) -> StorageWeakRefWrapper: ...
    def __call__(self) -> StorageWeakRefPointer | None: ...
    def swap_weakref(self, cdata: Any) -> None: ...
    def data_ptr(self) -> int: ...
    def remove_extra_reference(self) -> None: ...
    def expired(self) -> bool: ...

def is_live(weak_ref: StorageWeakRefWrapper | None) -> bool: ...
def maybe_deref(weak_ref: StorageWeakRefWrapper | None) -> tuple[StorageWeakRefPointer, int] | None: ...
def map_to_ref(t: Tensor | None) -> StorageWeakRefWrapper | None: ...
PathOutputIndex = tuple[int, int]
PathLiveness = list[list[bool]]
StackTraces = list[str | None]

class CUDAWarmupNode:
    wrapped_function: Incomplete
    parent: CUDAGraphNode | CUDAWarmupNode | None
    cuda_graphs_pool: Incomplete
    outputs_weakrefs: list[StorageWeakRefWrapper | None]
    tensor_weakrefs: list[TensorWeakRef | None]
    existing_cuda_graph: Incomplete
    has_run: bool
    device_index: Incomplete
    stack_traces: Incomplete
    stream: Incomplete
    already_warm: Incomplete
    id: Incomplete
    def __init__(self, wrapped_function: WrappedFunction, parent: CUDAGraphNode | CUDAWarmupNode | None, cuda_graphs_pool: tuple[int, int], existing_cuda_graph: torch.cuda.CUDAGraph | None, device_index: int, stack_traces: StackTraces | None, stream: torch.cuda.Stream, already_warm: bool, id: GraphID) -> None: ...
    def run(self, new_inputs: Any) -> OutputType: ...
    def path_live_weakrefs(self) -> Iterator[StorageWeakRefWrapper]: ...
    def all_outputs_are_dead(self) -> bool: ...
InputList = list
OutputList = list
LevelList = list

class OutputAliasInfo: ...
class _UnaliasedStorage(OutputAliasInfo): ...

UnaliasedStorage: Incomplete

class AliasesPriorGraphOutput(OutputAliasInfo):
    index: PathOutputIndex
    def __init__(self, index: PathOutputIndex) -> None: ...

class AliasesNewOutput(OutputAliasInfo):
    index: int
    def __init__(self, index: int) -> None: ...

class CUDAGraphNode:
    wrapped_function: Incomplete
    id: Incomplete
    device: Incomplete
    stack_traces: Incomplete
    stream: Incomplete
    rerecord_if_static_inputs_change: Incomplete
    cuda_graphs_pool: Incomplete
    children: dict[FunctionID, list[CUDAGraphNode]]
    outputs_weakrefs: OutputList[StorageWeakRefWrapper | None]
    path_weakrefs: LevelList[OutputList[StorageWeakRefWrapper | None]]
    path_stacktraces: LevelList[StackTraces | None]
    tensor_weakrefs: OutputList[TensorWeakRef | None]
    cudagraph_managed_idxs: list[int]
    live_cudagraph_managed_path_refs: InputList[PathOutputIndex | None]
    preserved_aliased_inputs: InputList[bool]
    static_input_idxs: list[int]
    non_static_input_idx: LevelList[int]
    non_managed_static_input_idxs: LevelList[int]
    static_input_data_ptrs: InputList[int | None]
    expanded_dims: list[list[int]]
    recorded_liveness_before_graph: LevelList[OutputList[bool]]
    recorded_liveness_after_graph: LevelList[OutputList[bool]]
    expected_dead_indices_before_graph: list[PathOutputIndex]
    expected_dead_indices_after_graph: list[PathOutputIndex]
    live_indices_after_graph: list[PathOutputIndex]
    graph: torch.cuda.CUDAGraph | None
    reconstructed_inputs: list[InputType]
    checkpointed_caching_state: AllocatorState | None
    output_storage_alias: OutputList[OutputAliasInfo | None]
    unaliased_in_all_paths: OutputList[bool]
    cached_tensor_outputs: OutputList[Tensor | None]
    static_output_tensors: OutputList[Tensor | None]
    recording_outputs: OutputType | None
    outputs_metadata: OutputList[dict[str, Any] | int | None]
    def __init__(self, wrapped_function: WrappedFunction, id: GraphID, parent: CUDAGraphNode | None, inputs: list[InputType], cuda_graphs_pool: tuple[int, int], device_index: int, stack_traces: StackTraces | None, stream: torch.cuda.Stream) -> None: ...
    def check_static_inputs_are_stable(self, new_inputs: list[InputType]) -> None: ...
    def run_first_inputs(self, new_inputs: list[InputType]) -> OutputType: ...
    static_inputs_stable: bool
    def run(self, new_inputs: list[InputType]) -> OutputType: ...
    def reconstruct_outputs(self) -> OutputType: ...
    def prepare_alias_info_for_tensor_construction(self, out_alias_info: OutputAliasInfo | None, metadata: dict[str, Any] | int | None) -> UntypedStorage | None | int: ...
    def prepare_storages_for_construction(self) -> list[UntypedStorage | None | int]: ...
    def run_graph(self) -> None: ...
    def all_outputs_are_dead(self) -> bool: ...
    def get_output_refcount(self, index: int) -> int: ...
    @property
    def parent(self) -> CUDAGraphNode | None: ...
    def add_child(self, function_id: FunctionID, node: CUDAGraphNode) -> None: ...
    def debug_assert_invariants(self, expected_liveness: list[list[bool]], newly_dead: list[PathOutputIndex]) -> None: ...
    def debug_check_invariants_before_invocation(self) -> None: ...
    def debug_check_invariants_after_invocation(self) -> None: ...
    def data_ptrs_dead_since_invocation(self) -> list[int]: ...
    def path_live_weakrefs(self) -> Iterator[StorageWeakRefWrapper]: ...
    def remove_node_cached_tensors(self) -> None: ...
    def remove_path_cached_tensors(self) -> None: ...
    def clear_path_state(self) -> None: ...
    def create_storage(self, metadata: dict[str, Any]) -> torch.types.Storage: ...
    def check_invariants(self, inputs: list[InputType]) -> tuple[CheckInvariantStatus, Callable[..., str]]: ...
    def num_descendants(self) -> int: ...

def get_cudagraph_segments(pool_id: tuple[int, int]) -> Any: ...
def get_block_addrs(pool_id: tuple[int, int], live_only: bool = True) -> list[int]: ...
def format_tb(frames: list[Any]) -> str: ...
def check_memory_pool(device: int, pool_id: tuple[int, int], live_storages_ptrs: list[StorageWeakRefWrapper]) -> None: ...

class ExecutionState(Enum):
    NONE = ...
    WARMUP = ...
    RECORDING = ...
    EXECUTION = ...

class CompilationMode(Enum):
    FORWARD = ...
    BACKWARD = ...
    INFERENCE = ...

class CUDAGraphTreeManager:
    roots: dict[FunctionID, list[CUDAGraphNode]]
    ids_to_funcs: dict[FunctionID, WrappedFunction]
    ids_to_stack_traces: dict[FunctionID, StackTraces | None]
    warmed_up_functions: set[FunctionID]
    warned_functions: set[FunctionID]
    warned_mutation: set[FunctionID]
    stream: Incomplete
    graph: torch.cuda.CUDAGraph | None
    cuda_graphs_thread_pool: Incomplete
    graph_counter: Incomplete
    func_counter: Incomplete
    non_cudagraph_managed_mutation_hint: dict[GraphID | None, dict[FunctionID, bool]]
    warmup_node_counter: Incomplete
    num_rerecord: dict[GraphID | None, dict[FunctionID, int]]
    path_state: Incomplete
    device_index: Incomplete
    current_gen: int
    debug_fail_counter: int
    debug_checkpointing_counter: int
    id_to_mode: dict[FunctionID, CompilationMode]
    running_forwards_with_pending_backwards: bool
    mode: CompilationMode | None
    disable_invalidate_aliases: Incomplete
    def __init__(self, device_index: int) -> None: ...
    def run(self, new_inputs: list[InputType], function_id: FunctionID) -> OutputType: ...
    def set_to_running_backward(self) -> None: ...
    def new_warmup_node_id(self) -> GraphID: ...
    def exceed_rerecord_limit(self, node_id: GraphID | None, function_id: FunctionID) -> bool: ...
    def shutdown(self) -> None: ...
    def record_function(self, new_inputs: list[InputType], function_id: FunctionID) -> OutputType: ...
    def execute_node(self, node: CUDAGraphNode, new_inputs: list[InputType]) -> OutputType: ...
    def run_eager(self, new_inputs: list[InputType], function_id: FunctionID) -> OutputType: ...
    def new_graph_id(self) -> GraphID: ...
    def new_func_id(self) -> FunctionID: ...
    def add_function(self, model: ModelType, inputs: list[InputType], static_input_idxs: Sequence[int], stack_traces: StackTraces | None, mode: CompilationMode, constants: tuple[torch.Tensor, ...], placeholders: tuple[PlaceholderInfo, ...], mutated_input_idxs: tuple[int, ...]) -> tuple[ModelType, OutputType]: ...
    @property
    def in_recording(self) -> bool: ...
    @property
    def in_warmup(self) -> bool: ...
    def get_roots(self) -> Iterator[CUDAGraphNode]: ...
    @property
    def current_node(self) -> CUDAGraphNode | CUDAWarmupNode | None: ...
    @current_node.setter
    def current_node(self, value: CUDAGraphNode | CUDAWarmupNode | None) -> None: ...
    def update_generation(self) -> None: ...
    @staticmethod
    def get_curr_generation() -> int: ...
    @staticmethod
    def user_invoked_mark_step() -> bool: ...
    def can_start_new_generation(self) -> bool: ...
    def in_new_torch_compile_invocation(self) -> bool: ...
    def try_end_curr_recording(self, function_id: FunctionID) -> None: ...
    def try_end_curr_execution(self) -> None: ...
    def try_end_curr_warmup(self, function_id: FunctionID) -> None: ...
    def check_warn_on_unable_to_start_executing(self, function_id: FunctionID) -> None: ...
    @staticmethod
    def format_dealloc_msg(stack_trace: str | None) -> str: ...
    def dealloc_current_path_weakrefs(self) -> None: ...
    def clear_current_path_state_and_set_to_none(self) -> None: ...
    def apply_checkpoint_execution_state_in_allocator(self) -> None: ...
    def live_cudagraph_pool_storages_in_curr_execution(self) -> list[StorageWeakRefPointer]: ...
