import abc
import torch.fx.graph
from abc import ABC, abstractmethod
from typing import Any
from typing_extensions import TypeAlias

class CustomGraphPass(ABC, metaclass=abc.ABCMeta):
    @abstractmethod
    def __call__(self, graph: torch.fx.graph.Graph) -> None: ...
    @abstractmethod
    def uuid(self) -> Any | None: ...

CustomGraphPassType: TypeAlias

def get_hash_for_files(paths: tuple[str], extra: str = '') -> bytes: ...
