import dataclasses
import io
import torch
from . import config as config, ir as ir
from .scheduler import BaseSchedulerNode as BaseSchedulerNode, FusedSchedulerNode as FusedSchedulerNode, NopKernelSchedulerNode as NopKernelSchedulerNode, OutputNode as OutputNode, SchedulerNode as SchedulerNode
from .virtualized import V as V
from _typeshed import Incomplete
from torch import fx as fx
from torch._dynamo.repro.after_aot import save_graph_repro as save_graph_repro
from torch._dynamo.utils import get_debug_dir as get_debug_dir
from torch.fx.graph_module import GraphModule as GraphModule
from torch.fx.passes.shape_prop import TensorMetadata as TensorMetadata
from torch.fx.passes.tools_common import legalize_graph as legalize_graph
from torch.utils._pytree import tree_map as tree_map
from typing import Any, Callable, IO, Iterator, NamedTuple

log: Incomplete
SchedulerNodeList = list[Any]

class BufMeta(NamedTuple):
    name: Incomplete
    n_origin: Incomplete

GRAPHVIZ_COMMAND_SCALABLE: Incomplete

def has_dot() -> bool: ...
def draw_buffers(nodes: list[BaseSchedulerNode], print_graph: bool = False, fname: str | None = None) -> None: ...
def create_fx_from_snodes(snodes: list[BaseSchedulerNode]) -> fx.Graph: ...
def update_orig_fx_node_name_to_buf_name(nodes: SchedulerNodeList | None, node_name_to_buf_name: dict[str, str], parent_buf_name: str | None = None, n_origins: int = 0) -> None: ...
def get_node_name_to_buf_meta(node_name_to_buf_name: dict[str, str]) -> dict[str, BufMeta]: ...
def annotate_orig_fx_with_snodes(gm: torch.fx.GraphModule, snodes: SchedulerNodeList) -> None: ...
def enable_aot_logging() -> Iterator[None]: ...

class DebugContext:
    @staticmethod
    def create_debug_dir(folder_name: str) -> str | None: ...
    def __init__(self) -> None: ...
    def copy(self, new_path: str) -> None: ...
    def fopen(self, filename: str, write_mode: str = 'w', *args: Any, **kwargs: Any) -> IO[Any]: ...
    def fopen_context(self, filename: str, write_mode: str = 'w', *args: Any, **kwargs: Any) -> Iterator[IO[Any]]: ...
    def filename(self, suffix: str) -> str: ...
    def upload_tar(self) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_val: BaseException | None, exc_tb: Any | None) -> None: ...
    def __getattr__(self, name: str) -> Callable[..., None] | None: ...

class DebugFormatter:
    fopen: Incomplete
    fopen_context: Incomplete
    filename: Incomplete
    handler: Incomplete
    def __init__(self, handler: DebugContext) -> None: ...
    def fx_graph(self, gm: torch.fx.GraphModule, inputs: list[torch.Tensor]) -> None: ...
    def fx_graph_transformed(self, gm: torch.fx.GraphModule, inputs: list[torch.Tensor]) -> None: ...
    def ir_pre_fusion(self, nodes: SchedulerNodeList) -> None: ...
    def ir_post_fusion(self, nodes: SchedulerNodeList) -> None: ...
    def graph_diagram(self, nodes: SchedulerNodeList) -> None: ...
    def draw_orig_fx_graph(self, gm: torch.fx.GraphModule, nodes: SchedulerNodeList) -> None: ...
    def output_code(self, filename: str) -> None: ...
    def log_autotuning_results(self, name: str, input_nodes: list[ir.IRNode], timings: dict['ChoiceCaller', float], elapse: float, precompile_elapse: float) -> None: ...

@dataclasses.dataclass
class TensorMetadataHolder:
    tensor_metadata: TensorMetadata
    device: torch.device

save_args_cnt: Incomplete

def save_args_for_compile_fx_inner(*args: Any, **kwargs: Any) -> None: ...
def load_args_and_run_compile_fx_inner(path: str) -> Any: ...
def aot_inductor_minifier_wrapper(func: Callable[..., str], exported_program: torch.export.ExportedProgram, *, inductor_configs: dict[str, Any], package_path: str | io.BytesIO | None = None) -> str: ...
