from typing import Any

class OperatorIssue(RuntimeError):
    @staticmethod
    def operator_str(target: Any, args: list[Any], kwargs: dict[str, Any]) -> str: ...

class MissingOperatorWithoutDecomp(OperatorIssue):
    def __init__(self, target: Any, args: list[Any], kwargs: dict[str, Any]) -> None: ...

class MissingOperatorWithDecomp(OperatorIssue):
    def __init__(self, target: Any, args: list[Any], kwargs: dict[str, Any]) -> None: ...

class LoweringException(OperatorIssue):
    def __init__(self, exc: Exception, target: Any, args: list[Any], kwargs: dict[str, Any]) -> None: ...

class SubgraphLoweringException(RuntimeError): ...

class InvalidCxxCompiler(RuntimeError):
    def __init__(self) -> None: ...

class CppWrapperCodegenError(RuntimeError):
    def __init__(self, msg: str) -> None: ...

class CppCompileError(RuntimeError):
    def __init__(self, cmd: list[str], output: str) -> None: ...

class CUDACompileError(CppCompileError): ...
