import sympy
import torch
import torch.fx
from . import config as config, inductor_prims as inductor_prims, ir as ir, jagged_lowerings as jagged_lowerings, kernel as kernel, mkldnn_lowerings as mkldnn_lowerings, quantized_lowerings as quantized_lowerings, test_operators as test_operators
from .._dynamo.utils import import_submodule as import_submodule
from .codegen.common import BackendFeature as BackendFeature, pointwise_overrides_data as pointwise_overrides_data
from .comm_lowering import register_comm_lowerings as register_comm_lowerings
from .decomposition import decompositions as decompositions, get_decompositions as get_decompositions
from .ir import DtypeView as DtypeView, ExpandView as ExpandView, IRNode as IRNode, IndexingConstant as IndexingConstant, PermuteView as PermuteView, Pointwise as Pointwise, Reduction as Reduction, SqueezeView as SqueezeView, TensorBox as TensorBox, View as View, is_triton as is_triton, ops_wrapper as ops_wrapper, validate_ir as validate_ir
from .utils import ceildiv as ceildiv, decode_device as decode_device, is_dynamic as is_dynamic, is_gpu as is_gpu, is_pointwise_use as is_pointwise_use, needs_fallback_due_to_atomic_add_limitations as needs_fallback_due_to_atomic_add_limitations, pad_listlike as pad_listlike, register_op_dtype_propagation_rules as register_op_dtype_propagation_rules, sympy_product as sympy_product, use_scatter_fallback as use_scatter_fallback
from .virtualized import V as V, ops as ops
from _typeshed import Incomplete
from torch._higher_order_ops.associative_scan import associative_scan_op as associative_scan_op
from torch._higher_order_ops.auto_functionalize import auto_functionalized as auto_functionalized
from torch._higher_order_ops.triton_kernel_wrap import triton_kernel_wrapper_mutation as triton_kernel_wrapper_mutation
from torch._prims_common import ELEMENTWISE_TYPE_PROMOTION_KIND as ELEMENTWISE_TYPE_PROMOTION_KIND, Number as Number, canonicalize_dim as canonicalize_dim, canonicalize_dims as canonicalize_dims, check as check, dtype_to_type as dtype_to_type, elementwise_dtypes as elementwise_dtypes, get_computation_dtype as get_computation_dtype, is_boolean_dtype as is_boolean_dtype, is_float_dtype as is_float_dtype, is_integer_dtype as is_integer_dtype
from torch.fx.experimental.sym_node import magic_methods as magic_methods, method_to_operator as method_to_operator
from torch.utils._sympy.functions import CeilDiv as CeilDiv, FloorDiv as FloorDiv, Identity as Identity, IntTrueDiv as IntTrueDiv, ModularIndexing as ModularIndexing
from typing import Any, Callable

FALLBACK_ALLOW_LIST: Incomplete
log: Incomplete
lowerings: dict[Callable[..., Any] | str, Callable[..., Any]]
fallbacks: set[torch._ops.OpOverload]
aten: Incomplete
tr_c10d: Incomplete
prims: Incomplete
needs_realized_inputs: set[torch._ops.OpOverload]
foreach_ops: set[torch._ops.OpOverload]
inplace_foreach_ops: set[torch._ops.OpOverload]
inplaceable_foreach_ops: dict[torch._ops.OpOverload, torch._ops.OpOverload]
quantized_decomposed: Incomplete

def maybe_layout_constraints(fn: Callable[..., Any]) -> Callable[..., Any] | None: ...
def get_layout_constraint_tag(fn): ...
def assert_nyi(cond, msg) -> None: ...
def add_needs_realized_inputs(fn): ...
def add_layout_constraint(fn, constraint) -> None: ...

DTYPE_ID_LOOKUP: Incomplete

def decode_dtype(dtype: int): ...
def is_integer_type(x): ...
def is_boolean_type(x): ...
def get_promoted_dtype(*args, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND): ...
def get_overloads(aten_fn): ...
def in_namespace(op, namespace): ...
def transform_args(args: list[Any], kwargs: dict[str, Any], broadcast: bool, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND | None, convert_input_to_bool: bool) -> tuple[list[Any], dict[str, Any]]: ...
def register_lowering(aten_fn, broadcast: bool = False, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND | None = ..., convert_input_to_bool: bool = False): ...
def broadcast_symbolic_shapes(a, b): ...
def promote_constants(inputs, override_return_dtype: Incomplete | None = None, type_promotion_kind: Incomplete | None = None): ...
def make_pointwise(fn, override_return_dtype: Incomplete | None = None, override_device: Incomplete | None = None, override_fn_when_input_bool: Incomplete | None = None, override_fn_when_gpu_float64: Incomplete | None = None, allow_alpha: bool = False, triton_fallback: Incomplete | None = None): ...
def make_foreach_pointwise(pw_fn, allow_alpha: bool = False): ...
def to_dtype(x: TensorBox, dtype: torch.dtype, copy: bool = False): ...
def to_dtype_bitcast(x: TensorBox, dtype: torch.dtype, *, copy: bool = False): ...
def to_device(x: TensorBox, device: torch.device, *, copy: bool = False, non_blocking: bool = False): ...
def register_pointwise(aten_fn, name: Incomplete | None = None, broadcast: bool = True, type_promotion_kind=..., convert_input_to_bool: bool = False, override_return_dtype: Incomplete | None = None, override_fn_when_input_bool: Incomplete | None = None, allow_alpha: bool = False, use_libdevice_for_f64: bool = False, triton_fallback: Incomplete | None = None): ...
def register_frexp(): ...
def register_foreach_pointwise(aten_fn, pointwise_lowering_fn, allow_alpha: bool = False): ...
def where(cond, a, b): ...
def broadcast_tensors(*inputs): ...
def nop(x): ...
def squeeze(x, dim: Incomplete | None = None): ...
def squeeze_copy(x, dim: Incomplete | None = None): ...
def squeeze_(x, dim: Incomplete | None = None): ...
def isinf(x): ...
def isnan(x): ...
def ceil(x): ...
def floor(x): ...
def round(x): ...
def trunc(x): ...
def expand(x, sizes): ...
def broadcast_in_dim(a, shape, broadcast_dimensions): ...
def expand_as(x, y): ...
def repeat(x, repeats): ...
def view(x, sizes): ...
def permute(x, dims): ...
def slice_(x, dim: int = 0, start: int = 0, end=..., step: int = 1, clamp: bool = True): ...
def as_strided(x, size, stride, storage_offset: Incomplete | None = None): ...
def as_strided_(x, size, stride, storage_offset: Incomplete | None = None): ...
def as_strided_copy(x, size, stride, storage_offset: Incomplete | None = None): ...
def pointwise_cat(inputs, dim: int = 0): ...
def quantized_decomposed_quantize_per_channel(input: TensorBox, scales: TensorBox, zero_points: TensorBox, axis: int, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def quantized_decomposed_dequantize_per_channel(input: TensorBox, scales: TensorBox, zero_points: TensorBox, axis: int, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def quantized_decomposed_quantize_per_tensor_default(input: TensorBox, scale: float, zero_point: int, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def quantized_decomposed_dequantize_per_tensor_default(input: TensorBox, scale: float, zero_point: int, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def quantized_decomposed_quantize_per_tensor_tensor(input: TensorBox, scale: TensorBox, zero_point: TensorBox, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def quantized_decomposed_dequantize_per_tensor_tensor(input: TensorBox, scale: TensorBox, zero_point: TensorBox, quant_min: int, quant_max: int, dtype: torch.dtype) -> TensorBox: ...
def cat(inputs, dim: int = 0): ...
def diagonal(input, offset: int = 0, dim1: int = 0, dim2: int = 1): ...
def diagonal_copy(input, offset: int = 0, dim1: int = 0, dim2: int = 1): ...
def diagonal_scatter(input, src, offset: int = 0, dim1: int = 0, dim2: int = 1): ...
def select(x, dim, idx): ...
def split(x, sizes, dim: int = 0): ...
def split_with_sizes(x, sizes, dim: int = 0): ...
def unbind(x, dim: int = 0): ...
def unfold(x, dimension, size, step): ...
def unsqueeze(x, dim): ...
def unsqueeze_(x, dim): ...
def glu(x, dim: int = -1): ...
def fallback_handler(kernel, add_to_fallback_set: bool = True): ...
def unsupported_input_tensor(t: torch.Tensor, parent: Incomplete | None = None): ...
def unsupported_output_tensor(t: torch.Tensor, parent: Incomplete | None = None): ...
def fallback_node_due_to_unsupported_type(node: torch.fx.Node, allow_cpu_inputs: bool = True): ...
def make_fallback(op, layout_constraint: Incomplete | None = None, warn: bool = True, override_decomp: bool = False): ...
def philox_rand_offset(shape): ...
def philox_rand(size, seed, offset, stride, device, dtype): ...
def native_dropout(x, p, train): ...
def bernoulli_(x, *args): ...
def bernoulli_p(x, *args): ...
def warn_triton_random() -> None: ...

fallback_rand_default: Incomplete
fallback_rand_generator: Incomplete
fallback_randn_default: Incomplete
fallback_randn_generator: Incomplete

def rand(*args, **kwargs): ...
def randn(*args, **kwargs): ...
def inductor_force_stride_order(input_tensor, stride): ...
def inductor_seed(device: torch.device): ...
def inductor_seeds(count, device): ...
def inductor_lookup_seed(seeds, index): ...
def inductor_random(size: list[int], seed: TensorBox, mode: str, *, offset: int = 0): ...
def inductor_randint(low: int, high: int, size: list[int], seed: TensorBox, *, offset: int = 0): ...
def searchsorted(sorted_sequence: TensorBox, self: TensorBox, *, out_int32: bool = False, right: bool = False, side: str | None = None, sorter: TensorBox | None = None) -> TensorBox: ...
def bucketize(input: TensorBox, boundaries: TensorBox, *, out_int32: bool = False, right: bool = False): ...
def require_dense(_, *args, **kwargs): ...
def require_contiguous(_, *args, **kwargs): ...
def require_channels_last(_, *args, **kwargs): ...
def constrain_to_fx_strides(fx_node, *args, **kwargs): ...
def sdpa_constraint(fx_node, *args, **kwargs): ...
def copy(self, src, non_blocking: bool = False): ...
def clone(x, *, memory_format: Incomplete | None = None): ...
def clone_preserve_reinterpret_view(x): ...
def iota(length, *, start, step, dtype, device, requires_grad): ...
def select_scatter(x, src, dim: int, index: int): ...
def slice_scatter(x, src, dim: int = 0, start: Incomplete | None = None, end: Incomplete | None = None, step: int = 1): ...
def tensor(data, *, dtype: Incomplete | None = None, device: Incomplete | None = None, layout: Incomplete | None = None, pin_memory: bool = False): ...
def as_tensor(data, dtype: Incomplete | None = None, device: Incomplete | None = None): ...
def long_tensor(data): ...
def full_like(x, fill_value, **kwargs): ...
def tensor_constructor(fill_value): ...
def empty(*size, names: Incomplete | None = None, dtype: Incomplete | None = None, layout: Incomplete | None = None, device: Incomplete | None = None, pin_memory: Incomplete | None = None, memory_format: Incomplete | None = None): ...
def create_tensor_like(creation_fn): ...
def constant_like(fill_value): ...

empty_like: Incomplete
ones_like: Incomplete
zeros_like: Incomplete

def new_constant(fill_value): ...
def new_empty(x, size, *, dtype: Incomplete | None = None, layout: Incomplete | None = None, device: Incomplete | None = None, pin_memory: Incomplete | None = None): ...
def empty_strided(size, stride, *, dtype: Incomplete | None = None, layout: Incomplete | None = None, device: Incomplete | None = None, pin_memory: Incomplete | None = None): ...
def new_empty_strided(x, size, stride, *, dtype: Incomplete | None = None, layout: Incomplete | None = None, device: Incomplete | None = None, pin_memory: Incomplete | None = None): ...
def copy_strided(x, stride): ...
def full(size, fill_value, **kwargs): ...
def gather(x, dim, index, sparse_grad: bool = False): ...
def embedding(weight, indices, padding_idx: int = -1, scale_grad_by_freq: bool = False, sparse: bool = False): ...
def check_and_broadcast_indices(indices, device): ...
def index_output_size_and_inner_fn(x_size, indices, tensor_indices, tensor_size, indices_loaders, indexed_size, x_loader, check, wrap_neg: bool = True): ...
def index_impl(x, indices, check): ...
def index_impl_helper(x, indices, check, wrap_neg: bool = True): ...
def index(x, indices): ...
def index_put(x, indices, values, accumulate: bool = False): ...
def index_put_as_masked_fill(self, indices, value, accumulate): ...
def index_put_fallback(self, indices, values, accumulate): ...
def index_put_(self, indices, values, accumulate: bool = False): ...
def index_put_impl_(self, indices, values, accumulate, check): ...

fallback__unsafe_masked_index: Incomplete
fallback__unsafe_masked_index_put_accumulate: Incomplete

def clamp(a, min, max): ...
def as_strided_scatter(self, src, size, stride, storage_offset: Incomplete | None = None): ...
def scatter(x, dim: int, index, src, **kwargs): ...
def scatter_fallback(op_overload: torch._ops.OpOverload, self, dim: int, index, src, *, reduce: str | None = None, include_self: bool = True): ...
def scatter_(self, dim: int, index, src, *, reduce: str | None = None): ...
def scatter_add(x, dim: int, index, src): ...
def scatter_add_(x, dim: int, index, src): ...
def scatter_reduce(x, dim: int, index, src, reduction_type, **kwargs): ...
def scatter_reduce_(self, dim: int, index, src, reduce, *, include_self: bool = True): ...
def upsample_nearestnd(x, output_size, scales_x: tuple[float | None, ...], n: int = 2, exact: bool = False): ...
def upsample_nearest1d(x, output_size, scales: float | None = None): ...
def upsample_nearest2d(x, output_size, scales_h: float | None = None, scales_w: float | None = None): ...
def upsample_nearest3d(x, output_size, scales_d: float | None = None, scales_h: float | None = None, scales_w: float | None = None): ...
def rev(x, dims): ...
def constant_pad_nd(x, padding, fill_value: int = 0): ...
def range_mask_low(i: sympy.Expr, low: sympy.Expr | int): ...
def range_mask_high(i: sympy.Expr, high: sympy.Expr): ...
def range_mask(i: sympy.Expr, high: sympy.Expr, low: sympy.Expr): ...
def constant_boundary_condition(x, fill_value, padding: Incomplete | None = None, pad_fill_value: float = 1.0, dim: Incomplete | None = None): ...
def pooling_size(x, i, kernel_size, stride, padding, ceil_mode): ...
def should_fallback_max_pool2d_with_indices(kernel_size, dilation): ...
def max_pool2d_checks(x, kernel_size, stride, padding, dilation, *, assert_fallback: Incomplete | None = None): ...

fallback_max_pool2d_with_indices_backward: Incomplete

def max_pool2d_with_indices_backward(grad_output, x, kernel_size, stride, padding, dilation, ceil_mode, indices): ...
def pad_adaptive_loader(x, pad_val: float = 0.0): ...
def compute_indices_adaptive_pooling(start_index, end_index, h_in, w_in, h_out, w_out): ...

fallback_adaptive_avg_pool2d: Incomplete
fallback_adaptive_max_pool2d: Incomplete

def adaptive_max_pool2d(x, output_size): ...

fallback_fractional_max_pool2d: Incomplete

def fractional_max_pool2d(x, kernel_size, output_size, random_samples): ...
def upsample_nearest2d_backward(x, output_size: Incomplete | None = None, input_size: Incomplete | None = None, scales_h: Incomplete | None = None, scales_w: Incomplete | None = None): ...

fallback_avg_pool2d: Incomplete
fallback_avg_pool3d: Incomplete

def avg_pool2d(x, kernel_size, stride=(), padding: int = 0, ceil_mode: bool = False, count_include_pad: bool = True, divisor_override: Incomplete | None = None): ...
def avg_pool3d(x, kernel_size, stride=(), padding: int = 0, ceil_mode: bool = False, count_include_pad: bool = True, divisor_override: Incomplete | None = None): ...

fallback_avg_pool2d_backward: Incomplete

def avg_pool2d_backward(grad_output, x, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override: Incomplete | None = None): ...

fallback_avg_pool3d_backward: Incomplete

def avg_pool3d_backward(grad_output, x, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override: Incomplete | None = None): ...
def make_reduction(reduction_type: str, override_return_dtype: Incomplete | None = None): ...
def mean(x, axis: Incomplete | None = None, keepdim: bool = False, *, dtype: Incomplete | None = None): ...
def var_mean_sum_(x, axis, correction, keepdim, return_mean): ...
def use_two_step_variance(x, axis, keepdim): ...
def var_mean_welford_(x, axis, *, correction, keepdim, return_mean): ...
def var_mean_helper_(x, *, axis, correction, keepdim, return_mean): ...
def var_(x, axis: Incomplete | None = None, *, correction: Incomplete | None = None, keepdim: bool = False): ...
def var_mean(x, axis: Incomplete | None = None, *, correction: Incomplete | None = None, keepdim: bool = False): ...
def pow_recursive(x, y, dtype): ...
def pow_native(a, b): ...

fallback_pow_tensor_tensor: Incomplete
fallback_pow_scalar: Incomplete
fallback_pow_tensor_scalar: Incomplete

def pow(a, b): ...
def mutate_to(changed, val, unsafe_alias: bool = False): ...
def fill_(x, fill_value): ...
def copy_(dst, src, non_blocking: bool = False): ...
def floordiv(a, b): ...
def truncdiv(a, b): ...
def div_mode(a, b, rounding_mode: Incomplete | None = None): ...
def mul(a, b): ...
def get_constant_value(x: ir.IRNode) -> ir.Constant | None: ...
def div_prim(a, b): ...
def div(a, b): ...
def fmod(a, b): ...
def sum_(x, axis: Incomplete | None = None, keepdims: bool = False, *, dtype: Incomplete | None = None): ...

fallback_cumsum: Incomplete
fallback_cumprod: Incomplete
fallback_logcumsumexp: Incomplete
fallback_cummax: Incomplete
fallback_cummin: Incomplete

def cumsum(x, axis: Incomplete | None = None, dtype: Incomplete | None = None): ...
def cumprod(x, axis: Incomplete | None = None, dtype: Incomplete | None = None): ...
def logcumsumexp(x, dim): ...
def cummax(x, axis: Incomplete | None = None): ...
def cummin(x, axis: Incomplete | None = None): ...
def prod(x, axis: Incomplete | None = None, keepdims: bool = False, *, dtype: Incomplete | None = None): ...
def reduce_any(x, dim: Incomplete | None = None, keepdim: bool = False): ...
def reduce_max(x, dim: Incomplete | None = None, keepdim: bool = False): ...
def reduce_min(x, dim: Incomplete | None = None, keepdim: bool = False): ...

reduce_amax: Incomplete
reduce_amin: Incomplete
reduce_argmax: Incomplete
reduce_argmin: Incomplete
add: Incomplete
sort_fallback: Incomplete

def sort_stable(x, *, stable: Incomplete | None = None, dim: int = -1, descending: bool = False): ...
def sort(x, dim: int = -1, descending: bool = False): ...
def register_pointwise_numeric(op, name: Incomplete | None = None, triton_fallback: Incomplete | None = None): ...
def register_pointwise_numeric_ldf64(op): ...

rsqrt: Incomplete
exp: Incomplete
exp2: Incomplete
expm1: Incomplete
relu: Incomplete
sigmoid: Incomplete
sqrt: Incomplete
square: Incomplete
sub: Incomplete
abs: Incomplete
bitwise_and: Incomplete
bitwise_left_shift: Incomplete
bitwise_not: Incomplete
bitwise_or: Incomplete
bitwise_right_shift: Incomplete
bitwise_xor: Incomplete
erf: Incomplete
logical_and: Incomplete
logical_not: Incomplete
logical_or: Incomplete
logical_xor: Incomplete
maximum: Incomplete
minimum: Incomplete
neg: Incomplete
reciprocal: Incomplete
sign: Incomplete
gt: Incomplete
foreach_add_list: Incomplete
foreach_add_scalar: Incomplete
foreach_mul_list: Incomplete
foreach_mul_scalar: Incomplete
foreach_div_list: Incomplete
foreach_div_scalar: Incomplete

def register_foreach_inplace(aten_op, outplace_aten_op, outplace_op): ...
def register_inplace(aten_op, outplace_op): ...
def sym_constrain_range(a, min: Incomplete | None = None, max: Incomplete | None = None) -> None: ...
def sym_size(a, dim): ...
def sym_stride(a, dim): ...
def sym_numel(a): ...
def sym_sum(args): ...
def foobar(self, *args, **kwargs) -> None: ...
def resize_storage_bytes_(variable, new_size): ...
def set__source_tensor(self, source_tensor): ...
def fsdp_copy_(dst, src): ...
def resize(x, size, *, memory_format: Incomplete | None = None): ...
def triton_kernel_wrap_(*, kernel_idx, constant_args_idx, grid, tma_descriptor_metadata, kwargs): ...
def cond(pred, true_fn, false_fn, operands): ...
def while_loop(cond_fn, body_fn, carried_inputs, additional_inputs): ...
def invoke_subgraph(subgraph_fn: ir.Subgraph, identifier: str, operands): ...
def associative_scan(combine_fn: ir.Subgraph, xs, dim: int): ...
def with_effects(token, op, *args, **kwargs): ...
