import dataclasses
from .dependencies import Dep as Dep
from .ir import MultiOutputLayout as MultiOutputLayout, NoneLayout as NoneLayout
from .scheduler import BaseSchedulerNode as BaseSchedulerNode, SchedulerBuffer as SchedulerBuffer
from .utils import get_dtype_size as get_dtype_size
from .virtualized import V as V
from _typeshed import Incomplete
from torch._utils_internal import signpost_event as signpost_event
from torch.utils._ordered_set import OrderedSet as OrderedSet
from typing import Callable

torch_log: Incomplete

@dataclasses.dataclass
class MemoryPlanningInfoForBuffer:
    size_alloc: int = ...
    size_free: int = ...
    succ_nodes: OrderedSet[BaseSchedulerNode] = dataclasses.field(default_factory=OrderedSet)

@dataclasses.dataclass
class MemoryPlanningInfoForNode:
    index: int = ...
    size: int = ...
    pred_buffers: OrderedSet[SchedulerBuffer | FreeableInputBuffer] = dataclasses.field(default_factory=OrderedSet)
    pred_nodes: OrderedSet[BaseSchedulerNode] = dataclasses.field(default_factory=OrderedSet)
    succ_nodes: OrderedSet[BaseSchedulerNode] = dataclasses.field(default_factory=OrderedSet)

@dataclasses.dataclass
class FreeableInputBuffer:
    name: str
    mpi_buffer: MemoryPlanningInfoForBuffer = dataclasses.field(default_factory=MemoryPlanningInfoForBuffer)
    def get_name(self) -> str: ...
    def __hash__(self) -> int: ...

def get_freeable_input_buf(nodes: list[BaseSchedulerNode], graph_inputs: set[str]) -> dict[str, FreeableInputBuffer]: ...
def compute_size_for_scheduler_buffer(name_to_buf: dict[str, SchedulerBuffer]) -> dict[str, tuple[int, int]]: ...
def assign_memory_planning_info_for_scheduler_buffers(nodes: list[BaseSchedulerNode], name_to_buf: dict[str, SchedulerBuffer]) -> None: ...
def assign_memory_planning_info_for_scheduler_nodes(nodes: list[BaseSchedulerNode], name_to_fused_node: dict[str, BaseSchedulerNode], name_to_buf: dict[str, SchedulerBuffer], name_to_freeable_input_buf: dict[str, FreeableInputBuffer]) -> None: ...
def estimate_peak_memory(nodes: list[BaseSchedulerNode], name_to_freeable_input_buf: dict[str, FreeableInputBuffer], graph_outputs: set[str]) -> tuple[int, list[int]]: ...
def topological_sort_lpmf(nodes: list[BaseSchedulerNode], name_to_freeable_input_buf: dict[str, FreeableInputBuffer], name_to_buf: dict[str, SchedulerBuffer], graph_outputs: set[str]) -> list[BaseSchedulerNode]: ...
def topological_sort_bfs(nodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def topological_sort_dfs(nodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def reorder_for_peak_memory(nodes: list[BaseSchedulerNode], name_to_buf: dict[str, SchedulerBuffer], name_to_fused_node: dict[str, BaseSchedulerNode], graph_inputs: set[str], graph_outputs: set[str], methods: list[Callable[..., list[BaseSchedulerNode]]] = ...) -> list[BaseSchedulerNode]: ...
