import dataclasses
from _typeshed import Incomplete
from dataclasses import dataclass
from torch._inductor import config as config
from torch._inductor.scheduler import BaseSchedulerNode as BaseSchedulerNode
from torch._inductor.utils import get_benchmark_name as get_benchmark_name

generated_kernel_count: int
generated_cpp_vec_kernel_count: int
num_bytes_accessed: int
nodes_num_elem: list[tuple[BaseSchedulerNode, int]]
node_runtimes: list[tuple[BaseSchedulerNode, float]]
ir_nodes_pre_fusion: int
cpp_to_dtype_count: int

@dataclasses.dataclass
class CppOuterLoopFusedCount:
    inner_kernel_number: int
    local_buffer_number: int = ...

cpp_outer_loop_fused_inner_counts: list[CppOuterLoopFusedCount]
num_comprehensive_padding: int
num_matches_for_scatter_upon_const_tensor: int
num_loop_reordering: int

def reset() -> None: ...

@dataclass
class CachedMetricsDeltas:
    generated_kernel_count: int
    generated_cpp_vec_kernel_count: int
    ir_nodes_pre_fusion: int
    cpp_to_dtype_count: int
    num_bytes_accessed: int
    num_matches_for_scatter_upon_const_tensor: int

def get_metric_fields(): ...

class CachedMetricsHelper:
    cached_metrics: Incomplete
    def __init__(self) -> None: ...
    def get_deltas(self) -> CachedMetricsDeltas: ...
    @staticmethod
    def apply_deltas(delta: CachedMetricsDeltas): ...

REGISTERED_METRIC_TABLES: dict[str, MetricTable]

@dataclass
class MetricTable:
    table_name: str
    column_names: list[str]
    num_rows_added: int = ...
    def add_row(self, row_fn) -> None: ...
    def output_filename(self): ...
    def write_header(self) -> None: ...
    @staticmethod
    def register_table(name, column_names) -> None: ...

def log_kernel_metadata(kernel_name, kernel_path, kernel_module_code): ...
def purge_old_log_files() -> None: ...
def enabled_metric_tables() -> set[str]: ...
def enabled_metric_tables_impl(config_str: str) -> set[str]: ...
def is_metric_table_enabled(name): ...
def get_metric_table(name): ...
