import abc
import dataclasses
from _typeshed import Incomplete
from abc import abstractmethod
from torch._dynamo.utils import dynamo_timed as dynamo_timed
from torch._inductor import config as config
from typing import Any, Callable, Generic
from typing_extensions import TypeAlias

log: Incomplete
Sample: TypeAlias
remote_fx_cache_get_timed: Incomplete
remote_fx_cache_put_timed: Incomplete

class RemoteCacheBackend(Generic[_T], metaclass=abc.ABCMeta):
    def __init__(self) -> None: ...
    def get(self, key: str) -> _T | None: ...
    def put(self, key: str, data: _T) -> None: ...

class RemoteCacheSerde(Generic[_T, _U], metaclass=abc.ABCMeta):
    @abstractmethod
    def encode(self, data: _T) -> _U: ...
    @abstractmethod
    def decode(self, data: _U) -> _T: ...

JsonDataTy: Incomplete

class RemoteCacheJsonSerde(RemoteCacheSerde[JsonDataTy, bytes]):
    def encode(self, data: JsonDataTy) -> bytes: ...
    def decode(self, data: bytes) -> JsonDataTy: ...

class RemoteCachePassthroughSerde(RemoteCacheSerde[_T, _T]):
    def encode(self, data: _T) -> _T: ...
    def decode(self, data: _T) -> _T: ...

class RemoteCache(Generic[_T]):
    backend_override_cls: Callable[[], RemoteCacheBackend[Any]] | None
    backend: Incomplete
    serde: Incomplete
    def __init__(self, backend: RemoteCacheBackend[_U], serde: RemoteCacheSerde[_T, _U]) -> None: ...
    def get(self, key: str) -> _T | None: ...
    def put(self, key: str, value: _T) -> None: ...

class RedisRemoteCacheBackend(RemoteCacheBackend[bytes]):
    def __init__(self, cache_id: str) -> None: ...

class RedisRemoteCache(RemoteCache[JsonDataTy]):
    def __init__(self, cache_id: str) -> None: ...

class RemoteAutotuneCache(RedisRemoteCache): ...
class RemoteBundledAutotuneCache(RedisRemoteCache): ...
class RemoteFxGraphCache(RedisRemoteCache): ...
class RemoteAOTAutogradCache(RedisRemoteCache): ...
class RemoteDynamoPGOCache(RedisRemoteCache): ...

def create_cache(key: str, is_fbcode: bool, fb_cache_cls: str, oss_cache_cls: str) -> RemoteCache[JsonDataTy] | None: ...

@dataclasses.dataclass
class _CacheStat:
    miss: int = ...
    hit: int = ...
    put: int = ...
    exception: int = ...

class _CacheStats:
    def __init__(self) -> None: ...
    def miss(self, name: str, count: int = 1) -> None: ...
    def hit(self, name: str, count: int = 1) -> None: ...
    def get(self, name: str, value: object | None) -> None: ...
    def put(self, name: str, count: int = 1) -> None: ...
    def exception(self, name: str, count: int = 1) -> None: ...

cache_stats: Incomplete

def dump_cache_stats() -> None: ...
