import sympy
from .runtime.runtime_utils import is_power_of_2 as is_power_of_2
from .utils import VarRanges as VarRanges, has_free_symbols as has_free_symbols, sympy_index_symbol as sympy_index_symbol, sympy_index_symbol_with_prefix as sympy_index_symbol_with_prefix, sympy_subs as sympy_subs
from .virtualized import V as V
from _typeshed import Incomplete
from sympy import Expr
from torch.fx.experimental.symbolic_shapes import ShapeEnv as ShapeEnv, free_unbacked_symbols as free_unbacked_symbols
from torch.utils._sympy.functions import FloorDiv as FloorDiv, ModularIndexing as ModularIndexing
from torch.utils._sympy.symbol import SymT as SymT, symbol_is_type as symbol_is_type
from torch.utils._sympy.value_ranges import IntInfinity as IntInfinity, ValueRanges as ValueRanges, bound_sympy as bound_sympy
from typing import Any, Callable, Iterable, Sequence

log: Incomplete

def evaluate_expr(shape_env: ShapeEnv, expr: sympy.Basic | bool, axioms: tuple[sympy.Expr] | None = None, var_to_range: tuple[tuple[sympy.Symbol, ValueRanges[Any]]] | None = None) -> bool: ...

class SizeVarAllocator:
    shape_env: Incomplete
    var_to_val: Incomplete
    replacements: dict[sympy.Symbol, Expr]
    precomputed_replacements: dict[Expr, sympy.Symbol]
    inv_precomputed_replacements: dict[sympy.Symbol, Expr]
    stride_vars: Incomplete
    simplify_with_ranges: Incomplete
    def __init__(self, shape_env: Incomplete | None = None) -> None: ...
    def simplify(self, expr: Expr): ...
    def make_simplify_with_ranges_cache(self) -> Callable[[Expr, VarRanges], Expr]: ...
    def make_simplify_loops_cache(self): ...
    def is_expr_static_and_true(self, expr: sympy.Basic | bool) -> bool: ...
    def statically_known_equals(self, left: Expr | int, right: Expr | int) -> bool: ...
    def statically_known_list_equals(self, left: list[Expr], right: list[Expr]) -> bool: ...
    def statically_known_leq(self, left: Expr, right: Expr | int) -> bool: ...
    def statically_known_geq(self, left: Expr, right: Expr | int) -> bool: ...
    def statically_known_lt(self, left: Expr, right: Expr | int) -> bool: ...
    def statically_known_gt(self, left: Expr, right: Expr | int) -> bool: ...
    def statically_known_multiple_of(self, numerator: Expr, denominator: Expr | int) -> bool: ...
    def statically_known_power_of_2(self, expr: Expr) -> bool: ...
    def guard_equals(self, left: Expr, right: Expr) -> Expr: ...
    def guard_leq(self, left: Expr, right: Expr) -> None: ...
    def guard_lt(self, left: Expr, right: Expr) -> None: ...
    def guarded_order(self, seq): ...
    def evaluate_expr(self, left: Expr | sympy.logic.boolalg.Boolean) -> bool: ...
    def evaluate_min(self, left: Expr, right: Expr) -> Expr: ...
    def evaluate_max(self, left: Expr, right: Expr) -> Expr: ...
    def evaluate_static_shape(self, left: Expr | int) -> int: ...
    def evaluate_static_shapes(self, left: Sequence[Expr | int]) -> list[int]: ...
    def remove_precomputed_replacements(self, expr: Expr) -> Expr: ...
    def symbolic_hint(self, expr: Expr | int) -> Expr | int: ...
    def size_hint(self, expr: Expr | int, *, fallback: int | None = None) -> int: ...
    def size_hints(self, exprs: Iterable[Expr], *, fallback: int | None = None) -> tuple[int, ...]: ...
    def make_stride_vars_cache(self): ...
    def atomically_apply_size_hint(self, expr: Expr | int, *, fallback: int | None = None) -> Expr | int: ...
    def offset_var(self, index: Expr, vars: list[sympy.Symbol]) -> Expr: ...
    def stride_hints(self, index: Expr, vars: Sequence[sympy.Symbol], support_vars: Sequence[sympy.Symbol] | None = None) -> list[int]: ...
    def stride_order(self, index: Expr, vars: list[sympy.Symbol]) -> list[int]: ...
    def lookup_precomputed_size(self, expr: Expr) -> Expr: ...
    def free_symbols(self) -> set[sympy.Symbol]: ...
    def combine_modular_indexing_pairs(self, index: sympy.Expr) -> sympy.Expr: ...
    def expand_floor_div(self, index: sympy.Expr) -> bool | tuple[sympy.Expr, sympy.Expr]: ...

def join_dimensions(expr: Expr) -> Expr: ...

class SimplifyIndexing(V.WrapperHandler):
    name: str
    def __init__(self, inner, var_ranges: VarRanges) -> None: ...
    def load(self, name: str, index: sympy.Expr): ...
    def store(self, name, index, value, mode: Incomplete | None = None): ...
    def store_reduction(self, name, index, value): ...
    def index_expr(self, index, dtype): ...
    def check_bounds(self, index, size, lower, upper): ...
