import dataclasses
from .runtime.runtime_utils import triton_cache_dir as triton_cache_dir
from .utils import GPU_KERNEL_BIN_EXTS as GPU_KERNEL_BIN_EXTS
from _typeshed import Incomplete
from torch._dynamo.utils import counters as counters, dynamo_timed as dynamo_timed, set_feature_use as set_feature_use
from torch._utils_internal import justknobs_check as justknobs_check

log: Incomplete

@dataclasses.dataclass(frozen=True)
class TritonBundleEntry:
    kernel_hash: str
    device: int
    directory: str

@dataclasses.dataclass(frozen=True)
class TritonKernelArtifact:
    filename: str
    payload: bytes = dataclasses.field(repr=False)

@dataclasses.dataclass(frozen=True)
class TritonKernelArtifacts:
    kernel_hash: str
    device: int
    artifacts: list[TritonKernelArtifact]

@dataclasses.dataclass(frozen=True)
class TritonBundlerMetadata:
    cached_kernel_names: list[str]

class TritonBundler:
    @staticmethod
    def is_enabled() -> bool: ...
    @classmethod
    def begin_compile(cls) -> None: ...
    @classmethod
    def end_compile(cls) -> None: ...
    @classmethod
    def put(cls, kernel_hash: str, device: int) -> None: ...
    @classmethod
    def collect(cls) -> tuple[list[TritonKernelArtifacts], TritonBundlerMetadata | None]: ...
    @staticmethod
    def read_and_emit(bundle: list[TritonKernelArtifacts]) -> TritonBundlerMetadata | None: ...
