import dataclasses
import enum
import sympy
import torch
from . import config as config
from _typeshed import Incomplete
from collections.abc import Generator
from torch._dynamo.device_interface import get_interface_for_device as get_interface_for_device
from torch._dynamo.utils import detect_fake_mode as detect_fake_mode
from torch._inductor.runtime.hints import DeviceProperties as DeviceProperties
from torch._prims_common import ELEMENTWISE_TYPE_PROMOTION_KIND as ELEMENTWISE_TYPE_PROMOTION_KIND
from torch.autograd import DeviceType as DeviceType
from torch.autograd.profiler_util import EventList as EventList
from torch.fx.passes.graph_transform_observer import GraphTransformObserver as GraphTransformObserver
from torch.fx.passes.shape_prop import ShapeProp as ShapeProp
from torch.utils._pytree import tree_map_only as tree_map_only
from torch.utils._sympy.functions import CeilDiv as CeilDiv, CleanDiv as CleanDiv, FloorDiv as FloorDiv, Identity as Identity, ModularIndexing as ModularIndexing
from torch.utils._sympy.symbol import SymT as SymT, make_symbol as make_symbol
from torch.utils._sympy.value_ranges import ValueRanges as ValueRanges, bound_sympy as bound_sympy
from typing import Any, Callable, Generic, Iterable, NamedTuple, Protocol, Sequence, TypeVar, ValuesView
from typing_extensions import Concatenate, ParamSpec, TypeGuard, dataclass_transform

GPU_TYPES: Incomplete

def get_gpu_type(): ...

log: Incomplete
VarRanges: Incomplete
InputType: Incomplete
GPU_KERNEL_BIN_EXTS: Incomplete
GPU_ALIGN_BYTES: int
ALIGNMENT: int
ALIGN_BYTES: int

class align(sympy.Function):
    nargs: Incomplete
    is_integer: bool
    @classmethod
    def eval(cls, value: sympy.Expr) -> sympy.Expr | None: ...

def do_bench_using_profiling(fn: Callable[[], Any], warmup: int = 25, rep: int = 100) -> float: ...
def has_torchvision_roi_align() -> bool: ...
def decode_device(device: torch.device | None | str) -> torch.device: ...
def sympy_product(it: Iterable[sympy.Expr]) -> sympy.Expr: ...
def sympy_dot(seq1: Sequence[sympy.Expr], seq2: Sequence[sympy.Expr]) -> sympy.Expr: ...
def unique(it: Iterable[_T]) -> ValuesView[_T]: ...
def ceildiv(numer: int | sympy.Expr, denom: int | sympy.Expr) -> int | sympy.Expr: ...
def convert_shape_to_inductor(lst: Iterable[int | torch.SymInt]) -> list[sympy.Expr]: ...
def convert_shape_to_symint(lst: Iterable[int | sympy.Expr]) -> list[int | torch.SymInt]: ...
def is_view(op: torch._ops.OpOverload) -> bool: ...
def is_pointwise_use(use, is_pointwise_fn: Callable[[torch._ops.OpOverload], bool] | None = None) -> bool: ...
def gen_gm_and_inputs(target, args, kwargs): ...
def synchronize(device: str = 'cuda') -> None: ...
def timed(model: Callable[..., Any], example_inputs, times: int = 1, device: str = 'cuda') -> float: ...
def print_performance(fn, args=(), times: int = 10, repeat: int = 10, baseline: float = 1.0, device: str = 'cuda'): ...
def precompute_method(obj: Any, method: str): ...
def precompute_methods(obj: Any, methods: list[str]): ...
def cmp(a, b) -> int: ...
def pad_listlike(x, size): ...
def tuple_sorted(x: tuple[_T, ...]) -> list[_T]: ...
P = ParamSpec('P')
RV = TypeVar('RV', covariant=True)

class CachedMethod(Protocol, Generic[P, RV]):
    @staticmethod
    def clear_cache(self) -> None: ...
    def __call__(self, *args: P.args, **kwargs: P.kwargs) -> RV: ...

def cache_on_self(fn: Callable[Concatenate[Any, P], RV]) -> CachedMethod[P, RV]: ...
def aggregate_origins(node_schedule): ...
def get_fused_kernel_name(node_schedule, descriptive_names): ...
def get_kernel_metadata(node_schedule, wrapper): ...
def dominated_nodes(initial_queue: Iterable[torch.fx.Node], skip_filter: Incomplete | None = None) -> set[torch.fx.Node]: ...
def gather_origins(args, kwargs): ...
def sympy_str(expr: sympy.Expr) -> str: ...
def get_bounds_index_expr(index): ...
def sympy_index_symbol_with_prefix(prefix: SymT, idx: int) -> sympy.Symbol: ...
def generate_assert(check): ...
def sympy_index_symbol(name: str) -> sympy.Symbol: ...
def sympy_subs(expr: sympy.Expr, replacements: dict[sympy.Expr, Any]) -> sympy.Expr: ...
def is_symbolic(a: Any) -> TypeGuard[torch.SymInt | torch.Tensor]: ...
def any_is_symbolic(*args: Any) -> bool: ...
def get_first_incompatible_cudagraph_node(gm: torch.fx.GraphModule) -> torch.fx.Node | None: ...
def output_node(gm: torch.fx.GraphModule): ...
def clear_on_fresh_inductor_cache(obj: Any): ...
def clear_inductor_caches() -> None: ...
def fresh_inductor_cache(cache_entries: Incomplete | None = None, dir: Incomplete | None = None, delete: bool = True) -> Generator[None]: ...
def argsort(seq) -> list[int]: ...
def argsort_sym(shape_env, seq: Sequence[int | torch.SymInt | sympy.Expr]) -> list[int]: ...
def get_dtype_size(dtype): ...

class LineContext(NamedTuple):
    context: Any

class IndentedBuffer:
    tabwidth: int
    def __init__(self, initial_indent: int = 0) -> None: ...
    def getvaluewithlinemap(self) -> tuple[str, list[tuple[int, LineContext]]]: ...
    def getvalue(self) -> str: ...
    def getrawvalue(self) -> str: ...
    def clear(self) -> None: ...
    def __bool__(self) -> bool: ...
    def prefix(self): ...
    def newline(self) -> None: ...
    def writeline(self, line) -> None: ...
    def writelines(self, lines) -> None: ...
    def indent(self, offset: int = 1): ...
    def do_indent(self, offset: int = 1) -> None: ...
    def do_unindent(self, offset: int = 1) -> None: ...
    def splice(self, other_code, strip: bool = False) -> None: ...
    def map(self, func: Callable[[Any], Any]) -> IndentedBuffer: ...
    def __add__(self, other): ...

class FakeIndentedBuffer(IndentedBuffer):
    def __init__(self) -> None: ...
    def __getattribute__(self, name): ...

def restore_stdout_stderr(initial_stdout, initial_stderr) -> Generator[None]: ...

class DeferredLineBase:
    line: Incomplete
    def __init__(self, line) -> None: ...
    def __call__(self) -> str | None: ...
    def with_prefix(self, prefix): ...
    def lstrip(self): ...
    def __getitem__(self, index): ...
    def __bool__(self) -> bool: ...
    def __len__(self) -> int: ...

class DelayReplaceLine(DeferredLineBase):
    key: Incomplete
    value_fn: Incomplete
    def __init__(self, key: str, value_fn: Callable[[], str], line: str) -> None: ...
    def __call__(self) -> str: ...

def is_big_gpu(index_or_device: int | torch.device = 0) -> bool: ...
def use_max_autotune() -> bool: ...
def use_triton_template(layout, *, enable_int32: bool = False, enable_float8: bool = False): ...
def use_cutlass_template(layout, m, n, k): ...
def try_import_ck_lib(): ...
def use_ck_template(layout): ...
def use_ck_gemm_template(layout, m, n, k): ...
def use_ck_conv_template(layout): ...
def use_cpp_bmm_template(layout, mat1, mat2): ...
def use_cpp_gemm_template(layout, mat1, mat2, mat2_transposed: bool = False, require_constant_mat2: bool = True): ...
def use_aten_gemm_kernels(): ...

class DebugDirManager:
    counter: Incomplete
    prev_debug_name: str
    id: Incomplete
    def __init__(self) -> None: ...
    new_name: Incomplete
    def __enter__(self) -> None: ...
    def __exit__(self, *args) -> None: ...

def run_and_get_code(fn, *args, **kwargs) -> tuple[Any, list[str]]: ...
def run_fw_bw_and_get_code(fn): ...
def get_code(fn, *args, **kwargs): ...
def get_triton_code(fn, *args, **kwargs): ...
def run_and_get_triton_code(fn, *args, **kwargs): ...
def run_and_get_graph_lowering(fn, *args, **kwargs): ...
def override_lowering(aten_op, override_fn) -> Generator[None]: ...
def add_scheduler_init_hook(pre_fn, post_fn: Incomplete | None = None): ...
def developer_warning(msg) -> None: ...
def get_benchmark_name(): ...
def is_ones(items): ...
def is_zeros(items): ...
def is_cpu_device(inputs): ...
def get_sympy_Expr_dtype(val: sympy.Expr) -> torch.dtype: ...
def maybe_profile(should_profile, *args, **kwargs) -> Generator[Incomplete]: ...
def parallel_num_threads(): ...
def get_backend_num_stages(): ...
def get_device_tflops(dtype): ...
def get_gpu_dram_gbps() -> int: ...
def get_gpu_shared_memory() -> int: ...
def is_welford_reduction(reduction_type: str) -> bool: ...
def reduction_num_outputs(reduction_type: str) -> int: ...
def is_linux() -> bool: ...
def is_windows() -> bool: ...
def has_free_symbols(itr: Iterable[Any]) -> bool: ...
def is_dynamic(*args) -> bool: ...

class Placeholder(enum.Enum):
    KERNEL_NAME = 'KERNEL_NAME'
    DESCRIPTIVE_NAME = 'DESCRIPTIVE_NAME'

def pass_execution_and_save(func, gm, inp, msg) -> None: ...
def is_collective(node, op: Incomplete | None = None): ...
def is_wait(node): ...
def contains_collective(snode): ...
def contains_wait(snode): ...
def is_fallback_op(node, op): ...
def buf_name_to_fused_snode(buf_name, name_to_buf, name_to_fused_node): ...
def find_recursive_deps_of_node(snode, collected_node_set, name_to_buf, name_to_fused_node, criteria_cb: Incomplete | None = None) -> None: ...
def find_recursive_users_of_node(snode, collected_node_set, name_to_buf, name_to_fused_node, criteria_cb: Incomplete | None = None) -> None: ...
def num_fw_fixed_arguments(dynamo_gm_num_inputs: int, aot_fw_gm_num_inputs: int): ...
def count_tangents(fx_g: torch.fx.GraphModule): ...

@dataclasses.dataclass
class BoxedBool:
    value: bool
    def __bool__(self) -> bool: ...
    @staticmethod
    def disable(obj): ...

def collect_defined_kernels(kernel_list) -> Generator[None, None, Incomplete]: ...
def get_cloned_parameter_buffer_name(name: str): ...
def is_gpu(device: str | None): ...
def device_need_guard(device: str): ...
def needs_fallback_due_to_atomic_add_limitations(dtype): ...
def use_scatter_fallback(op_overload: torch._ops.OpOverload, reduction_type, self_dtype, src_dtype, src_device_type, src_is_tensor): ...
def dump_node_schedule(node_schedule) -> None: ...
def tensor_is_aligned(tensor: torch.Tensor): ...
def should_assume_input_aligned(example_input: torch.Tensor): ...
def maybe_get_suppress_shape_guards_ctx(): ...
def run_and_get_cpp_code(fn, *args, **kwargs): ...
def shape_env_from_inputs(inputs: Sequence[InputType]): ...
def align_inputs_from_check_idxs(model: Callable[[list[InputType]], Any], inputs_to_check: Sequence[int]) -> Callable[[list[InputType]], Any]: ...
def clone_preserve_strides(x: torch.Tensor): ...
def copy_misaligned_inputs(new_inputs: list[InputType], check_inputs_idxs: Sequence[int]) -> None: ...
def remove_unaligned_input_idxs(inputs: Sequence[InputType], static_input_idxs: Sequence[int]) -> Sequence[int]: ...
def expr_fits_within_32bit(e: sympy.Expr): ...
def set_tracing_context_output_strides(example_inputs, compiled_graph): ...
def should_use_remote_fx_graph_cache(): ...
def normalize_name(name: str) -> str: ...
def triton_type(dtype: torch.dtype) -> str: ...
def triton_type_to_torch(dtype: str) -> torch.dtype: ...
def is_same_tensor(data: torch.Tensor, value: torch.Tensor): ...
def is_same_mkldnn_tensor(data: torch.Tensor, value: torch.Tensor): ...
def boolean_ops(): ...

@dataclasses.dataclass
class OpDtypeRule:
    type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND
    override_return_dtype: torch.dtype | None

op_dtype_propagation_rules: dict[str, OpDtypeRule]

def register_op_dtype_propagation_rules(name, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND, override_return_dtype: torch.dtype | None): ...
def upcast_compute_type(dtype: torch.dtype) -> torch.dtype: ...
@dataclass_transform(frozen_default=True)
def ir_dataclass(cls: Incomplete | None = None, /, *, frozen: bool = True): ...
def get_donated_idxs() -> list[int] | None: ...
