from .ops_handler import KernelFormatterHandler as KernelFormatterHandler, MockHandler as MockHandler, OpsHandler as OpsHandler, ReductionType as ReductionType, StoreMode as StoreMode, WrapperHandler as WrapperHandler
from _typeshed import Incomplete
from torch._inductor.choices import InductorChoices as InductorChoices
from torch._inductor.codegen.cpp_utils import LocalBufferContext as LocalBufferContext
from torch._inductor.debug import DebugContext as DebugContext
from torch._inductor.graph import GraphLowering as GraphLowering
from torch._inductor.loop_body import InterpreterShim as InterpreterShim
from torch._subclasses import FakeTensorMode as FakeTensorMode
from typing import Any, Callable, Generic, TypeVar

threadlocal: Incomplete
T = TypeVar('T')

class NullHandler: ...

class Virtualized(Generic[T]):
    def __init__(self, vname: str, default: Callable[[], T] | type[NullHandler]) -> None: ...
    def __getattr__(self, name: str) -> Any: ...

class NullKernelHandler(NullHandler):
    removed_buffers: Incomplete
    inplaced_to_remove: Incomplete
    index_dtype: str
    def __init__(self) -> None: ...

class OpsValue:
    value: Any
    def __init__(self, value) -> None: ...
    def __add__(self, other): ...
    def __mul__(self, other): ...
    def __sub__(self, other): ...
    def __neg__(self): ...
    def __truediv__(self, other): ...
    def __floordiv__(self, other): ...
    def __mod__(self, other): ...
    def __pow__(self, other): ...
    def __lt__(self, other): ...
    def __le__(self, other): ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def __gt__(self, other): ...
    def __ge__(self, other): ...
    def __and__(self, other): ...
    def __or__(self, other): ...
    def __xor__(self, other): ...
    def __invert__(self): ...
    def __rshfit__(self, n): ...
    def __lshift__(self, n): ...

class OpsWrapper:
    def __getattr__(self, name): ...
    @staticmethod
    def indirect_indexing(index, size, check: bool = True, wrap_neg: bool = True): ...

ops: Incomplete

class _V:
    MockHandler = MockHandler
    KernelFormatterHandler = KernelFormatterHandler
    WrapperHandler = WrapperHandler
    set_ops_handler: Callable[[Any], Any]
    get_ops_handler: Callable[[], Any]
    set_graph_handler: Callable[[GraphLowering], Any]
    set_real_inputs: Callable[[Any], Any]
    get_real_inputs: Callable[[], Any]
    set_fake_mode: Callable[[Any], Any]
    get_fake_mode: Callable[[], Any]
    set_kernel_handler: Callable[[Any], Any]
    set_debug_handler: Callable[[Any], Any]
    set_interpreter_handler: Callable[[Any], Any]
    set_aot_compilation: Callable[[bool], Any]
    get_aot_compilation: Callable[[], Any]
    set_current_node: Callable[[Any], Any]
    get_current_node: Callable[[], Any]
    set_local_buffer_context: Callable[[Any], Any]
    get_local_buffer_context: Callable[[], Any]
    set_choices_handler: Callable[[Any], Any]
    @property
    def ops(self) -> OpsHandler[Any]: ...
    @property
    def graph(self) -> GraphLowering: ...
    @property
    def real_inputs(self): ...
    @property
    def fake_mode(self): ...
    @property
    def kernel(self): ...
    @property
    def debug(self): ...
    @property
    def interpreter(self): ...
    @property
    def aot_compilation(self): ...
    @property
    def current_node(self): ...
    @property
    def local_buffer_context(self): ...
    @property
    def choices(self) -> InductorChoices: ...

V: Incomplete
