import torch
import weakref
from . import autograd as autograd, utils as utils
from _typeshed import Incomplete
from torch import Tensor as Tensor
from torch.utils._exposed_in import exposed_in as exposed_in
from typing import Any, Callable, Iterable, Sequence

device_types_t = str | Sequence[str] | None
log: Incomplete

def custom_op(name: str, fn: Callable | None = None, /, *, mutates_args: str | Iterable[str], device_types: device_types_t = None, schema: str | None = None) -> Any: ...

class CustomOpDef:
    def __init__(self, namespace: str, name: str, schema: str, fn: Callable) -> None: ...
    def set_kernel_enabled(self, device_type: str, enabled: bool = True): ...
    def register_kernel(self, device_types: device_types_t, fn: Callable | None = None, /) -> Callable: ...
    def register_fake(self, fn: Callable, /) -> Callable: ...
    def register_torch_dispatch(self, torch_dispatch_class: Any, fn: Callable | None = None, /) -> Callable: ...
    def register_autograd(self, backward: Callable, /, *, setup_context: Callable | None = None) -> None: ...
    def __call__(self, *args, **kwargs): ...
    def register_vmap(self, func: Callable | None = None): ...

def increment_version(val: Any) -> None: ...

OPDEF_TO_LIB: dict[str, 'torch.library.Library']
OPDEFS: weakref.WeakValueDictionary

def get_library_allowing_overwrite(namespace: str, name: str) -> torch.library.Library: ...
