import torch
from _typeshed import Incomplete
from torch import Tensor

__all__ = ['lobpcg']

class LOBPCGAutogradFunction(torch.autograd.Function):
    @staticmethod
    def forward(ctx, A: Tensor, k: int | None = None, B: Tensor | None = None, X: Tensor | None = None, n: int | None = None, iK: Tensor | None = None, niter: int | None = None, tol: float | None = None, largest: bool | None = None, method: str | None = None, tracker: None = None, ortho_iparams: dict[str, int] | None = None, ortho_fparams: dict[str, float] | None = None, ortho_bparams: dict[str, bool] | None = None) -> tuple[Tensor, Tensor]: ...
    @staticmethod
    def backward(ctx, D_grad, U_grad): ...

def lobpcg(A: Tensor, k: int | None = None, B: Tensor | None = None, X: Tensor | None = None, n: int | None = None, iK: Tensor | None = None, niter: int | None = None, tol: float | None = None, largest: bool | None = None, method: str | None = None, tracker: None = None, ortho_iparams: dict[str, int] | None = None, ortho_fparams: dict[str, float] | None = None, ortho_bparams: dict[str, bool] | None = None) -> tuple[Tensor, Tensor]: ...

class LOBPCG:
    A: Incomplete
    B: Incomplete
    iK: Incomplete
    iparams: Incomplete
    fparams: Incomplete
    bparams: Incomplete
    method: Incomplete
    tracker: Incomplete
    X: Incomplete
    E: Incomplete
    R: Incomplete
    S: Incomplete
    tvars: dict[str, Tensor]
    ivars: dict[str, int]
    fvars: dict[str, float]
    bvars: dict[str, bool]
    def __init__(self, A: Tensor | None, B: Tensor | None, X: Tensor, iK: Tensor | None, iparams: dict[str, int], fparams: dict[str, float], bparams: dict[str, bool], method: str, tracker: None) -> None: ...
    def update(self) -> None: ...
    def update_residual(self) -> None: ...
    def update_converged_count(self): ...
    def stop_iteration(self): ...
    def run(self) -> None: ...
    def call_tracker(self) -> None: ...
