from ._normalizations import ArrayLike as ArrayLike, AxisLike as AxisLike, DTypeLike as DTypeLike, KeepDims as KeepDims, NotImplementedType as NotImplementedType, OutArray as OutArray
from _typeshed import Incomplete

def count_nonzero(a: ArrayLike, axis: AxisLike = None, *, keepdims: KeepDims = False): ...
def argmax(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, *, keepdims: KeepDims = False): ...
def argmin(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, *, keepdims: KeepDims = False): ...
def any(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, keepdims: KeepDims = False, *, where: NotImplementedType = None): ...
def all(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, keepdims: KeepDims = False, *, where: NotImplementedType = None): ...
def amax(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, keepdims: KeepDims = False, initial: NotImplementedType = None, where: NotImplementedType = None): ...
max = amax

def amin(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, keepdims: KeepDims = False, initial: NotImplementedType = None, where: NotImplementedType = None): ...
min = amin

def ptp(a: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, keepdims: KeepDims = False): ...
def sum(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None, keepdims: KeepDims = False, initial: NotImplementedType = None, where: NotImplementedType = None): ...
def prod(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None, keepdims: KeepDims = False, initial: NotImplementedType = None, where: NotImplementedType = None): ...
product = prod

def mean(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None, keepdims: KeepDims = False, *, where: NotImplementedType = None): ...
def std(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None, ddof: int = 0, keepdims: KeepDims = False, *, where: NotImplementedType = None): ...
def var(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None, ddof: int = 0, keepdims: KeepDims = False, *, where: NotImplementedType = None): ...
def cumsum(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None): ...
def cumprod(a: ArrayLike, axis: AxisLike = None, dtype: DTypeLike | None = None, out: OutArray | None = None): ...
cumproduct = cumprod

def average(a: ArrayLike, axis: Incomplete | None = None, weights: ArrayLike = None, returned: bool = False, *, keepdims: bool = False): ...
def quantile(a: ArrayLike, q: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, overwrite_input: bool = False, method: str = 'linear', keepdims: KeepDims = False, *, interpolation: NotImplementedType = None): ...
def percentile(a: ArrayLike, q: ArrayLike, axis: AxisLike = None, out: OutArray | None = None, overwrite_input: bool = False, method: str = 'linear', keepdims: KeepDims = False, *, interpolation: NotImplementedType = None): ...
def median(a: ArrayLike, axis: Incomplete | None = None, out: OutArray | None = None, overwrite_input: bool = False, keepdims: KeepDims = False): ...
