import sympy
import torch
import typing
from _typeshed import Incomplete
from enum import Enum
from torch import sym_float as sym_float, sym_int as sym_int, sym_max as sym_max
from typing import Any, Callable, Sequence, overload
from typing_extensions import TypeAlias

class _WorksWithInt(typing.Protocol):
    def __add__(self, other: Any) -> typing.Self: ...
    def __radd__(self, other: Any) -> typing.Self: ...
    def __mul__(self, other: Any) -> typing.Self: ...
    def __rmul__(self, other: Any) -> typing.Self: ...

ShapeType: TypeAlias
StrideType: TypeAlias
DimsType: TypeAlias
DimsSequenceType: TypeAlias
NumberTypeType: TypeAlias
NumberType: TypeAlias
RealNumberType: TypeAlias
Number: Incomplete
Dim = int
IntLike: Incomplete
FloatLike: Incomplete
BoolLike: Incomplete
IntWithoutSymInt = int
FloatWithoutSymFloat = float
DeviceLikeType: TypeAlias
Tensor: Incomplete
torch_function_passthrough: Incomplete
TensorLikeType: Incomplete
TensorLike: Incomplete
TensorSequenceType: TypeAlias
TensorOrNumberLikeType: TypeAlias
CustomOutParamAnnotation: str

def same_shape(a: ShapeType, b: ShapeType, *, allow_rhs_unbacked: bool = False) -> bool: ...
def compare_tensor_meta(a: TensorLikeType, b: TensorLikeType, check_sizes: bool = True, check_strides: bool = False, *, allow_rhs_unbacked: bool = False, check_conj: bool = True): ...
def check_significant_strides(a: TensorLikeType, b: TensorLikeType, *, only_cuda: bool = True) -> tuple[bool, int | None]: ...
def check_all_strides(a: TensorLikeType, b: TensorLikeType, *, only_cuda: bool = True) -> tuple[bool, int | None]: ...
def is_contiguous(a: TensorLikeType) -> bool: ...
def is_channels_last_contiguous_2d(a: Tensor) -> bool: ...
def is_channels_last_contiguous_3d(a: Tensor) -> bool: ...
def validate_memory_format(memory_format: torch.memory_format): ...
def is_contiguous_for_memory_format(a: Tensor, *, memory_format: torch.memory_format) -> bool: ...
def is_channels_last_contiguous(a: Tensor) -> bool: ...
def is_non_overlapping_and_dense(a: Tensor) -> bool: ...
def compute_elementwise_output_logical_to_physical_perm(*tensors, _skip_checks: bool = False) -> list[int]: ...
def compute_elementwise_output_strides(*tensors) -> tuple[int, ...]: ...
def apply_perm(inp, perm): ...
def invert_perm(perm): ...
def validate_dim_length(length: int): ...
def validate_shape(shape: ShapeType): ...
def validate_strides(strides: StrideType): ...
def validate_idx(rank: int, idx: int): ...
def validate_dimension_indices(rank: int, indices: DimsSequenceType): ...
def validate_exclusive_idx(rank: int, ex_idx: int): ...
def canonicalize_dim(rank: int, idx: int, wrap_scalar: bool = True) -> int: ...
@overload
def canonicalize_dims(rank: int, indices: Sequence[int], wrap_scalar: bool = True) -> tuple[int, ...]: ...
@overload
def canonicalize_dims(rank: int, indices: int, wrap_scalar: bool = True) -> int: ...
def is_valid_permutation(rank: int, perm: DimsSequenceType) -> bool: ...
def is_same_shape(a: Sequence, b: Sequence) -> bool: ...
def is_cpu_scalar_tensor(a: Any) -> bool: ...
def check_same_device(*args, allow_cpu_scalar_tensors) -> None: ...
def canonicalize_device(device: DeviceLikeType) -> torch.device: ...
def check_same_shape(*args, allow_cpu_scalar_tensors: bool): ...
def extract_shape(*args, allow_cpu_scalar_tensors: bool) -> ShapeType | None: ...
def extract_dims_from_varargs(dims: DimsSequenceType | tuple[DimsSequenceType, ...]) -> DimsSequenceType: ...
def extract_shape_from_varargs(shape: ShapeType | tuple[ShapeType], validate: bool = True) -> tuple[int, ...]: ...
def infer_size_shapes(a: ShapeType, b: ShapeType) -> tuple[int, ...]: ...
def infer_size(shape: ShapeType, numel: int) -> tuple[int, ...]: ...
def is_boolean_dtype(dtype: torch.dtype) -> bool: ...
def is_integer_dtype(dtype: torch.dtype) -> bool: ...
def is_low_precision_dtype(dtype: torch.dtype) -> bool: ...
def is_float_dtype(dtype: torch.dtype) -> bool: ...
def is_complex_dtype(dtype: torch.dtype) -> bool: ...
def is_grad_dtype(dtype: torch.dtype) -> bool: ...
def corresponding_real_dtype(dtype: torch.dtype) -> torch.dtype: ...
def corresponding_complex_dtype(dtype: torch.dtype) -> torch.dtype: ...
def dtype_to_type(dtype: torch.dtype) -> type: ...
def dtype_to_type_ctor(dtype: torch.dtype) -> Callable[[NumberType], NumberType]: ...
def type_to_dtype(typ: type) -> torch.dtype: ...
def get_dtype(x: torch.Tensor | NumberType): ...
def check_fp_or_complex(dtype: torch.dtype, fn_name: str, allow_low_precision_dtypes: bool = True): ...
def check_is_matrix(A: TensorLikeType, f_name: str, arg_name: str = 'A'): ...
def get_higher_type(a: type, b: type) -> type: ...
def get_higher_dtype(a: torch.dtype | TensorLikeType | NumberType | None, b: torch.dtype | TensorLikeType | NumberType | None) -> torch.dtype | None: ...
def check_pin_memory(pin_memory: bool): ...
def check_layout(layout: torch.layout): ...
def is_weakly_lesser_type(a: type, b: type) -> bool: ...
def can_safe_cast_to(*, cast_to: torch.dtype, cast_from: torch.dtype) -> bool: ...
def check_same_dtype(*args) -> None: ...
def get_computation_dtype(dtype: torch.dtype) -> torch.dtype: ...
def get_acc_type(dtype: torch.dtype, device: torch.device) -> torch.dtype: ...

class ELEMENTWISE_TYPE_PROMOTION_KIND(Enum):
    DEFAULT = (0,)
    NO_OPMATH = (1,)
    INT_TO_FLOAT = (2,)
    ALWAYS_BOOL = (3,)
    COMPLEX_TO_FLOAT = (4,)
    BOOL_TO_LONG = (5,)

class REDUCTION_OUTPUT_TYPE_KIND(Enum):
    SAME = (0,)
    COMPLEX_TO_FLOAT = (1,)
    KEEP_PROMOTED_TYPE = (2,)
    ALWAYS_BOOL = (3,)

class RETURN_TYPE(Enum):
    NEW = (0,)
    VIEW = (1,)
    INPLACE = (2,)
    NONE = (3,)

def number_type(x: NumberType | torch.SymInt | torch.SymFloat | torch.SymBool) -> type: ...
def expr_type(x: sympy.Basic) -> type: ...
def elementwise_dtypes(*_args, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND) -> tuple[torch.dtype, torch.dtype]: ...
def reduction_dtypes(arg, output_dtype_kind: REDUCTION_OUTPUT_TYPE_KIND, dtype: torch.dtype | None = None) -> tuple[torch.dtype, torch.dtype | None]: ...
def make_contiguous_strides_for(shape: ShapeType, row_major: bool = True) -> tuple[_IntLikeT | int, ...]: ...
def make_channels_last_1d_strides_for(shape: Sequence[_IntLikeT]) -> tuple[_IntLikeT | int, ...]: ...
def make_channels_last_2d_strides_for(shape: Sequence[_IntLikeT]) -> tuple[_IntLikeT | int, ...]: ...
def make_channels_last_3d_strides_for(shape: Sequence[_IntLikeT]) -> tuple[_IntLikeT | int, ...]: ...
def make_channels_last_strides_for(shape: Sequence[_IntLikeT]) -> tuple[_IntLikeT | int, ...]: ...
def compute_reduction_output_shape(shape: ShapeType, dimensions: Sequence) -> tuple[int, ...]: ...
def validate_no_repeating_dims(dims: Sequence): ...
def reduction_dims(shape: ShapeType, dims: Sequence | None) -> tuple[int, ...]: ...
def set_correction(unbiased: bool | None = None, correction: NumberType | None = None) -> float: ...
def compute_required_storage_length(shape: ShapeType, strides: StrideType, storage_offset: int) -> int: ...
def check_in_bounds_for_storage(a: torch.TypedStorage, shape: ShapeType, strides: StrideType, storage_offset: int): ...
def check(b: bool, s: Callable[[], str], exc_type: type[Exception] = ...) -> None: ...
def are_strides_like_channels_last(shape: Sequence[int], strides: Sequence[int]) -> bool: ...
def suggest_memory_format(x: TensorLikeType) -> torch.memory_format: ...
def prod(xs: Sequence[NumberType]) -> NumberType: ...
def is_expandable_to(shape: ShapeType, desired: ShapeType) -> bool: ...
def mask_tensor(mask: TensorLikeType, t: TensorLikeType): ...
def get_aten_op(fn: Callable, name: str): ...
def dtype_or_default(dtype: torch.dtype | None) -> torch.dtype: ...
def device_or_default(device: DeviceLikeType | None) -> DeviceLikeType: ...
def layout_or_default(layout: torch.layout | None) -> torch.layout: ...
def clone_preserve_strides(x): ...
def alert_not_deterministic(caller: str): ...

class CUDARngStateHelper:
    @staticmethod
    def get_torch_state_as_tuple(fake_mode=...): ...
    @staticmethod
    def set_torch_state_tensor(seed, offset) -> None: ...
    @staticmethod
    def set_new_offset(relative_offset) -> None: ...
