import torch
import weakref
from _typeshed import Incomplete
from dataclasses import dataclass
from torch import SymBool as SymBool, SymFloat as SymFloat, SymInt as SymInt, Tensor as Tensor
from torch._C._functorch import is_functorch_wrapped_tensor as is_functorch_wrapped_tensor, is_legacy_batchedtensor as is_legacy_batchedtensor
from torch._guards import Source as Source
from torch._library.fake_class_registry import FakeScriptObject as FakeScriptObject
from torch._logging import dtrace_structured as dtrace_structured
from torch._ops import OpOverload as OpOverload
from torch._prims_common import suggest_memory_format as suggest_memory_format
from torch._subclasses.fake_impls import contains_tensor_types as contains_tensor_types, get_fast_op_impls as get_fast_op_impls, has_meta as has_meta, op_implementations_checks as op_implementations_checks, stride_incorrect_op as stride_incorrect_op
from torch._subclasses.meta_utils import MetaConverter as MetaConverter, assert_eq as assert_eq, assert_metadata_eq as assert_metadata_eq, is_sparse_any as is_sparse_any, is_sparse_compressed as is_sparse_compressed
from torch._utils import render_call as render_call
from torch.fx.experimental.symbolic_shapes import ShapeEnv as ShapeEnv, SymbolicContext as SymbolicContext
from torch.fx.immutable_collections import immutable_dict as immutable_dict
from torch.fx.operator_schemas import normalize_function as normalize_function
from torch.multiprocessing.reductions import StorageWeakRef as StorageWeakRef
from torch.overrides import TorchFunctionMode as TorchFunctionMode
from torch.types import IntLikeType as IntLikeType, py_sym_types as py_sym_types
from torch.utils._backport_slots import dataclass_slots as dataclass_slots
from torch.utils._mode_utils import no_dispatch as no_dispatch
from torch.utils._python_dispatch import TorchDispatchMode as TorchDispatchMode, is_traceable_wrapper_subclass as is_traceable_wrapper_subclass
from torch.utils._pytree import KeyPath as KeyPath, PyTree as PyTree, TreeSpec as TreeSpec, keystr as keystr, tree_map as tree_map, tree_map_ as tree_map_
from torch.utils._stats import count as count
from torch.utils._traceback import CapturedTraceback as CapturedTraceback
from types import TracebackType
from typing import Any, Generator, Literal, Mapping, Sequence, TypeVar
from typing_extensions import Self, TypeGuard
from weakref import ReferenceType

log: Incomplete
not_implemented_log: Incomplete

class _Unassigned: ...
DimList = list
pytree: Incomplete
T = TypeVar('T')
aten: Incomplete
CONSTANT_NUMEL_LIMIT: int
RECURSION_COUNT: int

class IncrementRecursionCount:
    def __init__(self) -> None: ...
    def __del__(self) -> None: ...

@dataclass
class UnsupportedFakeTensorException(RuntimeError):
    reason: str

@dataclass
class DynamicOutputShapeException(RuntimeError):
    func: OpOverload

@dataclass
class DataDependentOutputException(RuntimeError):
    func: OpOverload

@dataclass
class UnsupportedOperatorException(RuntimeError):
    func: OpOverload

@dataclass
class MetadataMismatchError(RuntimeError):
    reason: str

def ordered_set(*items: T) -> dict[T, Literal[True]]: ...
def unset_fake_temporarily() -> Generator[TorchDispatchMode | None, None, None]: ...
def get_plain_tensors(subclass: Tensor, *, out: list[Tensor | int | SymInt]) -> list[Tensor | int | SymInt]: ...
def is_fake(x: object) -> TypeGuard[Tensor]: ...
def maybe_get_fake_mode(t: object) -> FakeTensorMode | None: ...
def get_schema_info(func: OpOverload) -> torch._C._SchemaInfo: ...
def torch_decomp_decompositions(func: OpOverload) -> bool: ...
def tree_flatten_only(ty: type[T], tree: PyTree) -> list[T]: ...

class FakeTensorConverter:
    @property
    def tensor_memo(self) -> weakref.WeakValueDictionary: ...
    meta_converter: MetaConverter
    constant_storage_mapping: dict[StorageWeakRef, list[ReferenceType]]
    export: bool
    def __init__(self, *, copy_data: bool = False, export: bool = False) -> None: ...
    def add_constant_storage_mapping(self, fake_tensor: FakeTensor) -> None: ...
    def invalidate_constant_aliases(self, tensor: Tensor) -> None: ...
    def set_tensor_memo(self, t: Tensor, v: FakeTensor) -> None: ...
    def from_real_tensor(self, fake_mode: FakeTensorMode, t: Tensor, make_constant: bool = False, shape_env: ShapeEnv | None = None, *, source: Source | None = None, symbolic_context: SymbolicContext | None = None, trace: bool = True) -> FakeTensor: ...
    def from_meta_and_device(self, fake_mode: FakeTensorMode, t: Tensor, device: torch.device) -> FakeTensor: ...

def init_gpu_context(device: torch.device) -> None: ...
def in_kernel_invocation_manager(fake_mode: FakeTensorMode) -> Generator[None, None, None]: ...
def should_allow_numbers_as_tensors(func: OpOverload) -> bool: ...

class FakeTensorConfig:
    debug: Incomplete

class SymNumberMemoDescriptor:
    def __init__(self, *, is_nested_int: bool = False) -> None: ...
    def __set_name__(self, owner: str, name: str) -> None: ...
    def __get__(self, obj: FakeTensor, objtype: type[FakeTensor] | None = None) -> torch.SymInt | torch.SymFloat | None: ...
    def __set__(self, obj: FakeTensor, value: torch.SymInt | torch.SymFloat | None) -> None: ...

class FakeTensor(Tensor):
    fake_device: torch.device
    fake_mode: FakeTensorMode
    constant: Tensor | None
    real_tensor: Tensor | None
    nonzero_memo: Incomplete
    item_memo: Incomplete
    unique_memo: Incomplete
    nested_int_memo: Incomplete
    @property
    def device(self) -> torch.device: ...
    @device.setter
    def device(self, _: torch.device) -> None: ...
    @property
    def names(self) -> list[str]: ...
    @names.setter
    def names(self, _: list[str]) -> None: ...
    @staticmethod
    def __new__(cls, fake_mode: FakeTensorMode, elem: Tensor, device: torch.device, constant: Tensor | None = None, real_tensor: Tensor | None = None) -> Self: ...
    def __init__(self, *args: object, **kwargs: object) -> None: ...
    @staticmethod
    def from_tensor(t: Tensor, fake_mode: FakeTensorMode) -> FakeTensor: ...
    @classmethod
    def __torch_dispatch__(cls, func: OpOverload, types: Sequence[type], args: Sequence[object] = (), kwargs: Mapping[str, object] = ...) -> object: ...
    def get_nested_int(self, *, coeff: int | torch.SymInt = 1) -> torch.SymInt: ...
    def tolist(self) -> Any: ...

@dataclass
class TensorMetadata:
    dtype: torch.dtype
    shape: tuple[_MetadataIntLike, ...]
    stride: tuple[_MetadataIntLike, ...]
    device: torch.device
    layout: torch.layout
    memory_format: torch.memory_format | None
    storage_offset: _MetadataIntLike
    storage_bytes: _MetadataIntLike | None
    requires_grad: bool
    is_quantized: bool
    is_conj: bool
    is_neg: bool
    is_inference: bool
    is_sparse: bool
    is_coalesced: bool | None
    dense_dim: int | None
    sparse_dim: int | None

def extract_tensor_metadata(t: Tensor) -> TensorMetadata: ...

@dataclass
class _DispatchCacheKey:
    key: tuple[object, ...]
    hashvalue: int
    def __init__(self, tup: tuple[object, ...]) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def strip_shape_env(self) -> None: ...

@dataclass(frozen=True)
class _DispatchCacheEntryOutputInfo:
    inplace_idx: int | None
    metadata: TensorMetadata | None
    view_idx: int | None

@dataclass(frozen=True)
class _DispatchCacheEntry:
    output_infos: tuple[_DispatchCacheEntryOutputInfo]
    is_output_tuple: bool = ...

@dataclass(frozen=True)
class _BypassDispatchCache(Exception):
    reason: str

@dataclass(frozen=True)
class DispatchCacheInfo:
    hits: int
    misses: int
    bypasses: dict[str, int]
    size: int

class FakeTensorMode(TorchDispatchMode):
    cache: dict[_DispatchCacheKey, _DispatchCacheEntry]
    cache_hits: int
    cache_misses: int
    cache_bypasses: dict[str, int]
    epoch: int
    in_kernel_invocation: bool
    static_shapes: bool
    shape_env: ShapeEnv | None
    allow_meta: bool
    nt_tensor_id_counter: int
    nt_tensor_id_initial_count: int
    allow_fallback_kernels: Incomplete
    propagate_real_tensors: Incomplete
    fake_tensor_converter: Incomplete
    allow_scalar_outputs: bool
    cache_enabled: Incomplete
    cache_crosscheck_enabled: Incomplete
    allow_non_fake_inputs: Incomplete
    enter_stack: list[tuple[bool, TorchDispatchMode | None, bool | None]]
    def __init__(self, *, allow_fallback_kernels: bool = True, allow_non_fake_inputs: bool = False, shape_env: ShapeEnv | None = None, static_shapes: bool | None = None, export: bool = False) -> None: ...
    def reset_nt_tensor_id_counter(self) -> None: ...
    def is_our_fake(self, t: object) -> TypeGuard[FakeTensor]: ...
    @property
    def avoid_device_init(self) -> bool: ...
    @property
    def stack(self) -> str: ...
    def __torch_dispatch__(self, func: OpOverload, types: Sequence[type], args: Sequence[object] = (), kwargs: Mapping[str, object] = ...) -> object: ...
    def __enter__(self) -> Self: ...
    def __exit__(self, a: type[BaseException] | None, b: BaseException | None, c: TracebackType | None) -> None: ...
    @classmethod
    def is_infra_mode(cls) -> bool: ...
    @classmethod
    def cache_info(cls) -> DispatchCacheInfo: ...
    @classmethod
    def cache_clear(cls) -> None: ...
    def dispatch(self, func: OpOverload, types: Sequence[type], args: Sequence[object] = (), kwargs: Mapping[str, object] = ...) -> object: ...
    def can_run_unsafe_fallback(self, func: OpOverload) -> bool: ...
    def validate_and_convert_non_fake_tensors(self, func: OpOverload, converter: FakeTensorConverter, flat_args: Sequence[object], args_spec: TreeSpec) -> tuple[list[object], list[FakeTensor]]: ...
    def wrap_meta_outputs_with_default_device_logic(self, r: object, func: OpOverload, flat_args: Sequence[object], device: torch.device) -> PyTree: ...
    def create_symbolic_nested_int(self, *, nt_tensor_id: int | None = None) -> torch.SymInt: ...
    def cpp_meta_supports_symint(self, func: OpOverload) -> bool: ...
    lift_fns: Incomplete
    def may_turn_const(self, t: Tensor) -> bool: ...
    def invalidate_written_to_constants(self, func: OpOverload, flat_arg_fake_tensors: Sequence[FakeTensor], args: Sequence[object], kwargs: Mapping[str, object]) -> None: ...
    def from_tensor(self, tensor: Tensor, *, static_shapes: bool | None = None, source: Source | None = None, symbolic_context: SymbolicContext | None = None, trace: bool = True) -> FakeTensor: ...

def run_fallback_kernel(fake_mode: FakeTensorMode, func: OpOverload, flat_args: Sequence[object], args_spec: PyTree, orig_not_implemented_exception: RuntimeError) -> FakeTensor: ...

class FakeCopyMode(TorchFunctionMode):
    fake_mode: Incomplete
    def __init__(self, fake_mode: FakeTensorMode) -> None: ...
    def __torch_function__(self, func: OpOverload, types: Sequence[type], args: Sequence[object] = (), kwargs: Mapping[str, object] | None = None) -> FakeTensor: ...

def dump_cache_stats() -> None: ...
def inferred_fake_kernel_from_real_out(mode: FakeTensorMode, op: torch._ops.OpOverload, real_out: Any) -> Any: ...
