import abc
import torch
from _typeshed import Incomplete
from abc import ABC, abstractmethod
from torch._subclasses.meta_utils import is_sparse_any as is_sparse_any
from torch.utils._python_dispatch import TorchDispatchMode as TorchDispatchMode, return_and_correct_aliasing as return_and_correct_aliasing
from typing import Any, Callable, ContextManager

not_implemented_log: Incomplete

class FunctionalTensor(torch.Tensor):
    elem: torch.Tensor
    metadata_fns: Incomplete
    def __new__(cls, elem, mode): ...
    def __torch_dispatch__(self, func, types, args=(), kwargs: Incomplete | None = None): ...
    @staticmethod
    def to_functional(x): ...
    def from_functional(self): ...
    def is_base_tensor(self) -> bool: ...
    def replace_(self, output) -> None: ...
    def commit_update(self) -> None: ...
    def sync(self) -> None: ...
    def mark_mutation_hidden_from_autograd(self) -> None: ...
    def tolist(self) -> Any: ...
    def to(self, *args, **kwargs): ...
    def cuda(self, device: Incomplete | None = None, *args, **kwargs): ...
    char: Incomplete
    cpu: Incomplete
    bfloat16: Incomplete
    byte: Incomplete
    double: Incomplete
    float: Incomplete
    bool: Incomplete
    half: Incomplete
    int: Incomplete
    long: Incomplete
    def to_dense(self): ...
    @property
    def layout(self): ...
    def __bool__(self) -> bool: ...

class FunctionalTensorMode(TorchDispatchMode):
    export: Incomplete
    is_on_stack: bool
    enter_stack: Incomplete
    pre_dispatch: Incomplete
    def __init__(self, pre_dispatch: bool = False, export: bool = False, _allow_token_discovery: bool = False) -> None: ...
    def __enter__(self): ...
    def __exit__(self, a: type[BaseException] | None, b: BaseException | None, c: types.TracebackType | None) -> None: ...
    def __torch_dispatch__(self, func, types, args=(), kwargs: Incomplete | None = None): ...
    @classmethod
    def is_infra_mode(cls) -> bool: ...

def disable_functional_mode(): ...
def dispatch_functionalize(func, mode: FunctionalTensorMode = ...): ...

class BaseFunctionalizeAPI(ABC, metaclass=abc.ABCMeta):
    @abstractmethod
    def wrap_tensors(self, args: tuple[Any]) -> tuple[Any]: ...
    @abstractmethod
    def unwrap_tensors(self, args: torch.Tensor | tuple[torch.Tensor, ...]) -> Any: ...
    @abstractmethod
    def functionalize(self, inner_f: Callable) -> Callable: ...
    @abstractmethod
    def redispatch_to_next(self) -> ContextManager: ...
    @abstractmethod
    def replace(self, input_tensor, output_tensor) -> None: ...
    @abstractmethod
    def commit_update(self, tensor) -> None: ...
    @abstractmethod
    def sync(self, tensor) -> None: ...
    @abstractmethod
    def mark_mutation_hidden_from_autograd(self, tensor) -> None: ...

class PythonFunctionalizeAPI(BaseFunctionalizeAPI):
    mode: Incomplete
    pre_dispatch: Incomplete
    def __init__(self, mode: FunctionalTensorMode | None = None, pre_dispatch: bool = False) -> None: ...
    def wrap_tensors(self, args: tuple[Any]) -> tuple[Any]: ...
    def unwrap_tensors(self, args: torch.Tensor | tuple[torch.Tensor, ...] | list[torch.Tensor]) -> Any: ...
    def functionalize(self, inner_f: Callable) -> Callable: ...
    def redispatch_to_next(self) -> ContextManager: ...
    def replace(self, input_tensor, output_tensor) -> None: ...
    def commit_update(self, tensor) -> None: ...
    def sync(self, tensor) -> None: ...
    def mark_mutation_hidden_from_autograd(self, tensor) -> None: ...

class CppFunctionalizeAPI(BaseFunctionalizeAPI):
    def wrap_tensors(self, args: tuple[Any]) -> tuple[Any]: ...
    def unwrap_tensors(self, args: torch.Tensor | tuple[torch.Tensor, ...]) -> torch.Tensor | tuple[torch.Tensor, ...]: ...
    def functionalize(self, inner_f: Callable) -> Callable: ...
    def redispatch_to_next(self) -> ContextManager: ...
    def replace(self, input_tensor, output_tensor) -> None: ...
    def commit_update(self, tensor) -> None: ...
    def sync(self, tensor) -> None: ...
    def mark_mutation_hidden_from_autograd(self, tensor) -> None: ...

class FunctorchFunctionalizeAPI(BaseFunctionalizeAPI):
    interpreter: Incomplete
    def __init__(self, interpreter) -> None: ...
    def wrap_tensors(self, args: tuple[Any]) -> tuple[Any]: ...
    def unwrap_tensors(self, args: torch.Tensor | tuple[torch.Tensor, ...]) -> torch.Tensor | tuple[torch.Tensor, ...]: ...
    def functionalize(self, inner_f: Callable) -> Callable: ...
    def redispatch_to_next(self) -> ContextManager: ...
    def replace(self, input_tensor, output_tensor) -> None: ...
    def commit_update(self, tensor) -> None: ...
    def sync(self, tensor) -> None: ...
    def mark_mutation_hidden_from_autograd(self, tensor) -> None: ...

def mb_unwrap_functional_tensor(tensor: torch.Tensor): ...
