import enum
import torch
from _typeshed import Incomplete
from torch._namedtensor_internals import check_serializing_named_tensor as check_serializing_named_tensor, is_ellipsis as is_ellipsis, resolve_ellipsis as resolve_ellipsis, single_ellipsis_index as single_ellipsis_index, unzip_namedshape as unzip_namedshape, update_names as update_names
from torch.overrides import get_default_nowrap_functions as get_default_nowrap_functions, handle_torch_function as handle_torch_function, has_torch_function as has_torch_function, has_torch_function_unary as has_torch_function_unary, has_torch_function_variadic as has_torch_function_variadic
from typing import Any

class Tensor(torch._C.TensorBase):
    def __deepcopy__(self, memo): ...
    def __reduce_ex__(self, proto): ...
    def storage(self): ...
    def backward(self, gradient: Incomplete | None = None, retain_graph: Incomplete | None = None, create_graph: bool = False, inputs: Incomplete | None = None): ...
    def register_hook(self, hook): ...
    def register_post_accumulate_grad_hook(self, hook): ...
    def reinforce(self, reward): ...
    detach: Incomplete
    detach_: Incomplete
    def is_shared(self): ...
    def share_memory_(self): ...
    def module_load(self, other, assign: bool = False): ...
    def __reversed__(self): ...
    def norm(self, p: float | str | None = 'fro', dim: Incomplete | None = None, keepdim: bool = False, dtype: Incomplete | None = None): ...
    def solve(self, other): ...
    def lstsq(self, other): ...
    def eig(self, eigenvectors: bool = False): ...
    def symeig(self, eigenvectors: bool = False): ...
    def lu(self, pivot: bool = True, get_infos: bool = False): ...
    def stft(self, n_fft: int, hop_length: int | None = None, win_length: int | None = None, window: Tensor | None = None, center: bool = True, pad_mode: str = 'reflect', normalized: bool = False, onesided: bool | None = None, return_complex: bool | None = None): ...
    def istft(self, n_fft: int, hop_length: int | None = None, win_length: int | None = None, window: Tensor | None = None, center: bool = True, normalized: bool = False, onesided: bool | None = None, length: int | None = None, return_complex: bool = False): ...
    def resize(self, *sizes): ...
    def resize_as(self, tensor): ...
    def split(self, split_size, dim: int = 0): ...
    def unique(self, sorted: bool = True, return_inverse: bool = False, return_counts: bool = False, dim: Incomplete | None = None): ...
    def unique_consecutive(self, return_inverse: bool = False, return_counts: bool = False, dim: Incomplete | None = None): ...
    def __rsub__(self, other): ...
    def __rdiv__(self, other): ...
    __rtruediv__ = __rdiv__
    __itruediv__: Incomplete
    __pow__: Incomplete
    __ipow__: Incomplete
    def __rmod__(self, other): ...
    def __format__(self, format_spec) -> str: ...
    def __rpow__(self, other): ...
    def __floordiv__(self, other): ...
    def __rfloordiv__(self, other): ...
    def __rlshift__(self, other): ...
    def __rrshift__(self, other): ...
    def __rmatmul__(self, other): ...
    __pos__: Incomplete
    __neg__: Incomplete
    __abs__: Incomplete
    def __len__(self) -> int: ...
    def __iter__(self): ...
    def __hash__(self): ...
    def __dir__(self): ...
    __array_priority__: int
    def __array__(self, dtype: Incomplete | None = None): ...
    def __array_wrap__(self, array): ...
    def __contains__(self, element: Any) -> bool: ...
    @property
    def __cuda_array_interface__(self): ...
    def storage_type(self): ...
    def refine_names(self, *names): ...
    def align_to(self, *names): ...
    def unflatten(self, dim, sizes): ...
    def rename_(self, *names, **rename_map): ...
    def rename(self, *names, **rename_map): ...
    def to_sparse_coo(self): ...
    def dim_order(self, *, ambiguity_check: bool | list[torch.memory_format] = False): ...
    @classmethod
    def __torch_function__(cls, func, types, args=(), kwargs: Incomplete | None = None): ...
    __torch_dispatch__: Incomplete
    def __dlpack__(self, stream: Incomplete | None = None): ...
    def __dlpack_device__(self) -> tuple[enum.IntEnum, int]: ...
    __module__: str
