import torch
from _typeshed import Incomplete
from enum import Enum
from typing import Any, Iterable, overload

__all__ = ['OptState', 'GradScaler']

class _MultiDeviceReplicator:
    master: Incomplete
    def __init__(self, master_tensor: torch.Tensor) -> None: ...
    def get(self, device: torch.device) -> torch.Tensor: ...

class OptState(Enum):
    READY = 0
    UNSCALED = 1
    STEPPED = 2

class GradScaler:
    def __init__(self, device: str = 'cuda', init_scale: float = ..., growth_factor: float = 2.0, backoff_factor: float = 0.5, growth_interval: int = 2000, enabled: bool = True) -> None: ...
    @overload
    def scale(self, outputs: torch.Tensor) -> torch.Tensor: ...
    @overload
    def scale(self, outputs: list[torch.Tensor]) -> list[torch.Tensor]: ...
    @overload
    def scale(self, outputs: tuple[torch.Tensor, ...]) -> tuple[torch.Tensor, ...]: ...
    @overload
    def scale(self, outputs: Iterable[torch.Tensor]) -> Iterable[torch.Tensor]: ...
    def unscale_(self, optimizer: torch.optim.Optimizer) -> None: ...
    def step(self, optimizer: torch.optim.Optimizer, *args: Any, **kwargs: Any) -> float | None: ...
    def update(self, new_scale: float | torch.Tensor | None = None) -> None: ...
    def get_scale(self) -> float: ...
    def get_growth_factor(self) -> float: ...
    def set_growth_factor(self, new_factor: float) -> None: ...
    def get_backoff_factor(self) -> float: ...
    def set_backoff_factor(self, new_factor: float) -> None: ...
    def get_growth_interval(self) -> int: ...
    def set_growth_interval(self, new_interval: int) -> None: ...
    def is_enabled(self) -> bool: ...
    def state_dict(self) -> dict[str, Any]: ...
    def load_state_dict(self, state_dict: dict[str, Any]) -> None: ...
