import torch
from .anomaly_mode import detect_anomaly as detect_anomaly, set_detect_anomaly as set_detect_anomaly
from .function import Function as Function, NestedIOFunction as NestedIOFunction
from .grad_mode import enable_grad as enable_grad, inference_mode as inference_mode, no_grad as no_grad, set_grad_enabled as set_grad_enabled, set_multithreading_enabled as set_multithreading_enabled
from .gradcheck import gradcheck as gradcheck, gradgradcheck as gradgradcheck
from .variable import Variable as Variable
from torch.types import _TensorOrTensors, _TensorOrTensorsOrGradEdge

__all__ = ['Variable', 'Function', 'backward', 'grad_mode', 'NestedIOFunction', 'detect_anomaly', 'enable_grad', 'grad', 'gradcheck', 'gradgradcheck', 'inference_mode', 'no_grad', 'set_detect_anomaly', 'set_grad_enabled', 'set_multithreading_enabled', 'variable']

def backward(tensors: _TensorOrTensors, grad_tensors: _TensorOrTensors | None = None, retain_graph: bool | None = None, create_graph: bool = False, grad_variables: _TensorOrTensors | None = None, inputs: _TensorOrTensorsOrGradEdge | None = None) -> None: ...
def grad(outputs: _TensorOrTensorsOrGradEdge, inputs: _TensorOrTensorsOrGradEdge, grad_outputs: _TensorOrTensors | None = None, retain_graph: bool | None = None, create_graph: bool = False, only_inputs: bool = True, allow_unused: bool | None = None, is_grads_batched: bool = False, materialize_grads: bool = False) -> tuple[torch.Tensor, ...]: ...
def variable(*args, **kwargs) -> None: ...

# Names in __all__ with no definition:
#   grad_mode
