from .grad_mode import _DecoratorContextManager
from _typeshed import Incomplete
from typing import Any, NamedTuple

__all__ = ['UnpackedDualTensor', 'enter_dual_level', 'exit_dual_level', 'make_dual', 'unpack_dual', 'dual_level']

def enter_dual_level(): ...
def exit_dual_level(*, level: Incomplete | None = None) -> None: ...
def make_dual(tensor, tangent, *, level: Incomplete | None = None): ...

class _UnpackedDualTensor(NamedTuple):
    primal: Incomplete
    tangent: Incomplete

class UnpackedDualTensor(_UnpackedDualTensor): ...

def unpack_dual(tensor, *, level: Incomplete | None = None): ...

class dual_level(_DecoratorContextManager):
    def __enter__(self): ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...

class _set_fwd_grad_enabled(_DecoratorContextManager):
    prev: Incomplete
    def __init__(self, mode: bool) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...
