import torch
from _typeshed import Incomplete
from torch.utils._contextlib import F, _DecoratorContextManager, _NoParamDecoratorContextManager
from typing import Any

__all__ = ['no_grad', 'enable_grad', 'set_grad_enabled', 'inference_mode', 'set_multithreading_enabled']

class no_grad(_NoParamDecoratorContextManager):
    prev: bool
    def __init__(self) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...

class enable_grad(_NoParamDecoratorContextManager):
    prev: Incomplete
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...

class set_grad_enabled(_DecoratorContextManager):
    prev: Incomplete
    mode: Incomplete
    def __init__(self, mode: bool) -> None: ...
    def __call__(self, orig_func: F) -> F: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...
    def clone(self) -> set_grad_enabled: ...

class inference_mode(_DecoratorContextManager):
    mode: Incomplete
    def __init__(self, mode: bool = True) -> None: ...
    def __new__(cls, mode: bool = True): ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...
    def clone(self) -> inference_mode: ...

class set_multithreading_enabled(_DecoratorContextManager):
    prev: Incomplete
    mode: Incomplete
    def __init__(self, mode: bool) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...
    def clone(self) -> set_multithreading_enabled: ...

class _force_original_view_tracking(_DecoratorContextManager):
    prev: Incomplete
    mode: Incomplete
    def __init__(self, mode: bool) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...
    def clone(self): ...

class _unsafe_preserve_version_counter(_DecoratorContextManager):
    tensor: Incomplete
    prev_version: Incomplete
    def __init__(self, tensor: torch.Tensor) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, *args) -> None: ...
