import torch
from _typeshed import Incomplete
from torch.types import _TensorOrTensors
from typing import Callable

__all__ = ['gradcheck', 'gradgradcheck', 'GradcheckError', 'get_numerical_jacobian', 'get_analytical_jacobian', 'get_numerical_jacobian_wrt_specific_input']

class GradcheckError(RuntimeError): ...

def get_numerical_jacobian(fn, inputs, target: Incomplete | None = None, eps: float = 0.001, grad_out: float = 1.0): ...
def get_numerical_jacobian_wrt_specific_input(fn, input_idx, inputs, outputs, eps, input: Incomplete | None = None, is_forward_ad: bool = False) -> tuple[torch.Tensor, ...]: ...
def get_analytical_jacobian(inputs, output, nondet_tol: float = 0.0, grad_out: float = 1.0): ...
def gradcheck(func: Callable[..., _TensorOrTensors], inputs: _TensorOrTensors, *, eps: float = 1e-06, atol: float = 1e-05, rtol: float = 0.001, raise_exception: bool = True, nondet_tol: float = 0.0, check_undefined_grad: bool = True, check_grad_dtypes: bool = False, check_batched_grad: bool = False, check_batched_forward_grad: bool = False, check_forward_ad: bool = False, check_backward_ad: bool = True, fast_mode: bool = False, masked: bool | None = None) -> bool: ...
def gradgradcheck(func: Callable[..., _TensorOrTensors], inputs: _TensorOrTensors, grad_outputs: _TensorOrTensors | None = None, *, eps: float = 1e-06, atol: float = 1e-05, rtol: float = 0.001, gen_non_contig_grad_outputs: bool = False, raise_exception: bool = True, nondet_tol: float = 0.0, check_undefined_grad: bool = True, check_grad_dtypes: bool = False, check_batched_grad: bool = False, check_fwd_over_rev: bool = False, check_rev_over_rev: bool = True, fast_mode: bool = False, masked: bool = False) -> bool: ...
