from _typeshed import Incomplete
from contextlib import AbstractContextManager
from typing import Any

__all__ = ['is_available', 'synchronize', 'current_device', 'current_stream', 'stream', 'set_device', 'device_count', 'Stream', 'StreamContext', 'Event']

def is_available() -> bool: ...
def synchronize(device: _device_t = None) -> None: ...

class Stream:
    def __init__(self, priority: int = -1) -> None: ...
    def wait_stream(self, stream) -> None: ...

class Event:
    def query(self) -> bool: ...
    def record(self, stream: Incomplete | None = None) -> None: ...
    def synchronize(self) -> None: ...
    def wait(self, stream: Incomplete | None = None) -> None: ...

def current_stream(device: _device_t = None) -> Stream: ...

class StreamContext(AbstractContextManager):
    cur_stream: Stream | None
    stream: Incomplete
    prev_stream: Incomplete
    def __init__(self, stream) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...

def stream(stream: Stream) -> AbstractContextManager: ...
def device_count() -> int: ...
def set_device(device: _device_t) -> None: ...
def current_device() -> str: ...
