import torch
from _typeshed import Incomplete
from torch.distributed.device_mesh import DeviceMesh as DeviceMesh
from torch.fx.experimental.proxy_tensor import get_proxy_mode as get_proxy_mode
from torch.utils._pytree import tree_map_only as tree_map_only
from typing import Any

def is_torchdynamo_compiling(): ...

RANK_TYPES: Incomplete

def wait_tensor(tensor): ...
def broadcast(self, src: int, group: RANK_TYPES, tag: str = ''): ...
def all_reduce(self, reduceOp: str, group: RANK_TYPES, tag: str = ''): ...
def all_gather_tensor(self, gather_dim: int, group: RANK_TYPES, tag: str = ''): ...
def all_gather_tensor_autograd(self, gather_dim: int, group: RANK_TYPES, tag: str = ''): ...
def reduce_scatter_tensor(self, reduceOp: str, scatter_dim: int, group: RANK_TYPES, tag: str = ''): ...
def reduce_scatter_tensor_autograd(self, reduceOp: str, scatter_dim: int, group: RANK_TYPES, tag: str = ''): ...
def all_reduce_coalesced(self, reduceOp: str, group: RANK_TYPES, tag: str = '') -> list[torch.Tensor]: ...
def all_gather_into_tensor_coalesced(self, group: RANK_TYPES, tag: str = '') -> list[torch.Tensor]: ...
def reduce_scatter_tensor_coalesced(inputs: list[torch.Tensor], reduceOp: str, scatter_dim: list[int], group: RANK_TYPES, tag: str = '') -> list[torch.Tensor]: ...
def all_to_all_single(self, output_split_sizes: list[int] | None, input_split_sizes: list[int] | None, group: RANK_TYPES, tag: str = '') -> torch.Tensor: ...
def all_to_all_single_autograd(self, output_split_sizes: list[int] | None, input_split_sizes: list[int] | None, group: RANK_TYPES, tag: str = '') -> torch.Tensor: ...
def permute_tensor(self, src_dst: list[int], group: RANK_TYPES, tag: str = '') -> torch.Tensor: ...

class AsyncCollectiveTensor(torch.Tensor):
    elem: torch.Tensor
    completed: bool
    @staticmethod
    def __new__(cls, elem: torch.Tensor): ...
    def __tensor_flatten__(self): ...
    def tolist(self): ...
    @staticmethod
    def __tensor_unflatten__(inner_tensors, meta, outer_size, outer_stride): ...
    def __coerce_same_metadata_as_tangent__(self, expected_metadata: Any, expected_type: type | None = None): ...
    def trigger_wait(self): ...
    def wait(self) -> torch.Tensor: ...
    @classmethod
    def __torch_dispatch__(cls, func, types, args=(), kwargs: Incomplete | None = None): ...
    def numpy(self): ...

class _FromTorchTensor(torch.autograd.Function):
    @staticmethod
    def forward(ctx, input: torch.Tensor) -> torch.Tensor: ...
    @staticmethod
    def backward(ctx, grad_output: torch.Tensor) -> torch.Tensor: ...

def allow_inflight_collective_as_graph_input_ctx(value: bool = True): ...

lib_impl: Incomplete
legacy_lib: Incomplete
legacy_lib_impl: Incomplete
ops_defs: Incomplete
my_module: Incomplete
op_name: Incomplete
backend_impl: Incomplete

def all_gather_tensor_inplace(output_tensor: torch.Tensor, input_tensor: torch.Tensor, group, async_op: bool = False, tag: str = '', gather_dim: int = 0): ...
def reduce_scatter_tensor_inplace(output: torch.Tensor, input: torch.Tensor, op: str = 'sum', group: Incomplete | None = None, async_op: bool = False, scatter_dim: int = 0, tag: str = ''): ...

REDUCE_OP_TO_STR: Incomplete

def all_reduce_inplace(tensor: torch.Tensor, op: str = 'sum', group: Incomplete | None = None, async_op: bool = False, tag: str = ''): ...
def all_to_all_inplace(output: torch.Tensor, input: torch.Tensor, output_split_sizes: Incomplete | None = None, input_split_sizes: Incomplete | None = None, group: Incomplete | None = None, async_op: bool = False, tag: str = ''): ...
def all_gather_inplace(tensor_list: list[torch.Tensor], tensor: torch.Tensor, group: Incomplete | None = None, async_op: bool = False, tag: str = ''): ...

traceable_collective_remaps: Incomplete
