import torch
from torch.distributed import distributed_c10d as distributed_c10d
from torch.distributed._functional_collectives import AsyncCollectiveTensor as AsyncCollectiveTensor
from torch.distributed._shard.sharded_tensor import ShardedTensor as ShardedTensor
from torch.distributed.tensor import DTensor as DTensor, Replicate as Replicate, distribute_tensor as distribute_tensor
from torch.distributed.tensor._utils import compute_local_shape_and_global_offset as compute_local_shape_and_global_offset
from typing import Any, MutableMapping, NamedTuple

class CompanionMismatch(Exception): ...

class _TensorInfo(NamedTuple):
    size: torch.Size
    dtype: torch.dtype
PATH_ITEM = str | int
OBJ_PATH = tuple[PATH_ITEM, ...]
FLATTEN_MAPPING = dict[str, OBJ_PATH]
STATE_DICT_TYPE = dict[str, Any]
CONTAINER_TYPE = MutableMapping[PATH_ITEM, Any]
