import torch.distributed as dist
from dataclasses import dataclass
from typing import Any, Callable, Generic, TypeVar

T = TypeVar('T')

@dataclass
class SyncPayload(Generic[T]):
    stage_name: str | None
    success: bool
    payload: T
    exception: Exception | None = ...

def broadcast(data_or_fn: T | Callable[[], T], *, success: bool = True, stage_name: str | None = None, rank: int = 0, pg: dist.ProcessGroup | None = None) -> T: ...
def all_gather(data_or_fn: T | Callable[[], T], stage_name: str | None = None, pg: dist.ProcessGroup | None = None) -> list[T]: ...
def all_gather_object_enforce_type(pg: dist.ProcessGroup, object_list: list[Any], obj: Any, type_checker: Callable[[Any, Any], bool] = ...) -> None: ...
