import torch
from _typeshed import Incomplete
from torch.distributions import constraints
from torch.types import _size
from typing import Any

__all__ = ['Distribution']

class Distribution:
    has_rsample: bool
    has_enumerate_support: bool
    @staticmethod
    def set_default_validate_args(value: bool) -> None: ...
    def __init__(self, batch_shape: torch.Size = ..., event_shape: torch.Size = ..., validate_args: bool | None = None) -> None: ...
    def expand(self, batch_shape: _size, _instance: Incomplete | None = None): ...
    @property
    def batch_shape(self) -> torch.Size: ...
    @property
    def event_shape(self) -> torch.Size: ...
    @property
    def arg_constraints(self) -> dict[str, constraints.Constraint]: ...
    @property
    def support(self) -> Any | None: ...
    @property
    def mean(self) -> torch.Tensor: ...
    @property
    def mode(self) -> torch.Tensor: ...
    @property
    def variance(self) -> torch.Tensor: ...
    @property
    def stddev(self) -> torch.Tensor: ...
    def sample(self, sample_shape: _size = ...) -> torch.Tensor: ...
    def rsample(self, sample_shape: _size = ...) -> torch.Tensor: ...
    def sample_n(self, n: int) -> torch.Tensor: ...
    def log_prob(self, value: torch.Tensor) -> torch.Tensor: ...
    def cdf(self, value: torch.Tensor) -> torch.Tensor: ...
    def icdf(self, value: torch.Tensor) -> torch.Tensor: ...
    def enumerate_support(self, expand: bool = True) -> torch.Tensor: ...
    def entropy(self) -> torch.Tensor: ...
    def perplexity(self) -> torch.Tensor: ...
