import logging
import torch
from _typeshed import Incomplete
from enum import IntEnum
from torch._export.passes.insert_custom_op_guards import insert_custom_op_guards as insert_custom_op_guards
from torch.export import ExportedProgram as ExportedProgram
from torch.export.dynamic_shapes import refine_dynamic_shapes_from_suggested_fixes as refine_dynamic_shapes_from_suggested_fixes
from typing import Any

log: Incomplete

class FailureType(IntEnum):
    MISSING_FAKE_KERNEL = 1
    DATA_DEPENDENT_ERROR = 2
    CONSTRAINT_VIOLATION_ERROR = 3
    MISMATCHED_FAKE_KERNEL = 4

def prettify_stack(stack: list[dict[str, str]], str_to_filename: dict[str, str]) -> str: ...
def filter_stack(stack: list[dict[str, str]], str_to_filename: dict[str, str]) -> list[dict[str, str]]: ...
def hash_stack(stack: list[dict[str, str]]) -> str: ...

class FailureReport:
    failure_type: FailureType
    data: dict[str, Any]
    xfail: bool
    def __init__(self, failure_type: FailureType, data: dict[str, Any], xfail: bool = False) -> None: ...
    def print(self, str_to_filename: dict[str, str]) -> str: ...

class DraftExportReport:
    failures: list[FailureReport]
    str_to_filename: Incomplete
    def __init__(self, failures: list[FailureReport], str_to_filename: dict[str, str]) -> None: ...
    def successful(self) -> bool: ...
    def apply_suggested_fixes(self) -> None: ...

class CaptureStructuredTrace(logging.Handler):
    specific_log_keys: Incomplete
    logs: list[tuple[str, dict[str, Any]]]
    logger: Incomplete
    prev_get_dtrace: bool
    def __init__(self, specific_log_keys: list[str]) -> None: ...
    def __enter__(self) -> CaptureStructuredTrace: ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_value: BaseException | None, traceback: types.TracebackType | None) -> None: ...
    def emit(self, record: Any) -> None: ...

def draft_export(mod: torch.nn.Module, args: tuple[Any, ...], kwargs: dict[str, Any] | None = None, *, dynamic_shapes: dict[str, Any] | tuple[Any] | list[Any] | None = None, preserve_module_call_signature: tuple[str, ...] = (), strict: bool = False, pre_dispatch: bool = False) -> tuple[ExportedProgram, DraftExportReport]: ...
