import dataclasses
import torch
import torch.fx
import torch.utils._pytree as pytree
from ._safeguard import AutogradStateOpsFailSafeguard as AutogradStateOpsFailSafeguard
from .exported_program import ExportedProgram as ExportedProgram, InputKind as InputKind, ModuleCallEntry as ModuleCallEntry, ModuleCallSignature as ModuleCallSignature
from .graph_signature import ExportGraphSignature as ExportGraphSignature
from _typeshed import Incomplete
from torch._dispatch.python import enable_python_dispatcher as enable_python_dispatcher
from torch._dynamo.exc import UserError as UserError, UserErrorType as UserErrorType
from torch._export.db.logging import exportdb_error_message as exportdb_error_message, get_class_if_classified_error as get_class_if_classified_error
from torch._export.non_strict_utils import make_constraints as make_constraints, make_fake_inputs as make_fake_inputs, produce_guards_and_solve_constraints as produce_guards_and_solve_constraints
from torch._export.passes.collect_tracepoints_pass import CollectTracepointsPass as CollectTracepointsPass
from torch._export.passes.lift_constants_pass import ConstantAttrMap as ConstantAttrMap, lift_constants_pass as lift_constants_pass, rewrite_script_object_meta as rewrite_script_object_meta
from torch._export.utils import apply_runtime_assertion_pass as apply_runtime_assertion_pass, placeholder_naming_pass as placeholder_naming_pass, placeholder_prefixes as placeholder_prefixes
from torch._export.verifier import SpecViolationError as SpecViolationError
from torch._functorch._aot_autograd.traced_function_transforms import create_functional_call as create_functional_call
from torch._functorch._aot_autograd.utils import create_tree_flattened_fn as create_tree_flattened_fn, register_buffer_assignment_hook as register_buffer_assignment_hook
from torch._functorch.aot_autograd import aot_export_module as aot_export_module
from torch._guards import detect_fake_mode as detect_fake_mode
from torch._library.fake_class_registry import FakeScriptObject as FakeScriptObject
from torch._subclasses.fake_tensor import FakeTensor as FakeTensor, FakeTensorMode as FakeTensorMode
from torch._utils_internal import log_export_usage as log_export_usage
from torch.export.exported_program import OutputKind as OutputKind
from torch.fx.experimental.proxy_tensor import make_fx as make_fx
from torch.fx.experimental.symbolic_shapes import ConstraintViolationError as ConstraintViolationError, GuardOnDataDependentSymNode as GuardOnDataDependentSymNode, ShapeEnv as ShapeEnv, free_unbacked_symbols as free_unbacked_symbols
from torch.utils._pytree import TreeSpec as TreeSpec
from torch.utils._sympy.value_ranges import ValueRangeError as ValueRangeError
from typing import Any, Callable

log: Incomplete

@dataclasses.dataclass
class ExportDynamoConfig:
    allow_rnn: bool = ...
    reorderable_logging_functions: set[Callable] = dataclasses.field(default_factory=set)
    do_not_emit_runtime_asserts = ...

@dataclasses.dataclass
class ATenExportArtifact:
    gm: torch.fx.GraphModule
    sig: ExportGraphSignature
    constants: dict[str, torch.Tensor | FakeScriptObject | torch.ScriptObject]

@dataclasses.dataclass(frozen=True)
class ExportArtifact:
    aten: ATenExportArtifact
    out_spec: TreeSpec
    fake_mode: FakeTensorMode
    module_call_specs: dict[str, dict[str, pytree.TreeSpec]]

DEFAULT_EXPORT_DYNAMO_CONFIG: Incomplete

def get_ep_stats(ep: ExportedProgram) -> dict[str, Any]: ...
def patch_forward(obj: torch.nn.Module, new_method): ...

class _WrapperModule(torch.nn.Module):
    f: Incomplete
    def __init__(self, f) -> None: ...
    def forward(self, *args, **kwargs): ...

def set_missing_meta_vals(gm, flat_args, num_params_buffers) -> None: ...
