import dataclasses
from _typeshed import Incomplete
from enum import Enum
from torch.fx.experimental.symbolic_shapes import StrictMinMaxConstraint
from typing import Any, Callable

__all__ = ['Constraint', 'Dim', 'dims', 'refine_dynamic_shapes_from_suggested_fixes']

class _DimHint(Enum):
    AUTO = ...
    STATIC = ...
    DYNAMIC = ...

class _Dim(type):
    @staticmethod
    def readable(name, min_, max_): ...
    def __add__(cls, other): ...
    def __radd__(cls, other): ...
    def __sub__(cls, other): ...
    def __rsub__(cls, other) -> None: ...
    def __mul__(cls, other): ...
    def __rmul__(cls, other): ...

class _StaticDim(_Dim):
    @property
    def min(self): ...
    @property
    def max(self): ...

class _DerivedDim(_Dim):
    @property
    def min(self): ...
    @property
    def max(self): ...

def Dim(name: str, *, min: int | None = None, max: int | None = None): ...
def dims(*names: str, min: int | None = None, max: int | None = None): ...

@dataclasses.dataclass
class _ConstraintTarget:
    t_id: int
    dim: int

@dataclasses.dataclass
class _Constraint(_ConstraintTarget):
    name: str
    constraint_range: StrictMinMaxConstraint
    def __ge__(self, lower): ...
    def __gt__(self, lower): ...
    def __le__(self, upper): ...
    def __lt__(self, upper): ...
    def __bool__(self) -> bool: ...
    @property
    def serializable_spec(self): ...

@dataclasses.dataclass
class _PhantomRoot:
    name: str
    constraint_range: StrictMinMaxConstraint
    val: int

@dataclasses.dataclass
class _DerivedConstraint(_ConstraintTarget):
    name: str
    constraint_range: StrictMinMaxConstraint
    root: _ConstraintTarget | _PhantomRoot
    fn: Callable
    @property
    def serializable_spec(self): ...

@dataclasses.dataclass
class _RelaxedConstraint(_ConstraintTarget):
    @property
    def serializable_spec(self): ...

Constraint: Incomplete

class ShapesCollection:
    def __init__(self) -> None: ...
    def __setitem__(self, t, shape) -> None: ...
    def __getitem__(self, t): ...
    def __len__(self) -> int: ...
    def dynamic_shapes(self, m, args, kwargs: Incomplete | None = None): ...

def refine_dynamic_shapes_from_suggested_fixes(msg: str, dynamic_shapes: dict[str, Any] | tuple[Any] | list[Any]) -> dict[str, Any] | tuple[Any] | list[Any]: ...
