import torch
from _typeshed import Incomplete
from torch import Tensor
from torch._lowrank import pca_lowrank as pca_lowrank, svd_lowrank as svd_lowrank
from typing import Any, Sequence

__all__ = ['atleast_1d', 'atleast_2d', 'atleast_3d', 'align_tensors', 'broadcast_shapes', 'broadcast_tensors', 'cartesian_prod', 'block_diag', 'cdist', 'chain_matmul', 'einsum', 'istft', 'lu', 'norm', 'meshgrid', 'pca_lowrank', 'split', 'stft', 'svd_lowrank', 'tensordot', 'unique', 'unique_consecutive', 'unravel_index']

def broadcast_tensors(*tensors): ...
def broadcast_shapes(*shapes): ...
def split(tensor: Tensor, split_size_or_sections: int | list[int], dim: int = 0) -> tuple[Tensor, ...]: ...
def einsum(*args: Any) -> Tensor: ...
def meshgrid(*tensors: Tensor | list[Tensor], indexing: str | None = None) -> tuple[Tensor, ...]: ...
def stft(input: Tensor, n_fft: int, hop_length: int | None = None, win_length: int | None = None, window: Tensor | None = None, center: bool = True, pad_mode: str = 'reflect', normalized: bool = False, onesided: bool | None = None, return_complex: bool | None = None) -> Tensor: ...

istft: Incomplete
unique: Incomplete
unique_consecutive: Incomplete

def tensordot(a, b, dims: int = 2, out: torch.Tensor | None = None): ...
def cartesian_prod(*tensors: Tensor) -> Tensor: ...
def block_diag(*tensors): ...
def cdist(x1: Tensor, x2: Tensor, p: float = 2.0, compute_mode: str = 'use_mm_for_euclid_dist_if_necessary') -> Tensor: ...
def atleast_1d(*tensors): ...
def atleast_2d(*tensors): ...
def atleast_3d(*tensors): ...
def norm(input, p: float | str | None = 'fro', dim: Incomplete | None = None, keepdim: bool = False, out: Incomplete | None = None, dtype: Incomplete | None = None): ...
def unravel_index(indices: Tensor, shape: int | Sequence[int] | torch.Size) -> tuple[Tensor, ...]: ...
def chain_matmul(*matrices, out: Incomplete | None = None): ...

lu: Incomplete

def align_tensors(*tensors) -> None: ...
