import torch
from _typeshed import Incomplete
from typing import Callable, Generic, TypeVar

__all__ = ['Future', 'collect_all', 'wait_all']

T = TypeVar('T')
S = TypeVar('S')

class _PyFutureMeta(Incomplete, Incomplete): ...

class Future(torch._C.Future, Generic[T], metaclass=_PyFutureMeta):
    def __init__(self, *, devices: list[int | str | torch.device] | None = None) -> None: ...
    def done(self) -> bool: ...
    def wait(self) -> T: ...
    def value(self) -> T: ...
    def then(self, callback: Callable[[Future[T]], S]) -> Future[S]: ...
    def add_done_callback(self, callback: Callable[[Future[T]], None]) -> None: ...
    def set_result(self, result: T) -> None: ...
    def set_exception(self, result: T) -> None: ...

def collect_all(futures: list[Future]) -> Future[list[Future]]: ...
def wait_all(futures: list[Future]) -> list: ...
