import torch
from ._compatibility import compatibility as compatibility
from .graph import Graph as Graph
from .graph_module import GraphModule as GraphModule
from .node import Argument as Argument, base_types as base_types, map_aggregate as map_aggregate
from .proxy import ParameterProxy as ParameterProxy, Proxy as Proxy, Scope as Scope, ScopeContextManager as ScopeContextManager, TracerBase as TracerBase
from _typeshed import Incomplete
from torch._C import ScriptObject as ScriptObject
from torch._library.fake_class_registry import FakeScriptObject as FakeScriptObject
from types import ModuleType
from typing import Any, Callable, NamedTuple

HAS_VARSTUFF: Incomplete

def is_fx_tracing(): ...

class ProxyableClassMeta(type):
    def __init__(cls, name, bases, attrs) -> None: ...
    def __call__(cls, *args, **kwargs): ...

class PHBase: ...

PH: Incomplete

class PHWithMeta(PHBase):
    ph_key: Incomplete
    def __init__(self, ph_key: str | None = None) -> None: ...

class Tracer(TracerBase):
    param_shapes_constant: Incomplete
    submodule_paths: dict[torch.nn.Module, str] | None
    root_module_name: str
    scope: Incomplete
    module_stack: Incomplete
    num_calls: dict[str, int]
    node_name_to_scope: dict[str, tuple[str, type]]
    def __init__(self, autowrap_modules: tuple[ModuleType] = ..., autowrap_functions: tuple[Callable, ...] = (), param_shapes_constant: bool = False) -> None: ...
    def get_fresh_qualname(self, prefix: str) -> str: ...
    def create_arg(self, a: Any) -> Argument: ...
    def is_leaf_module(self, m: torch.nn.Module, module_qualified_name: str) -> bool: ...
    def path_of_module(self, mod: torch.nn.Module) -> str: ...
    def call_module(self, m: torch.nn.Module, forward: Callable[..., Any], args: tuple[Any, ...], kwargs: dict[str, Any]) -> Any: ...
    def getattr(self, attr: str, attr_val: Any, parameter_proxy_cache: dict[str, Any]): ...
    def create_args_for_root(self, root_fn, is_module, concrete_args: Incomplete | None = None): ...
    root: Incomplete
    graph: Incomplete
    tensor_attrs: dict[torch.Tensor | ScriptObject | FakeScriptObject, str]
    def trace(self, root: torch.nn.Module | Callable[..., Any], concrete_args: dict[str, Any] | None = None) -> Graph: ...
    def __deepcopy__(self, memo): ...

class _PatchedFn(NamedTuple):
    frame_dict: Any
    fn_name: str
    orig_fn: Any
    new_fn: Any
    def revert(self) -> None: ...
    def patch(self) -> None: ...

class _PatchedFnSetItem(_PatchedFn):
    def revert(self) -> None: ...
    def patch(self) -> None: ...

class _PatchedFnDel(_PatchedFn):
    def revert(self) -> None: ...
    def patch(self) -> None: ...

class _PatchedFnSetAttr(_PatchedFn):
    def revert(self) -> None: ...
    def patch(self) -> None: ...

class _Patcher:
    patches_made: list[_PatchedFn]
    visited: set[int]
    def __init__(self) -> None: ...
    def patch(self, frame_dict: dict[str, Any], name: str, new_fn: Callable, deduplicate: bool = True): ...
    def patch_method(self, cls: type, name: str, new_fn: Callable, deduplicate: bool = True): ...
    def visit_once(self, thing: Any): ...
    def revert_all_patches(self): ...
    def reapply_all_patches(self): ...
    def __enter__(self): ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_val: BaseException | None, exc_tb: types.TracebackType | None) -> None: ...

CURRENT_PATCHER: _Patcher | None

def wrap(fn_or_name: str | Callable): ...
def symbolic_trace(root: torch.nn.Module | Callable[..., Any], concrete_args: dict[str, Any] | None = None) -> GraphModule: ...
