import os
import torch
from .graph import Graph, PythonCode
from _typeshed import Incomplete
from torch.package import Importer, PackageExporter, PackageImporter
from typing import Any

__all__ = ['reduce_graph_module', 'reduce_package_graph_module', 'reduce_deploy_graph_module', 'GraphModule']

class _EvalCacheLoader:
    eval_cache: Incomplete
    next_id: int
    def __init__(self) -> None: ...
    def cache(self, src: str, globals: dict[str, Any], co_fields: Incomplete | None = None): ...
    def get_source(self, module_name) -> str | None: ...

def reduce_graph_module(body: dict[Any, Any], import_block: str) -> torch.nn.Module: ...
def reduce_package_graph_module(importer: PackageImporter, body: dict[Any, Any], generated_module_name: str) -> torch.nn.Module: ...
def reduce_deploy_graph_module(importer: PackageImporter, body: dict[Any, Any], import_block: str) -> torch.nn.Module: ...

class _CodeOnlyModule(torch.nn.Module):
    __dict__: Incomplete
    def __init__(self, body) -> None: ...

class _WrappedCall:
    cls: Incomplete
    cls_call: Incomplete
    def __init__(self, cls, cls_call) -> None: ...
    def __call__(self, obj, *args, **kwargs): ...

class GraphModule(torch.nn.Module):
    def __new__(cls, *args, **kwargs): ...
    training: Incomplete
    meta: dict[str, Any]
    def __init__(self, root: torch.nn.Module | dict[str, Any], graph: Graph, class_name: str = 'GraphModule') -> None: ...
    __jit_unused_properties__: Incomplete
    @property
    def graph(self) -> Graph: ...
    @graph.setter
    def graph(self, g: Graph) -> None: ...
    def to_folder(self, folder: str | os.PathLike, module_name: str = 'FxModule'): ...
    def add_submodule(self, target: str, m: torch.nn.Module) -> bool: ...
    def delete_submodule(self, target: str) -> bool: ...
    def delete_all_unused_submodules(self) -> None: ...
    @property
    def code(self) -> str: ...
    def recompile(self) -> PythonCode: ...
    def __reduce_deploy__(self, importer: Importer): ...
    def __reduce_package__(self, exporter: PackageExporter): ...
    def __reduce__(self): ...
    def __deepcopy__(self, memo): ...
    def __copy__(self): ...
    def print_readable(self, print_output: bool = True, include_stride: bool = False, include_device: bool = False, colored: bool = False): ...
