import torch
from .graph import Graph
from .graph_module import GraphModule
from .node import Argument, Node, Target
from .proxy import Proxy
from _typeshed import Incomplete
from typing import Any, Iterator

__all__ = ['Interpreter', 'Transformer']

class Interpreter:
    module: Incomplete
    submodules: Incomplete
    graph: Incomplete
    env: dict[Node, Any]
    name: str
    garbage_collect_values: Incomplete
    extra_traceback: bool
    user_to_last_uses: dict[Node, list[Node]]
    def __init__(self, module: torch.nn.Module, garbage_collect_values: bool = True, graph: Graph | None = None) -> None: ...
    args_iter: Iterator[Any]
    def run(self, *args, initial_env: dict[Node, Any] | None = None, enable_io_processing: bool = True) -> Any: ...
    def boxed_run(self, args_list): ...
    def run_node(self, n: Node) -> Any: ...
    def placeholder(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def get_attr(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def call_function(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def call_method(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def call_module(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def output(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def fetch_attr(self, target: str): ...
    def fetch_args_kwargs_from_env(self, n: Node) -> tuple[tuple, dict]: ...
    def map_nodes_to_values(self, args: Argument, n: Node) -> Argument: ...

class Transformer(Interpreter):
    new_graph: Incomplete
    graph: Incomplete
    tensor_attrs: dict[torch.Tensor, str]
    tracer: Incomplete
    def __init__(self, module) -> None: ...
    def placeholder(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Proxy: ...
    def get_attr(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Proxy: ...
    def call_module(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def call_function(self, target: Target, args: tuple[Argument, ...], kwargs: dict[str, Any]) -> Any: ...
    def transform(self) -> GraphModule: ...
