import torch
from .node import Argument
from typing import Any, Callable, NamedTuple

__all__ = ['ArgsKwargsPair', 'check_for_mutable_operation', 'get_signature_for_torch_op', 'create_type_hint', 'type_matches', 'normalize_function', 'normalize_module']

class ArgsKwargsPair(NamedTuple):
    args: tuple[Any, ...]
    kwargs: dict[str, Any]

class _FakeGlobalNamespace:
    def __getattr__(self, name): ...

def check_for_mutable_operation(target: Callable, args: tuple['Argument', ...], kwargs: dict[str, 'Argument']): ...
def get_signature_for_torch_op(op: Callable, return_schemas: bool = False): ...
def create_type_hint(x): ...
def type_matches(signature_type: Any, argument_type: Any): ...
def normalize_function(target: Callable, args: tuple[Any], kwargs: dict[str, Any] | None = None, arg_types: tuple[Any] | None = None, kwarg_types: dict[str, Any] | None = None, normalize_to_only_use_kwargs: bool = False) -> ArgsKwargsPair | None: ...
def normalize_module(root: torch.nn.Module, target: str, args: tuple[Any], kwargs: dict[str, Any] | None = None, normalize_to_only_use_kwargs: bool = False) -> ArgsKwargsPair | None: ...
