from .graph import Graph
from .graph_module import GraphModule
from .node import Node
from .passes.utils.matcher_with_name_node_map_utils import InternalMatch
from dataclasses import dataclass
from typing import Callable, NamedTuple

__all__ = ['Match', 'replace_pattern', 'replace_pattern_with_filters', 'ReplacedPatterns']

class Match(NamedTuple):
    anchor: Node
    nodes_map: dict[Node, Node]

@dataclass
class ReplacedPatterns:
    anchor: Node
    nodes_map: dict[Node, Node]
    replacements: list[Node]

def replace_pattern(gm: GraphModule, pattern: Callable | GraphModule, replacement: Callable | GraphModule) -> list[Match]: ...
def replace_pattern_with_filters(gm: GraphModule, pattern: Callable | Graph | GraphModule, replacement: Callable | Graph | GraphModule | None = None, match_filters: list[Callable[[InternalMatch, Graph, Graph], bool]] | None = None, ignore_literals: bool = False, replacement_callback: Callable[[InternalMatch, Graph, Graph], Graph] | None = None) -> list[ReplacedPatterns]: ...
