from .graph import Graph
from .node import Node
from _typeshed import Incomplete
from collections.abc import Generator
from enum import Enum
from typing import Any

__all__ = ['preserve_node_meta', 'has_preserved_node_meta', 'set_stack_trace', 'set_grad_fn_seq_nr', 'reset_grad_fn_seq_nr', 'format_stack', 'set_current_meta', 'get_current_meta', 'NodeSource', 'NodeSourceAction', 'get_graph_provenance_json']

class NodeSourceAction(str, Enum):
    CREATE = 'create'
    REPLACE = 'replace'

class NodeSource:
    class NodeInfo:
        name: Incomplete
        target: Incomplete
        graph_id: Incomplete
        def __init__(self, name: str, target: str, graph_id: int) -> None: ...
    pass_name: str
    action: NodeSourceAction | None
    from_node: list['NodeSource']
    node_info: NodeInfo | None
    def __init__(self, node: Node | None, pass_name: str = '', action: NodeSourceAction | None = None) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def target(self) -> str: ...
    @property
    def graph_id(self) -> int: ...
    def print_readable(self, indent: int = 0): ...
    def to_dict(self) -> dict: ...

def preserve_node_meta() -> Generator[None]: ...
def set_stack_trace(stack: list[str]): ...
def set_grad_fn_seq_nr(seq_nr) -> None: ...
def reset_grad_fn_seq_nr() -> None: ...
def format_stack() -> list[str]: ...
def has_preserved_node_meta() -> bool: ...
def set_current_meta(node, pass_name: str = '') -> Generator[None]: ...
def get_current_meta() -> dict[str, Any]: ...
def get_graph_provenance_json(graph: Graph) -> str: ...
