import torch
from ._serialization import validate_map_location as validate_map_location
from _typeshed import Incomplete
from torch._classes import classes as classes
from torch._utils_internal import log_torchscript_usage as log_torchscript_usage
from torch.jit._monkeytype_config import JitTypeTraceConfig as JitTypeTraceConfig, JitTypeTraceStore as JitTypeTraceStore, monkeytype_trace as monkeytype_trace
from torch.jit._recursive import ScriptMethodStub as ScriptMethodStub, infer_methods_to_compile as infer_methods_to_compile, wrap_cpp_module as wrap_cpp_module
from torch.jit.frontend import get_default_args as get_default_args, get_jit_class_def as get_jit_class_def, get_jit_def as get_jit_def
from torch.nn import Module as Module
from torch.overrides import has_torch_function as has_torch_function, has_torch_function_unary as has_torch_function_unary, has_torch_function_variadic as has_torch_function_variadic
from torch.package import PackageExporter as PackageExporter, PackageImporter as PackageImporter
from torch.utils import set_module as set_module
from typing import Any, Callable, NamedTuple

type_trace_db: Incomplete
ScriptFunction: Incomplete

class Attribute(NamedTuple):
    value: Incomplete
    type: Incomplete

def Attribute(value, type): ...

class OrderedDictWrapper:
    def __init__(self, _c) -> None: ...
    def keys(self): ...
    def values(self): ...
    def __len__(self) -> int: ...
    def __delitem__(self, k) -> None: ...
    def items(self): ...
    def __setitem__(self, k, v) -> None: ...
    def __contains__(self, k) -> bool: ...
    def __getitem__(self, k): ...

class OrderedModuleDict(OrderedDictWrapper):
    def __init__(self, module, python_dict) -> None: ...
    def items(self): ...
    def __contains__(self, k) -> bool: ...
    def __setitem__(self, k, v) -> None: ...
    def __getitem__(self, k): ...

class ScriptMeta(type):
    def __init__(cls, name, bases, attrs) -> None: ...

class _CachedForward:
    def __get__(self, obj, cls): ...

class ScriptWarning(Warning): ...

def script_method(fn): ...

class ConstMap:
    const_mapping: Incomplete
    def __init__(self, const_mapping) -> None: ...
    def __getattr__(self, attr): ...

def unpackage_script_module(importer: PackageImporter, script_module_id: str) -> torch.nn.Module: ...

class RecursiveScriptClass:
    def __init__(self, cpp_class) -> None: ...
    def __getattr__(self, attr): ...
    def __setattr__(self, attr, value): ...
    def forward_magic_method(self, method_name, *args, **kwargs): ...
    def __iadd__(self, other): ...

def method_template(self, *args, **kwargs): ...

class ScriptModule(Module, metaclass=ScriptMeta):
    __jit_unused_properties__: Incomplete
    def __init__(self) -> None: ...
    forward: Callable[..., Any]
    def __getattr__(self, attr): ...
    def __setattr__(self, attr, value): ...
    def define(self, src): ...
    def __reduce_package__(self, exporter: PackageExporter): ...

class RecursiveScriptModule(ScriptModule):
    def __init__(self, cpp_module) -> None: ...
    @property
    def graph(self): ...
    @property
    def inlined_graph(self): ...
    @property
    def code(self): ...
    @property
    def code_with_constants(self): ...
    def save(self, f, **kwargs): ...
    def save_to_buffer(self, *args, **kwargs): ...
    def get_debug_state(self, *args, **kwargs): ...
    def extra_repr(self): ...
    def graph_for(self, *args, **kwargs): ...
    @property
    def original_name(self): ...
    def define(self, src) -> None: ...
    def __getattr__(self, attr): ...
    def __setattr__(self, attr, value): ...
    def __copy__(self): ...
    def __deepcopy__(self, memo): ...
    def forward_magic_method(self, method_name, *args, **kwargs): ...
    def __iter__(self): ...
    def __getitem__(self, idx): ...
    def __len__(self) -> int: ...
    def __contains__(self, key) -> bool: ...
    def __dir__(self): ...
    def __bool__(self) -> bool: ...

class RecursiveScriptClass: ...

class ScriptModule(torch.nn.Module):
    def __init__(self, arg: Incomplete | None = None) -> None: ...

class RecursiveScriptModule(ScriptModule):
    def __init__(self, arg: Incomplete | None = None) -> None: ...

def call_prepare_scriptable_func_impl(obj, memo): ...
def call_prepare_scriptable_func(obj): ...
def create_script_dict(obj): ...
def create_script_list(obj, type_hint: Incomplete | None = None): ...
def script(obj, optimize: Incomplete | None = None, _frames_up: int = 0, _rcb: Incomplete | None = None, example_inputs: list[tuple] | dict[Callable, list[tuple]] | None = None): ...
def interface(obj): ...

CompilationUnit: Incomplete

def pad(s: str, padding: int, offset: int = 0, char: str = ' '): ...

class _ScriptProfileColumn:
    header: Incomplete
    alignment: Incomplete
    offset: Incomplete
    rows: dict[int, Any]
    def __init__(self, header: str, alignment: int = 4, offset: int = 0) -> None: ...
    def add_row(self, lineno: int, value: Any): ...
    def materialize(self): ...

class _ScriptProfileTable:
    cols: Incomplete
    source_range: Incomplete
    def __init__(self, cols: list[_ScriptProfileColumn], source_range: list[int]) -> None: ...
    def dump_string(self): ...

class _ScriptProfile:
    profile: Incomplete
    def __init__(self) -> None: ...
    def enable(self) -> None: ...
    def disable(self) -> None: ...
    def dump_string(self) -> str: ...
    def dump(self) -> None: ...
