import torch
from _typeshed import Incomplete
from enum import Enum
from torch._jit_internal import get_callable_argument_names as get_callable_argument_names, is_scripting as is_scripting
from torch.autograd import function as function
from torch.jit._script import ScriptModule as ScriptModule, script as script
from torch.nn import Module as Module
from torch.testing._comparison import default_tolerances as default_tolerances
from typing import Any, Callable, TypeVar
from typing_extensions import ParamSpec

R = TypeVar('R', covariant=True)
P = ParamSpec('P')

class ONNXTracedModule(torch.nn.Module):
    inner: Incomplete
    strict: Incomplete
    def __init__(self, inner, strict: bool = True, force_outplace: bool = False, return_inputs: bool = False, return_inputs_states: bool = False) -> None: ...
    def forward(self, *args: torch.Tensor): ...

def verify(model, args, loss_fn=..., devices: Incomplete | None = None): ...
def indent(s): ...

class TracingCheckError(Exception):
    message: str
    def __init__(self, graph_diff_error, tensor_compare_error, extra_msg: Incomplete | None = None) -> None: ...

class TracerWarning(Warning):
    @staticmethod
    def ignore_lib_warnings() -> None: ...

def make_tuple(example_inputs): ...
def make_module(mod, _module_class, _compilation_unit): ...
def wrap_check_inputs(check_inputs): ...
def analyze_ts_result_with_export_result(export, trace): ...

class _ExportType(str, Enum):
    DIRECT_EXPORT = 'DIRECT_EXPORT'
    TRACE_AND_EXPORT = 'TRACE_AND_EXPORT'
    SOURCE_TO_SOURCE = 'SOURCE_TO_SOURCE'

class _ExportOutcome(str, Enum):
    SUCCESS = 'SUCCESS'
    FAILED_TO_EXPORT = 'FAILED_TO_EXPORT'
    FAILED_TO_RUN = 'FAILED_TO_RUN'
    ACCURACY_ERROR = 'ACCURACY_ERROR'

def trace(func, example_inputs: Incomplete | None = None, optimize: Incomplete | None = None, check_trace: bool = True, check_inputs: Incomplete | None = None, check_tolerance: float = 1e-05, strict: bool = True, _force_outplace: bool = False, _module_class: Incomplete | None = None, _compilation_unit=..., example_kwarg_inputs: Incomplete | None = None, _store_inputs: bool = True): ...
def trace_module(mod, inputs, optimize: Incomplete | None = None, check_trace: bool = True, check_inputs: Incomplete | None = None, check_tolerance: float = 1e-05, strict: bool = True, _force_outplace: bool = False, _module_class: Incomplete | None = None, _compilation_unit=..., example_inputs_is_kwarg: bool = False, _store_inputs: bool = True): ...
def is_tracing(): ...

class TracedModule(ScriptModule):
    def __init__(self, orig, id_set: Incomplete | None = None, _compilation_unit: Incomplete | None = None) -> None: ...
    def forward(self, *args, **kwargs) -> None: ...
    def __getattr__(self, attr): ...
    def __setattr__(self, attr, value): ...
    def extra_repr(self): ...

class TopLevelTracedModule(TracedModule):
    forward: Callable[..., Any]
