import torch
from _typeshed import Incomplete
from torch._library.custom_ops import custom_op as custom_op
from torch._library.infer_schema import infer_schema as infer_schema
from torch._library.triton import triton_op as triton_op, wrap_triton as wrap_triton
from typing import Any, Callable

__all__ = ['Library', 'impl', 'define', 'fallthrough_kernel', 'impl_abstract', 'register_fake', 'register_torch_dispatch', 'register_vmap', 'get_ctx', 'custom_op', 'triton_op', 'wrap_triton', 'infer_schema']

def fallthrough_kernel() -> None: ...

class Library:
    m: Any | None
    ns: Incomplete
    kind: Incomplete
    dispatch_key: Incomplete
    def __init__(self, ns, kind, dispatch_key: str = '') -> None: ...
    def define(self, schema, alias_analysis: str = '', *, tags=()): ...
    def impl(self, op_name, fn, dispatch_key: str = '', *, with_keyset: bool = False) -> None: ...
    def fallback(self, fn, dispatch_key: str = '', *, with_keyset: bool = False) -> None: ...

def define(qualname, schema, *, lib: Incomplete | None = None, tags=()) -> None: ...
def impl(qualname, types, func: Incomplete | None = None, *, lib: Incomplete | None = None): ...
def impl_abstract(qualname, func: Incomplete | None = None, *, lib: Incomplete | None = None, _stacklevel: int = 1): ...
def register_fake(op: _op_identifier, func: Callable | None = None, /, *, lib: Library | None = None, _stacklevel: int = 1): ...
def register_torch_dispatch(op: _op_identifier, torch_dispatch_class: Any, func: Callable | None = None, /, *, lib: Library | None = None): ...
def register_vmap(op: _op_identifier, func: Callable | None = None, /, *, lib: Incomplete | None = None): ...
def get_ctx() -> torch._library.fake_impl.FakeImplCtx: ...
