from torch import Tensor
from torch.masked.maskedtensor.core import MaskedTensor
from torch.types import _dtype as DType

__all__ = ['sum', 'prod', 'cumsum', 'cumprod', 'amax', 'amin', 'argmax', 'argmin', 'mean', 'median', 'logsumexp', 'norm', 'var', 'std', 'softmax', 'log_softmax', 'softmin', 'normalize']

DimOrDims = int | tuple[int] | list[int] | None

def sum(input: Tensor | MaskedTensor, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def prod(input: Tensor | MaskedTensor, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def cumsum(input: Tensor, dim: int, *, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def cumprod(input: Tensor, dim: int, *, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def amax(input: Tensor | MaskedTensor, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def amin(input: Tensor | MaskedTensor, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def argmax(input: Tensor | MaskedTensor, dim: int | None = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def argmin(input: Tensor | MaskedTensor, dim: int | None = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def mean(input: Tensor | MaskedTensor, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def median(input: Tensor | MaskedTensor, dim: int = -1, *, keepdim: bool = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def logsumexp(input: Tensor, dim: DimOrDims = None, *, keepdim: bool = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def norm(input: Tensor | MaskedTensor, ord: float | None = 2.0, dim: DimOrDims = None, *, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def var(input: Tensor | MaskedTensor, dim: DimOrDims = None, unbiased: bool | None = None, *, correction: int | float | None = None, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def std(input: Tensor | MaskedTensor, dim: DimOrDims = None, unbiased: bool | None = None, *, correction: int | None = None, keepdim: bool | None = False, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def softmax(input: Tensor | MaskedTensor, dim: int, *, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def log_softmax(input: Tensor | MaskedTensor, dim: int, *, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def softmin(input: Tensor | MaskedTensor, dim: int, *, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
def normalize(input: Tensor | MaskedTensor, ord: float, dim: int, *, eps: float = 1e-12, dtype: DType | None = None, mask: Tensor | None = None) -> Tensor: ...
