from .memory import *
import torch
from _typeshed import Incomplete
from torch import Tensor
from typing import Any

__all__ = ['init', 'is_available', 'is_initialized', 'synchronize', 'device_count', 'current_device', 'current_stream', 'default_stream', 'memory_stats', 'max_memory_allocated', 'get_device_capability', 'empty_cache', 'set_device', 'set_stream', 'stream', 'device', 'set_rng_state', 'get_rng_state']

def init() -> None: ...
def is_initialized(): ...

class DeferredMtiaCallError(Exception): ...

def is_available() -> bool: ...
def synchronize(device: _device_t | None = None) -> None: ...
def device_count() -> int: ...
def current_device() -> int: ...
def current_stream(device: _device_t | None = None) -> Stream: ...
def default_stream(device: _device_t | None = None) -> Stream: ...
def get_device_capability(device: _device_t | None = None) -> tuple[int, int]: ...
def empty_cache() -> None: ...
def set_stream(stream: Stream): ...
def set_device(device: _device_t) -> None: ...

class device:
    idx: Incomplete
    prev_idx: int
    def __init__(self, device: Any) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, type: Any, value: Any, traceback: Any): ...

class StreamContext:
    cur_stream: torch.mtia.Stream | None
    stream: Incomplete
    idx: Incomplete
    src_prev_stream: Incomplete
    dst_prev_stream: Incomplete
    def __init__(self, stream: torch.mtia.Stream | None) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, type: Any, value: Any, traceback: Any): ...

def stream(stream: torch.mtia.Stream | None) -> StreamContext: ...
def get_rng_state(device: int | str | torch.device = 'mtia') -> Tensor: ...
def set_rng_state(new_state: Tensor, device: int | str | torch.device = 'mtia') -> None: ...

# Names in __all__ with no definition:
#   max_memory_allocated
#   memory_stats
