from _typeshed import Incomplete

__all__ = ['ProcessContext', 'ProcessException', 'ProcessExitedException', 'ProcessRaisedException', 'spawn', 'SpawnContext', 'start_processes']

class ProcessException(Exception):
    msg: Incomplete
    error_index: Incomplete
    pid: Incomplete
    def __init__(self, msg: str, error_index: int, pid: int) -> None: ...
    def __reduce__(self): ...

class ProcessRaisedException(ProcessException):
    def __init__(self, msg: str, error_index: int, error_pid: int) -> None: ...

class ProcessExitedException(ProcessException):
    exit_code: Incomplete
    signal_name: Incomplete
    def __init__(self, msg: str, error_index: int, error_pid: int, exit_code: int, signal_name: str | None = None) -> None: ...
    def __reduce__(self): ...

class ProcessContext:
    error_files: Incomplete
    processes: Incomplete
    sentinels: Incomplete
    def __init__(self, processes, error_files) -> None: ...
    def pids(self): ...
    def join(self, timeout: float | None = None, grace_period: float | None = None): ...

class SpawnContext(ProcessContext):
    def __init__(self, processes, error_files) -> None: ...

def start_processes(fn, args=(), nprocs: int = 1, join: bool = True, daemon: bool = False, start_method: str = 'spawn'): ...
def spawn(fn, args=(), nprocs: int = 1, join: bool = True, daemon: bool = False, start_method: str = 'spawn'): ...
